import { computed as p, ref as v, watch as ce, onMounted as de, onBeforeUnmount as Xe, openBlock as o, createElementBlock as r, normalizeClass as ve, normalizeStyle as H, createBlock as L, createCommentVNode as b, unref as d, createSlots as Se, withCtx as _, renderSlot as k, normalizeProps as W, guardReactiveProps as R, createVNode as Ne, Fragment as w, renderList as $, createElementVNode as n, toDisplayString as A, createTextVNode as he, nextTick as Pe } from "vue";
import { u as Te, c as ye, t as Ge, o as De, e as be, g as Ie, v as fe, C as Me, f as z, X as ge, i as B, l as me, h as pe, q as Fe, r as Oe } from "./index-Bya_q1J-.js";
import { t as Ve, u as Ee } from "./useResponsive-BY8tgM1n.js";
import { _ as He } from "./Title-C5pIfQAz.js";
import { u as We, U as Re } from "./usePrinter-CiHd1FwD.js";
import { D as Be } from "./DataTable-DYqC2pqu.js";
import Ue from "./vue-ui-skeleton-BYssP0K4.js";
import { L as je } from "./Legend-DNgTCgEK.js";
import qe from "./vue-ui-accordion-DfUfL2dI.js";
import { u as _e } from "./useNestedProp-B33hazbH.js";
import { _ as Ye } from "./PackageVersion-VkaUzgmt.js";
import { P as Ze } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Je } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ke = ["id"], Qe = ["xmlns", "viewBox"], et = { key: 0 }, tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], lt = { key: 1 }, at = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], st = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ot = { key: 2 }, rt = ["x", "y", "font-size", "fill", "font-weight"], nt = ["x", "y", "font-size", "fill"], ut = { key: 3 }, it = ["x", "y", "font-size", "fill", "font-weight"], ct = ["id"], dt = ["stop-color"], vt = ["stop-color"], ht = ["stop-color"], yt = ["id"], bt = ["stop-color"], ft = ["stop-color"], gt = ["stop-color"], mt = ["id"], pt = ["stop-color"], _t = ["stop-color"], kt = ["id"], xt = ["stop-color"], Ct = ["stop-color"], wt = { key: 0 }, $t = ["d", "fill"], Lt = { key: 1 }, At = ["x", "y", "height", "width", "fill"], zt = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Xt = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], St = { key: 2 }, Nt = ["x", "y", "fill", "font-size"], Pt = { key: 3 }, Tt = ["x", "y", "fill", "font-size"], Gt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Dt = ["xmlns", "height", "width"], It = ["fill"], Mt = ["innerHTML"], Ft = {
  __name: "vue-ui-dumbbell",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(ke, { expose: xe, emit: Ot }) {
    const m = ke, { vue_ui_dumbbell: Ce } = Te(), X = p({
      get() {
        return !!m.dataset && m.dataset.length;
      },
      set(l) {
        return l;
      }
    }), y = v(ye()), U = v(0), S = v(null), j = v(null), q = v(null), Y = v(null), Z = v(0), J = v(0), K = v(0), e = p({
      get: () => Q(),
      set: (l) => l
    });
    function Q() {
      const l = _e({
        userConfig: m.config,
        defaultConfig: Ce
      });
      return l.theme ? {
        ..._e({
          userConfig: Ge.vue_ui_dumbbell[l.theme] || m.config,
          defaultConfig: l
        })
      } : l;
    }
    ce(() => m.config, (l) => {
      e.value = Q(), ee(), Z.value += 1, J.value += 1, K.value += 1, h.value = e.value.style.chart.rowHeight, N.value = e.value.style.chart.width;
    }, { deep: !0 }), ce(() => m.dataset, (l) => {
      re();
    }, { deep: !0 });
    const T = v(null);
    de(() => {
      ee();
    });
    function ee() {
      if (De(m.dataset) ? be({
        componentName: "VueUiDumbbell",
        type: "dataset"
      }) : m.dataset.forEach((l, u) => {
        Ie({
          datasetObject: l,
          requiredAttributes: ["name", "start", "end"]
        }).forEach((t) => {
          X.value = !1, be({
            componentName: "VueUiDumbbell",
            type: "datasetSerieAttribute",
            property: t,
            index: u
          });
        });
      }), e.value.responsive) {
        const l = Ve(() => {
          const { width: u, height: t } = Ee({
            chart: S.value,
            title: e.value.style.chart.title.text ? j.value : null,
            legend: e.value.style.chart.legend.show ? q.value : null,
            source: Y.value
          });
          N.value = u, h.value = t / m.dataset.length, f.value = D();
        });
        T.value = new ResizeObserver(l), T.value.observe(S.value.parentNode);
      }
    }
    Xe(() => {
      T.value && T.value.disconnect();
    });
    const { isPrinting: te, isImaging: le, generatePdf: ae, generateImage: se } = We({
      elementId: `dumbbell_${y.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-dumbbell"
    }), G = v({
      showTable: e.value.table.show
    }), x = p(() => m.dataset.map((l, u) => ({
      ...l,
      start: fe(l.start),
      end: fe(l.end),
      id: ye()
    }))), O = p(() => ({
      max: Math.max(...x.value.flatMap((l) => [l.start, l.end])),
      min: Math.min(...x.value.flatMap((l) => [l.start, l.end]))
    })), c = p(() => Me(O.value.min < 0 ? O.value.min : 0, O.value.max, e.value.style.chart.grid.scaleSteps)), h = v(e.value.style.chart.rowHeight), N = v(e.value.style.chart.width), s = p(() => {
      const l = h.value, u = e.value.style.chart.padding.left + e.value.style.chart.padding.right + N.value, t = e.value.style.chart.padding.top + e.value.style.chart.padding.bottom + l * m.dataset.length, a = c.value.ticks.length * (N.value / c.value.ticks.length);
      return {
        left: e.value.style.chart.padding.left,
        right: u - e.value.style.chart.padding.right,
        top: e.value.style.chart.padding.top,
        bottom: t - e.value.style.chart.padding.bottom,
        width: N.value,
        height: l * m.dataset.length,
        rowHeight: l,
        absoluteHeight: t,
        absoluteWidth: u,
        widthPlotReference: a
      };
    });
    function D() {
      return x.value.map((l, u) => {
        const t = s.value.left + (l.start + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, a = s.value.left + (l.end + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, i = t + (a - t) / 2;
        return {
          ...l,
          startX: t,
          endX: a,
          centerX: i,
          y: s.value.top + u * h.value + h.value / 2,
          endVal: l.start
        };
      });
    }
    const f = v([]), oe = v(null), we = p(() => x.value.map((l) => l.end).reduce((l, u) => l + u, 0));
    de(() => {
      re();
    });
    function re() {
      f.value = D();
      let l = f.value.map((t) => t.start).reduce((t, a) => t + a, 0);
      function u() {
        const t = x.value.map((a) => a.end - a.start);
        l >= we.value ? (cancelAnimationFrame(oe.value), f.value = D()) : (f.value = f.value.map((a, i) => {
          a.endVal += t[i] * (e.value.animationSpeed / 100);
          const g = s.value.left + (a.start + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, F = s.value.left + (a.endVal + Math.abs(c.value.min)) / (c.value.max + Math.abs(c.value.min)) * s.value.widthPlotReference, E = g + (F - g) / 2;
          return {
            ...a,
            startX: g,
            endX: F,
            centerX: E,
            y: s.value.top + i * h.value + h.value / 2,
            endVal: a.endVal
          };
        }), l = f.value.map((a) => a.endVal).reduce((a, i) => a + i, 0), oe.value = requestAnimationFrame(u));
      }
      e.value.useAnimation ? u() : f.value = D();
    }
    const ne = p(() => [
      { name: e.value.style.chart.legend.labelStart, color: e.value.style.chart.plots.gradient.show ? `url(#start_grad_${y.value})` : e.value.style.chart.plots.startColor },
      { name: e.value.style.chart.legend.labelEnd, color: e.value.style.chart.plots.gradient.show ? `url(#end_grad_${y.value})` : e.value.style.chart.plots.endColor }
    ]), $e = p(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      paddingTop: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), C = p(() => {
      const l = f.value.map((t) => ({
        name: t.name
      })), u = f.value.map((t) => ({
        start: t.start,
        end: t.end
      }));
      return { head: l, body: u };
    }), I = p(() => {
      const l = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.start,
        e.value.table.columnNames.end,
        e.value.table.columnNames.progression
      ], u = C.value.head.map((i, g) => {
        const F = z({
          p: e.value.style.chart.labels.prefix,
          v: C.value.body[g].start,
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        }), E = z({
          p: e.value.style.chart.labels.prefix,
          v: C.value.body[g].end,
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        }), ze = z({
          v: 100 * (C.value.body[g].end / C.value.body[g].start - 1),
          s: "%",
          r: e.value.table.td.roundingPercentage
        });
        return [
          { name: i.name },
          F,
          E,
          ze
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.start,
          e.value.table.columnNames.end,
          e.value.table.columnNames.progression
        ],
        head: l,
        body: u,
        config: t
      };
    });
    function ue() {
      Pe(() => {
        const l = C.value.head.map((a, i) => [[
          a.name
        ], [C.value.body[i].start], [C.value.body[i].end]]), u = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[e.value.table.columnNames.series], [e.value.table.columnNames.start], [e.value.table.columnNames.end]]].concat(l), t = Fe(u);
        Oe({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-dumbbell" });
      });
    }
    const P = v(!1);
    function Le(l) {
      P.value = l, U.value += 1;
    }
    function Ae() {
      return f.value;
    }
    function ie() {
      G.value.showTable = !G.value.showTable;
    }
    const M = v(!1);
    function V() {
      M.value = !M.value;
    }
    return xe({
      getData: Ae,
      generatePdf: ae,
      generateCsv: ue,
      generateImage: se,
      toggleTable: ie,
      toggleAnnotator: V
    }), (l, u) => (o(), r("div", {
      ref_key: "dumbbellChart",
      ref: S,
      class: ve(`vue-ui-dumbbell ${P.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: H(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `dumbbell_${y.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (o(), L(Ze, {
        key: 0,
        parent: S.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: M.value,
        onClose: V
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : b("", !0),
      e.value.style.chart.title.text ? (o(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: j,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), L(He, {
          key: `title_${Z.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : b("", !0),
      e.value.userOptions.show && X.value ? (o(), L(Re, {
        ref: "details",
        key: `user_option_${U.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(te),
        isImaging: d(le),
        uid: y.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: P.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: S.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: M.value,
        onToggleFullscreen: Le,
        onGeneratePdf: d(ae),
        onGenerateCsv: ue,
        onGenerateImage: d(se),
        onToggleTable: ie,
        onToggleAnnotator: V
      }, Se({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            k(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            k(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            k(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            k(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: t, isFullscreen: a }) => [
            k(l.$slots, "optionFullscreen", W(R({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: t, isAnnotator: a }) => [
            k(l.$slots, "optionAnnotator", W(R({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : b("", !0),
      X.value ? (o(), r("svg", {
        key: 3,
        xmlns: d(ge),
        class: ve({ "vue-data-ui-fullscreen--on": P.value, "vue-data-ui-fulscreen--off": !P.value }),
        viewBox: `0 0 ${s.value.absoluteWidth <= 0 ? 10 : s.value.absoluteWidth} ${s.value.absoluteHeight <= 0 ? 10 : s.value.absoluteHeight}`,
        style: H(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Ne(Ye),
        e.value.style.chart.grid.verticalGrid.show ? (o(), r("g", et, [
          (o(!0), r(w, null, $(c.value.ticks, (t, a) => (o(), r("line", {
            x1: s.value.left + a * s.value.width / (c.value.ticks.length - 1),
            x2: s.value.left + a * s.value.width / (c.value.ticks.length - 1),
            y1: s.value.top,
            y2: s.value.bottom,
            stroke: e.value.style.chart.grid.verticalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.verticalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.verticalGrid.strokeDasharray
          }, null, 8, tt))), 256))
        ])) : b("", !0),
        e.value.style.chart.grid.horizontalGrid.show ? (o(), r("g", lt, [
          (o(!0), r(w, null, $(x.value, (t, a) => (o(), r("line", {
            x1: s.value.left,
            x2: s.value.right,
            y1: s.value.top + a * h.value,
            y2: s.value.top + a * h.value,
            stroke: e.value.style.chart.grid.horizontalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray
          }, null, 8, at))), 256)),
          n("line", {
            x1: s.value.left,
            x2: s.value.right,
            y1: s.value.bottom,
            y2: s.value.bottom,
            stroke: e.value.style.chart.grid.horizontalGrid.stroke,
            "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
            "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray
          }, null, 8, st)
        ])) : b("", !0),
        e.value.style.chart.labels.yAxisLabels.show ? (o(), r("g", ot, [
          (o(!0), r(w, null, $(x.value, (t, a) => (o(), r("text", {
            x: s.value.left - 6 + e.value.style.chart.labels.yAxisLabels.offsetX,
            y: s.value.top + a * h.value + (e.value.style.chart.labels.yAxisLabels.showProgression ? h.value / 3 : h.value / 2) + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
            "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
            fill: e.value.style.chart.labels.yAxisLabels.color,
            "font-weight": e.value.style.chart.labels.yAxisLabels.bold ? "bold" : "normal",
            "text-anchor": "end"
          }, A(t.name), 9, rt))), 256)),
          e.value.style.chart.labels.yAxisLabels.showProgression ? (o(!0), r(w, { key: 0 }, $(x.value, (t, a) => (o(), r("text", {
            x: s.value.left - 6 + e.value.style.chart.labels.yAxisLabels.offsetX,
            y: s.value.top + a * h.value + h.value / 1.3 + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
            "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
            fill: e.value.style.chart.labels.yAxisLabels.color,
            "text-anchor": "end"
          }, A(d(z)({
            v: 100 * (t.end / t.start - 1),
            s: "%",
            r: e.value.style.chart.labels.yAxisLabels.rounding
          })), 9, nt))), 256)) : b("", !0)
        ])) : b("", !0),
        e.value.style.chart.labels.xAxisLabels.show ? (o(), r("g", ut, [
          (o(!0), r(w, null, $(c.value.ticks, (t, a) => (o(), r("text", {
            x: s.value.left + a * (s.value.width / (c.value.ticks.length - 1)),
            y: s.value.bottom + e.value.style.chart.labels.xAxisLabels.fontSize + e.value.style.chart.labels.xAxisLabels.offsetY,
            "font-size": e.value.style.chart.labels.xAxisLabels.fontSize,
            fill: e.value.style.chart.labels.xAxisLabels.color,
            "font-weight": e.value.style.chart.labels.xAxisLabels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, A(d(B)(
            e.value.style.chart.labels.formatter,
            t,
            d(z)({
              p: e.value.style.chart.labels.prefix,
              v: t,
              s: e.value.style.chart.labels.suffix,
              r: e.value.style.chart.labels.xAxisLabels.rounding
            }),
            { datapoint: t, seriesIndex: a }
          )), 9, it))), 256))
        ])) : b("", !0),
        n("defs", null, [
          n("radialGradient", {
            id: `start_grad_${y.value}`,
            fy: "30%"
          }, [
            n("stop", {
              offset: "10%",
              "stop-color": d(me)(e.value.style.chart.plots.startColor, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, dt),
            n("stop", {
              offset: "90%",
              "stop-color": d(pe)(e.value.style.chart.plots.startColor, 0.1)
            }, null, 8, vt),
            n("stop", {
              offset: "100%",
              "stop-color": e.value.style.chart.plots.startColor
            }, null, 8, ht)
          ], 8, ct),
          n("radialGradient", {
            id: `end_grad_${y.value}`,
            fy: "30%"
          }, [
            n("stop", {
              offset: "10%",
              "stop-color": d(me)(e.value.style.chart.plots.endColor, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, bt),
            n("stop", {
              offset: "90%",
              "stop-color": d(pe)(e.value.style.chart.plots.endColor, 0.1)
            }, null, 8, ft),
            n("stop", {
              offset: "100%",
              "stop-color": e.value.style.chart.plots.endColor
            }, null, 8, gt)
          ], 8, yt)
        ]),
        (o(!0), r(w, null, $(f.value, (t, a) => (o(), r("g", null, [
          n("defs", null, [
            n("linearGradient", {
              id: `grad_positive_${y.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.chart.plots.startColor
              }, null, 8, pt),
              n("stop", {
                offset: "100%",
                "stop-color": e.value.style.chart.plots.endColor
              }, null, 8, _t)
            ], 8, mt),
            n("linearGradient", {
              id: `grad_negative_${y.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              n("stop", {
                offset: "0%",
                "stop-color": e.value.style.chart.plots.endColor
              }, null, 8, xt),
              n("stop", {
                offset: "100%",
                "stop-color": e.value.style.chart.plots.startColor
              }, null, 8, Ct)
            ], 8, kt)
          ]),
          e.value.style.chart.plots.link.type === "curved" ? (o(), r("g", wt, [
            n("path", {
              d: `M 
                            ${t.startX},${t.y + e.value.style.chart.plots.radius / 2} 
                            C ${t.centerX},${t.y} ${t.centerX},${t.y} 
                            ${t.endX},${t.y + e.value.style.chart.plots.radius / 2}
                            L ${t.endX},${t.y - e.value.style.chart.plots.radius / 2}
                            C ${t.centerX},${t.y} ${t.centerX},${t.y}
                            ${t.startX},${t.y - e.value.style.chart.plots.radius / 2}
                            Z
                        `,
              fill: t.endX > t.startX ? `url(#grad_positive_${y.value})` : `url(#grad_negative_${y.value})`
            }, null, 8, $t)
          ])) : (o(), r("g", Lt, [
            n("rect", {
              x: t.endX > t.startX ? t.startX : t.endX,
              y: t.y - e.value.style.chart.plots.link.strokeWidth / 2,
              height: e.value.style.chart.plots.link.strokeWidth,
              width: Math.abs(t.endX - t.startX),
              fill: t.endX > t.startX ? `url(#grad_positive_${y.value})` : `url(#grad_negative_${y.value})`
            }, null, 8, At)
          ])),
          n("circle", {
            cx: t.startX,
            cy: t.y,
            r: e.value.style.chart.plots.radius,
            fill: e.value.style.chart.plots.gradient.show ? `url(#start_grad_${y.value})` : e.value.style.chart.plots.startColor,
            stroke: e.value.style.chart.plots.stroke,
            "stroke-width": e.value.style.chart.plots.strokeWidth
          }, null, 8, zt),
          n("circle", {
            cx: t.endX,
            cy: t.y,
            r: e.value.style.chart.plots.radius,
            fill: e.value.style.chart.plots.gradient.show ? `url(#end_grad_${y.value})` : e.value.style.chart.plots.endColor,
            stroke: e.value.style.chart.plots.stroke,
            "stroke-width": e.value.style.chart.plots.strokeWidth
          }, null, 8, Xt),
          e.value.style.chart.labels.startLabels.show ? (o(), r("g", St, [
            (o(!0), r(w, null, $(f.value, (i, g) => (o(), r("text", {
              x: i.startX,
              y: s.value.top + (g + 1) * h.value - e.value.style.chart.labels.startLabels.fontSize / 3 + e.value.style.chart.labels.startLabels.offsetY,
              fill: e.value.style.chart.labels.startLabels.useStartColor ? e.value.style.chart.plots.startColor : e.value.style.chart.labels.startLabels.color,
              "font-size": e.value.style.chart.labels.startLabels.fontSize,
              "text-anchor": "middle"
            }, A(d(B)(
              e.value.style.chart.labels.formatter,
              i.start,
              d(z)({
                p: e.value.style.chart.labels.prefix,
                v: i.start,
                s: e.value.style.chart.labels.suffix,
                r: e.value.style.chart.labels.startLabels.rounding
              }),
              { datapoint: i, seriesIndex: g }
            )), 9, Nt))), 256))
          ])) : b("", !0),
          e.value.style.chart.labels.endLabels.show ? (o(), r("g", Pt, [
            (o(!0), r(w, null, $(f.value, (i, g) => (o(), r("text", {
              x: i.endX,
              y: s.value.top + g * h.value + e.value.style.chart.labels.endLabels.fontSize + e.value.style.chart.labels.endLabels.offsetY,
              fill: e.value.style.chart.labels.endLabels.useEndColor ? e.value.style.chart.plots.endColor : e.value.style.chart.labels.endLabels.color,
              "font-size": e.value.style.chart.labels.endLabels.fontSize,
              "text-anchor": "middle"
            }, A(d(B)(
              e.value.style.chart.labels.formatter,
              i.end,
              d(z)({
                p: e.value.style.chart.labels.prefix,
                v: i.end,
                s: e.value.style.chart.labels.suffix,
                r: e.value.style.chart.labels.endLabels.rounding
              }),
              { datapoint: i, seriesIndex: g }
            )), 9, Tt))), 256))
          ])) : b("", !0)
        ]))), 256)),
        k(l.$slots, "svg", { svg: s.value }, void 0, !0)
      ], 14, Qe)) : b("", !0),
      l.$slots.watermark ? (o(), r("div", Gt, [
        k(l.$slots, "watermark", W(R({ isPrinting: d(te) || d(le) })), void 0, !0)
      ])) : b("", !0),
      X.value ? b("", !0) : (o(), L(Ue, {
        key: 5,
        config: {
          type: "dumbbell",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            dumbbell: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      n("div", {
        ref_key: "chartLegend",
        ref: q
      }, [
        e.value.style.chart.legend.show && X.value ? (o(), L(je, {
          key: `legend_${K.value}`,
          legendSet: ne.value,
          config: $e.value
        }, {
          item: _(({ legend: t }) => [
            n("div", {
              style: H(`display:flex;align-items:center;gap:4px;font-size:${e.value.style.chart.legend.fontSize}px`)
            }, [
              (o(), r("svg", {
                xmlns: d(ge),
                viewBox: "0 0 20 20",
                height: e.value.style.chart.legend.fontSize,
                width: e.value.style.chart.legend.fontSize
              }, [
                n("circle", {
                  cx: 10,
                  cy: 10,
                  r: 9,
                  fill: t.color
                }, null, 8, It)
              ], 8, Dt)),
              he(" " + A(t.name), 1)
            ], 4)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : k(l.$slots, "legend", {
          key: 1,
          legend: ne.value
        }, void 0, !0)
      ], 512),
      l.$slots.source ? (o(), r("div", {
        key: 6,
        ref_key: "source",
        ref: Y,
        dir: "auto"
      }, [
        k(l.$slots, "source", {}, void 0, !0)
      ], 512)) : b("", !0),
      X.value ? (o(), L(qe, {
        key: 7,
        hideDetails: "",
        config: {
          open: G.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: _(() => [
          (o(), L(Be, {
            key: `table_${J.value}`,
            colNames: I.value.colNames,
            head: I.value.head,
            body: I.value.body,
            config: I.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: u[0] || (u[0] = (t) => G.value.showTable = !1)
          }, {
            th: _(({ th: t }) => [
              n("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Mt)
            ]),
            td: _(({ td: t }) => [
              he(A(t.name || t), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : b("", !0)
    ], 14, Ke));
  }
}, Qt = /* @__PURE__ */ Je(Ft, [["__scopeId", "data-v-10dae78c"]]);
export {
  Qt as default
};
