import { computed as m, onMounted as He, ref as b, watch as Ee, openBlock as u, createElementBlock as v, normalizeClass as he, normalizeStyle as N, createBlock as P, createCommentVNode as $, unref as i, createSlots as Se, withCtx as y, renderSlot as k, normalizeProps as X, guardReactiveProps as W, createVNode as me, createElementVNode as S, Fragment as F, renderList as I, toDisplayString as q, createTextVNode as Me, nextTick as ze } from "vue";
import { u as Ye, o as De, e as Ge, c as ge, t as Be, a as Ue, p as K, b as Ve, v as f, f as pe, X as je, F as be, K as Xe, i as We, q as qe, r as Ke } from "./index-Bya_q1J-.js";
import { _ as Re } from "./Title-C5pIfQAz.js";
import { u as Ze, U as Je } from "./usePrinter-CiHd1FwD.js";
import { D as Qe } from "./DataTable-DYqC2pqu.js";
import et from "./vue-ui-accordion-DfUfL2dI.js";
import tt from "./vue-ui-skeleton-BYssP0K4.js";
import { u as ye } from "./useNestedProp-B33hazbH.js";
import { _ as ot } from "./PackageVersion-VkaUzgmt.js";
import { P as lt } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as at } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const nt = ["id"], st = {
  key: 1,
  style: "width:100%;background:transparent;padding-bottom:24px"
}, rt = ["xmlns", "viewBox"], ut = ["id"], it = ["stop-color"], ct = ["stop-color"], dt = ["d", "fill", "stroke", "stroke-width"], vt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "onMouseenter"], ft = ["x", "y", "font-size", "fill"], ht = ["x", "y", "font-size", "fill"], mt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, gt = {
  key: 5,
  ref: "source",
  dir: "auto"
}, pt = ["innerHTML"], bt = {
  __name: "vue-ui-flow",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(ke, { expose: we }) {
    const g = ke, { vue_ui_flow: Ce } = Ye(), M = m(() => !!g.dataset && g.dataset.length);
    He(() => {
      R();
    });
    function R() {
      De(g.dataset) && Ge({
        componentName: "VueUiFlow",
        type: "dataset"
      });
    }
    const z = b(ge()), Y = b(null), Z = b(0), J = b(0), T = b(!1);
    function $e(t) {
      T.value = t, Z.value += 1;
    }
    const e = m({
      get: () => Q(),
      set: (t) => t
    });
    function Q() {
      const t = ye({
        userConfig: g.config,
        defaultConfig: Ce
      });
      return t.theme ? {
        ...ye({
          userConfig: Be.vue_ui_flow[t.theme] || g.config,
          defaultConfig: t
        }),
        customPalette: Ue[t.theme] || K
      } : t;
    }
    Ee(() => g.config, (t) => {
      e.value = Q(), R(), J.value += 1;
    }, { deep: !0 });
    const { isPrinting: ee, isImaging: te, generatePdf: oe, generateImage: le } = Ze({
      elementId: `flow_${z.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-flow"
    }), D = m(() => Ve(e.value.customPalette)), ae = m(() => e.value.style.chart.nodes.gap), x = m(() => e.value.style.chart.nodes.width), O = b({
      showTable: e.value.table.show
    }), ne = m(() => e.value.style.chart.links.width), G = m(() => !g.dataset || !g.dataset.length ? [] : g.dataset.map((t) => [
      t[0],
      t[1],
      f(t[2])
    ])), se = m(() => {
      const t = {};
      function l(n) {
        t[n] || (t[n] = { inflow: 0, outflow: 0 });
      }
      G.value.forEach(([n, a, c]) => {
        l(n), l(a), t[n].outflow += c, t[a].inflow += c;
      });
      let o = 0;
      for (const n in t) {
        const a = Math.max(t[n].inflow, t[n].outflow);
        o = Math.max(o, a);
      }
      return o;
    });
    function xe(t) {
      return t / se.value * 100 + e.value.style.chart.nodes.minHeight;
    }
    function _e(t) {
      const l = e.value.style.chart.nodes.minHeight;
      return (t - l) / 100 * se.value;
    }
    function Ne(t) {
      const l = {}, o = {};
      function n(s, r) {
        l[s] || (l[s] = { height: 0, level: null, inflow: 0, outflow: 0 }), l[s].level === null && (l[s].level = r), o[r] || (o[r] = []), o[r].includes(s) || o[r].push(s);
      }
      t.forEach(([s, r, h], _) => {
        const C = l[s] ? l[s].level : 0, E = C + 1;
        n(s, C), n(r, E), l[s].children || (l[s].children = []), l[s].children.push({ target: r, value: h }), l[s].outflow += h, l[r].inflow += h;
      }), Object.keys(l).forEach((s, r) => {
        l[s].color = D.value[r] || D.value[r % D.value.length] || K[r] || K[r % d.length];
      });
      for (const s in l)
        l[s].height = xe(Math.max(l[s].inflow, l[s].outflow)), l[s].name = s;
      const a = {};
      for (const s in o) {
        let r = 0;
        o[s].forEach((h, _) => {
          const C = l[h].height;
          a[h] = {
            x: parseInt(s, 10) * ne.value + e.value.style.chart.padding.left,
            y: r,
            absoluteY: r,
            height: C,
            i: _,
            color: l[h].color,
            value: _e(C)
          }, r += C + ae.value;
        });
      }
      const c = [];
      for (const s in l) {
        let r = a[s].absoluteY;
        l[s].children && l[s].children.forEach(({ target: h, value: _ }, C) => {
          const E = a[h].y, V = a[s], j = a[h], ce = f(r), de = f(r + _ / l[s].outflow * V.height), ve = f(E), fe = f(E + _ / l[h].inflow * j.height), Le = {
            id: ge(),
            source: s,
            target: h,
            path: `M ${f(V.x) + f(x.value)} ${ce} L ${f(V.x) + f(x.value)} ${de} L ${f(j.x)} ${fe} L ${f(j.x)} ${ve} Z`,
            value: _,
            sourceColor: l[s].color,
            targetColor: l[h].color
          };
          c.push(Le), r += de - ce, a[h].y += fe - ve;
        });
      }
      return { nodeCoordinates: a, links: c };
    }
    const p = m(() => {
      const t = Ne(g.dataset);
      return {
        nodes: Object.keys(t.nodeCoordinates).map((l, o) => ({
          ...t.nodeCoordinates[l],
          name: l
        })),
        links: t.links
      };
    }), Te = m(() => Pe(p.value.nodes));
    function Pe(t) {
      const l = {};
      for (const n in t) {
        const { x: a, height: c } = t[n];
        l[a] || (l[a] = 0), l[a] += c + ae.value;
      }
      return Math.max(...Object.values(l));
    }
    const B = m(() => {
      const { top: t, right: l, left: o, bottom: n } = e.value.style.chart.padding, a = G.value.length * ne.value;
      return {
        height: Te.value + t + n,
        width: l + Math.max(...p.value.nodes.map((c) => c.x)) + x.value,
        left: o,
        top: t,
        right: a - l,
        p_top: t,
        p_bottom: n
      };
    });
    function Fe(t) {
      const l = {}, o = {}, n = /* @__PURE__ */ new Set();
      return G.value.forEach(([a, c, s]) => {
        l[a] || (l[a] = []), o[c] || (o[c] = []), l[a].push(c), o[c].push(a);
      }), l[t] && l[t].forEach((a) => n.add(a)), o[t] && o[t].forEach((a) => n.add(a)), Array.from(n).concat(t);
    }
    const w = b(null), A = b(null);
    function Ie(t) {
      w.value = Fe(t.name), A.value = t.name;
    }
    function Oe() {
      w.value = null, A.value = null;
    }
    const re = m(() => p.value.links.map(({ source: t, target: l, sourceColor: o, targetColor: n, value: a }) => ({
      source: t,
      target: l,
      sourceColor: o,
      targetColor: n,
      value: a
    })));
    function ue() {
      ze(() => {
        const t = re.value.map((n, a) => [
          [n.source],
          [n.target],
          [n.value]
        ]), l = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text],
          [
            [e.value.table.columnNames.source],
            [e.value.table.columnNames.target],
            [e.value.table.columnNames.value]
          ]
        ].concat(t), o = qe(l);
        Ke({
          csvContent: o,
          title: e.value.style.chart.title.text || "vue-ui-flow"
        });
      });
    }
    const L = m(() => {
      const t = [
        e.value.table.columnNames.source,
        e.value.table.columnNames.target,
        e.value.table.columnNames.value
      ], l = re.value.map((a, c) => [
        {
          color: a.sourceColor,
          name: a.source
        },
        {
          color: a.targetColor,
          name: a.target
        },
        pe({
          p: e.value.style.chart.nodes.labels.prefix,
          v: a.value,
          s: e.value.style.chart.nodes.labels.suffix,
          r: e.value.style.chart.nodes.labels.rounding
        })
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.source,
          e.value.table.columnNames.target,
          e.value.table.columnNames.value
        ],
        head: t,
        body: l,
        config: o
      };
    });
    function Ae() {
      return p.value;
    }
    function ie() {
      O.value.showTable = !O.value.showTable;
    }
    const H = b(!1);
    function U() {
      H.value = !H.value;
    }
    return we({
      getData: Ae,
      generateCsv: ue,
      generateImage: le,
      generatePdf: oe,
      toggleTable: ie,
      toggleAnnotator: U
    }), (t, l) => (u(), v("div", {
      ref_key: "flowChart",
      ref: Y,
      class: he(`vue-ui-flow ${T.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: N(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `flow_${z.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (u(), P(lt, {
        key: 0,
        parent: Y.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: H.value,
        onClose: U
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : $("", !0),
      e.value.style.chart.title.text ? (u(), v("div", st, [
        (u(), P(Re, {
          key: `title_${J.value}`,
          config: {
            title: {
              cy: "flow-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "flow-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : $("", !0),
      e.value.userOptions.show && M.value ? (u(), P(Je, {
        ref: "details",
        key: `user_option_${Z.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: i(ee),
        isImaging: i(te),
        uid: z.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: T.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: Y.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: H.value,
        onToggleFullscreen: $e,
        onGeneratePdf: i(oe),
        onGenerateCsv: ue,
        onGenerateImage: i(le),
        onToggleTable: ie,
        onToggleAnnotator: U
      }, Se({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: y(() => [
            k(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: y(() => [
            k(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: y(() => [
            k(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: y(() => [
            k(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: y(({ toggleFullscreen: o, isFullscreen: n }) => [
            k(t.$slots, "optionFullscreen", X(W({ toggleFullscreen: o, isFullscreen: n })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: y(({ toggleAnnotator: o, isAnnotator: n }) => [
            k(t.$slots, "optionAnnotator", X(W({ toggleAnnotator: o, isAnnotator: n })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : $("", !0),
      (u(), v("svg", {
        xmlns: i(je),
        viewBox: `0 0 ${B.value.width} ${B.value.height}`,
        class: he({ "vue-data-ui-fullscreen--on": T.value, "vue-data-ui-fulscreen--off": !T.value }),
        style: N(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        me(ot),
        S("defs", null, [
          (u(!0), v(F, null, I(p.value.links, (o, n) => (u(), v("linearGradient", {
            id: o.id,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            S("stop", {
              offset: "0%",
              "stop-color": o.sourceColor
            }, null, 8, it),
            S("stop", {
              offset: "100%",
              "stop-color": o.targetColor
            }, null, 8, ct)
          ], 8, ut))), 256))
        ]),
        (u(!0), v(F, null, I(p.value.links, (o) => (u(), v("path", {
          class: "vue-ui-flow-link",
          d: o.path,
          fill: `url(#${o.id})`,
          stroke: e.value.style.chart.links.stroke,
          "stroke-width": e.value.style.chart.links.strokeWidth,
          style: N(`opacity:${A.value ? [o.target, o.source].includes(A.value) ? 1 : 0.3 : e.value.style.chart.links.opacity}`)
        }, null, 12, dt))), 256)),
        (u(!0), v(F, null, I(p.value.nodes, (o, n) => (u(), v("rect", {
          class: "vue-ui-flow-node",
          x: o.x,
          y: i(f)(o.absoluteY),
          height: i(f)(o.height),
          width: x.value,
          fill: o.color,
          stroke: e.value.style.chart.nodes.stroke,
          "stroke-width": e.value.style.chart.nodes.strokeWidth,
          onMouseenter: (a) => Ie(o),
          onMouseleave: l[0] || (l[0] = (a) => Oe()),
          style: N(`opacity:${w.value ? w.value.includes(o.name) ? 1 : 0.2 : 1}`)
        }, null, 44, vt))), 256)),
        (u(!0), v(F, null, I(p.value.nodes, (o, n) => (u(), v("text", {
          x: o.x + x.value / 2,
          y: i(f)(o.absoluteY + o.height / 2 - e.value.style.chart.nodes.labels.fontSize / 4),
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: i(be)(o.color),
          "text-anchor": "middle",
          style: N(`pointer-events: none; opacity:${w.value ? w.value.includes(o.name) ? 1 : 0 : 1}`)
        }, q(e.value.style.chart.nodes.labels.abbreviation.use ? i(Xe)({ source: o.name, length: e.value.style.chart.nodes.labels.abbreviation.length }) : o.name), 13, ft))), 256)),
        (u(!0), v(F, null, I(p.value.nodes, (o, n) => (u(), v("text", {
          x: o.x + x.value / 2,
          y: i(f)(o.absoluteY + o.height / 2 + e.value.style.chart.nodes.labels.fontSize),
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: i(be)(o.color),
          "text-anchor": "middle",
          style: N(`pointer-events: none; opacity:${w.value ? w.value.includes(o.name) ? 1 : 0 : 1}`)
        }, q(i(We)(
          e.value.style.chart.nodes.labels.formatter,
          o.value,
          i(pe)({
            p: e.value.style.chart.nodes.labels.prefix,
            v: o.value,
            s: e.value.style.chart.nodes.labels.suffix,
            r: e.value.style.chart.nodes.labels.rounding
          }),
          { datapoint: o, seriesIndex: n }
        )), 13, ht))), 256)),
        k(t.$slots, "svg", { svg: B.value }, void 0, !0)
      ], 14, rt)),
      t.$slots.watermark ? (u(), v("div", mt, [
        k(t.$slots, "watermark", X(W({ isPrinting: i(ee) || i(te) })), void 0, !0)
      ])) : $("", !0),
      M.value ? $("", !0) : (u(), P(tt, {
        key: 4,
        config: {
          type: "flow",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      t.$slots.source ? (u(), v("div", gt, [
        k(t.$slots, "source", {}, void 0, !0)
      ], 512)) : $("", !0),
      M.value ? (u(), P(et, {
        key: 6,
        hideDetails: "",
        config: {
          open: O.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: y(() => [
          me(Qe, {
            colNames: L.value.colNames,
            head: L.value.head,
            body: L.value.body,
            config: L.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[1] || (l[1] = (o) => O.value.showTable = !1)
          }, {
            th: y(({ th: o }) => [
              S("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, pt)
            ]),
            td: y(({ td: o }) => [
              Me(q(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : $("", !0)
    ], 14, nt));
  }
}, It = /* @__PURE__ */ at(bt, [["__scopeId", "data-v-cbc0789b"]]);
export {
  It as default
};
