import { computed as d, ref as s, watch as pe, onMounted as De, onBeforeUnmount as Le, openBlock as n, createElementBlock as u, normalizeClass as V, normalizeStyle as q, createBlock as C, createCommentVNode as p, unref as v, createSlots as ze, withCtx as h, renderSlot as f, normalizeProps as S, guardReactiveProps as M, createVNode as ye, Fragment as F, renderList as N, createElementVNode as _, toDisplayString as P, createTextVNode as Ye, nextTick as Be } from "vue";
import { u as Ve, c as Xe, t as Ge, a as Ue, p as me, b as Ee, o as He, e as J, d as We, X as je, f as R, i as K, x as be, q as qe, r as Je, y as Ke } from "./index-Bya_q1J-.js";
import { t as Qe, u as Ze } from "./useResponsive-BY8tgM1n.js";
import { _ as et } from "./Title-C5pIfQAz.js";
import { u as tt, U as at } from "./usePrinter-CiHd1FwD.js";
import { L as lt } from "./Legend-DNgTCgEK.js";
import { D as ot } from "./DataTable-DYqC2pqu.js";
import { _ as rt } from "./Tooltip-Cz24YLfw.js";
import nt from "./vue-ui-skeleton-BYssP0K4.js";
import st from "./vue-ui-accordion-DfUfL2dI.js";
import { u as ke } from "./useNestedProp-B33hazbH.js";
import { _ as ut } from "./PackageVersion-VkaUzgmt.js";
import { P as it } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as ct } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const dt = ["id"], vt = ["xmlns", "viewBox"], ht = ["cx", "cy", "r", "stroke", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], ft = ["cx", "cy", "r", "stroke", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], gt = ["id"], pt = ["stdDeviation"], yt = ["filter"], mt = ["cx", "cy", "r", "stroke-width", "stroke-dasharray", "stroke-dashoffset"], bt = ["cx", "cy", "r", "stroke-width", "stroke-dasharray", "stroke-dashoffset", "onMouseenter"], kt = { key: 1 }, $t = ["onMouseenter"], wt = ["x", "y", "font-size", "fill", "font-weight"], Ct = {
  key: 4,
  class: "vue-data-ui-watermark"
}, xt = ["onClick"], Tt = ["innerHTML"], _t = {
  __name: "vue-ui-onion",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup($e, { expose: we, emit: Ce }) {
    const k = $e, { vue_ui_onion: xe } = Ve(), D = d(() => !!k.dataset && k.dataset.length), x = s(Xe()), Te = s(null), Q = s(0), L = s(!1), X = s(""), y = s([]), T = s(null), Z = s(null), ee = s(null), te = s(null), ae = s(0), le = s(0), oe = s(0), e = d({
      get: () => re(),
      set: (t) => t
    });
    function re() {
      const t = ke({
        userConfig: k.config,
        defaultConfig: xe
      });
      return t.theme ? {
        ...ke({
          userConfig: Ge.vue_ui_onion[t.theme] || k.config,
          defaultConfig: t
        }),
        customPalette: Ue[t.theme] || me
      } : t;
    }
    pe(() => k.config, (t) => {
      e.value = re(), ce(), ae.value += 1, le.value += 1, oe.value += 1;
    }, { deep: !0 });
    const { isPrinting: ne, isImaging: se, generatePdf: ue, generateImage: ie } = tt({
      elementId: `vue-ui-onion_${x.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-onion"
    }), _e = d(() => Ee(e.value.customPalette)), $ = s({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), r = s({
      height: 512,
      width: 512,
      padding: {
        top: 64,
        left: 64,
        right: 64,
        bottom: 64
      },
      minRadius: 64
    }), z = s(null);
    De(() => {
      ce();
    });
    function ce() {
      if (He(k.dataset) && J({
        componentName: "VueUiOnion",
        type: "dataset"
      }), e.value.responsive) {
        const o = Qe(() => {
          const { width: a, height: l } = Ze({
            chart: T.value,
            title: e.value.style.chart.title.text ? Z.value : null,
            legend: e.value.style.chart.legend.show ? ee.value : null,
            source: te.value
          });
          r.value.width = a, r.value.height = l, r.value.padding.top = Math.max(a, l) * 0.125, r.value.padding.right = Math.max(a, l) * 0.125, r.value.padding.bottom = Math.max(a, l) * 0.125, r.value.padding.left = Math.max(a, l) * 0.125, r.value.minRadius = Math.min(a, l) * 0.125;
        });
        z.value = new ResizeObserver(o), z.value.observe(T.value.parentNode);
      }
    }
    Le(() => {
      z.value && z.value.disconnect();
    });
    const i = d(() => ({
      top: r.value.padding.top,
      left: r.value.padding.left,
      right: r.value.width - r.value.padding.right,
      bottom: r.value.height - r.value.padding.bottom,
      centerX: r.value.width / 2,
      centerY: r.value.height / 2,
      width: r.value.width - r.value.padding.right - r.value.padding.left,
      height: r.value.height - r.value.padding.bottom - r.value.padding.top,
      minRadius: r.value.minRadius,
      maxRadius: Math.min(r.value.width, r.value.height) - r.value.padding.top * 2
    })), c = d(() => (k.dataset.forEach((t, o) => {
      [null, void 0].includes(t.name) && J({
        componentName: "VueUiOnion",
        type: "datasetSerieAttribute",
        property: "name",
        index: o
      }), [void 0].includes(t.percentage) && J({
        componentName: "VueUiOnion",
        type: "datasetSerieAttribute",
        property: "percentage",
        index: o
      });
    }), k.dataset.map((t, o) => {
      const a = `onion_serie_${o}_${x.value}`;
      return {
        ...t,
        percentage: t.percentage || 0,
        targetPercentage: t.percentage || 0,
        color: We(t.color) || _e.value[o] || me[o],
        id: a,
        shape: "circle",
        opacity: y.value.includes(a) ? 0.5 : 1,
        absoluteIndex: o,
        segregate: () => de(a),
        isSegregated: y.value.includes(a)
      };
    }))), O = s(c.value), Pe = d(() => e.value.useStartAnimation), Oe = s(null), Ae = d(() => Math.max(...c.value.map((t) => t.percentage))), G = s(!1);
    pe(() => c.value, Ie, { immediate: !0 });
    function Ie() {
      if (Pe.value && !G.value) {
        let o = function() {
          t >= Ae.value ? (cancelAnimationFrame(Oe.value), O.value = c.value, G.value = !0) : (O.value = c.value.map((a) => ({
            ...a,
            percentage: t < a.targetPercentage ? t : a.targetPercentage
          })), t += 1, requestAnimationFrame(o), G.value = !0);
        };
        O.value = c.value.map((a) => ({
          ...a,
          percentage: 0
        }));
        let t = 0;
        o();
      } else
        O.value = c.value;
    }
    const Se = d(() => ({
      cy: "onion-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), Me = d(() => c.value.filter((t) => !y.value.includes(t.id)).length), w = d(() => {
      const t = Math.min(i.value.width, i.value.height) / 2 / c.value.length;
      return {
        gutter: (t > e.value.style.chart.layout.maxThickness ? e.value.style.chart.layout.maxThickness : t) * e.value.style.chart.layout.gutter.width,
        track: (t > e.value.style.chart.layout.maxThickness ? e.value.style.chart.layout.maxThickness : t) * e.value.style.chart.layout.track.width
      };
    }), m = d(() => O.value.filter((t) => !y.value.includes(t.id)).map((t, o) => {
      const a = (i.value.maxRadius - w.value.track) / Me.value / 2 * (1 + o), l = i.value.centerY - a;
      return {
        percentage: t.percentage || 0,
        ...t,
        labelY: l,
        radius: a,
        path: Fe(a, t.percentage || 0)
      };
    }));
    function Fe(t, o) {
      const a = 2 * Math.PI * t, l = a * 0.75, g = `${l} ${a}`, I = l * (1 - o / 100);
      return {
        bgDashArray: `${l} ${a}`,
        bgDashOffset: 0,
        dashArray: g,
        dashOffset: I,
        fullOffset: 0,
        active: `
            M ${i.value.centerX},${i.value.centerY - t} 
            A ${t},${t} 0 1 1 
            ${i.value.centerX + t * Math.cos(Math.PI * 3 / 4)},${i.value.centerY + t * Math.sin(Math.PI * 3 / 4)}
        `.trim()
      };
    }
    function de(t) {
      y.value.includes(t) ? y.value = y.value.filter((o) => o !== t) : y.value.push(t), Ce("selectLegend", m.value);
    }
    function Ne() {
      return m.value;
    }
    const U = d(() => {
      const t = [e.value.table.translations.serie, e.value.table.translations.percentage, e.value.table.translations.value], o = m.value.map((a) => [
        a.name,
        a.percentage,
        a.value
      ]);
      return { head: t, body: o };
    }), Y = d(() => {
      const t = U.value.head, o = m.value.map((l) => [
        `<span style="color:${l.color}">⬤</span> ${l.name}`,
        `${Number(l.percentage ?? 0).toFixed(e.value.table.td.roundingPercentage).toLocaleString()}%`,
        `${l.prefix || ""}${[null, void 0, NaN, "NaN"].includes(l.value) ? "-" : l.value.toFixed(e.value.table.td.roundingValue).toLocaleString()}${l.suffix || ""}`
      ]), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: t, body: o, config: a, colNames: t };
    });
    function ve() {
      Be(() => {
        const t = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], o = U.value.head, a = U.value.body, l = t.concat([o]).concat(a), g = qe(l);
        Je({ csvContent: g, title: e.value.style.chart.title.text || "vue-ui-onion" });
      });
    }
    const b = s(void 0), A = s(!1);
    function Re(t) {
      A.value = t, Q.value += 1;
    }
    const E = s(null);
    function he({ datapoint: t, seriesIndex: o, show: a = !0 }) {
      const l = t.absoluteIndex;
      b.value = o, E.value = {
        datapoint: t,
        seriesIndex: l,
        series: c.value,
        config: e.value
      }, L.value = a;
      let g = "";
      const I = e.value.style.chart.tooltip.customFormat;
      if (be(I) && Ke(() => I({
        seriesIndex: l,
        datapoint: t,
        series: c.value,
        config: e.value
      })))
        X.value = I({
          seriesIndex: l,
          datapoint: t,
          series: c.value,
          config: e.value
        });
      else {
        const W = e.value.style.chart.tooltip.showPercentage, j = e.value.style.chart.tooltip.showValue;
        g += `<div style="width: 100%; border-bottom: 1px solid ${e.value.style.chart.tooltip.borderColor}; padding-bottom: 6px;margin-bottom:3px;display:flex;flex-direction:row;gap:3px;align-items:center"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${t.color}"/></svg><span></span>${t.name}</span></div>`, g += `<div style="width:100%;text-align:left;"><b>${W ? R({ p: "", v: t.percentage, s: "%", r: e.value.style.chart.tooltip.roundingPercentage }) : ""}</b> ${W && j ? "(" : ""}${j ? K(
          e.value.style.chart.layout.labels.value.formatter,
          t.value,
          R({
            p: t.prefix || "",
            v: t.value,
            s: t.suffix || "",
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: o }
        ) : ""}${W && j ? ")" : ""}</div>`, X.value = `<div>${g}</div>`;
      }
    }
    function fe() {
      $.value.showTable = !$.value.showTable;
    }
    function ge() {
      $.value.showTooltip = !$.value.showTooltip;
    }
    const B = s(!1);
    function H() {
      B.value = !B.value;
    }
    return we({
      getData: Ne,
      generatePdf: ue,
      generateCsv: ve,
      generateImage: ie,
      toggleTable: fe,
      toggleTooltip: ge,
      toggleAnnotator: H
    }), (t, o) => (n(), u("div", {
      class: V(`vue-ui-onion ${A.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "onionChart",
      ref: T,
      id: `vue-ui-onion_${x.value}`,
      style: q(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`)
    }, [
      e.value.userOptions.buttons.annotator ? (n(), C(it, {
        key: 0,
        parent: T.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: B.value,
        onClose: H
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : p("", !0),
      e.value.style.chart.title.text ? (n(), u("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: Z,
        style: "width:100%;background:transparent"
      }, [
        (n(), C(et, {
          key: `title_${ae.value}`,
          config: {
            title: {
              cy: "onion-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "onion-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : p("", !0),
      e.value.userOptions.show && D.value ? (n(), C(at, {
        ref_key: "details",
        ref: Te,
        key: `user_options${Q.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: v(se),
        isPrinting: v(ne),
        uid: x.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: A.value,
        isTooltip: $.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: T.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: B.value,
        onToggleFullscreen: Re,
        onGeneratePdf: v(ue),
        onGenerateCsv: ve,
        onGenerateImage: v(ie),
        onToggleTable: fe,
        onToggleTooltip: ge,
        onToggleAnnotator: H
      }, ze({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: h(() => [
            f(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: h(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: h(() => [
            f(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: h(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: h(() => [
            f(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: h(({ toggleFullscreen: a, isFullscreen: l }) => [
            f(t.$slots, "optionFullscreen", S(M({ toggleFullscreen: a, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: h(({ toggleAnnotator: a, isAnnotator: l }) => [
            f(t.$slots, "optionAnnotator", S(M({ toggleAnnotator: a, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : p("", !0),
      D.value ? (n(), u("svg", {
        key: 3,
        xmlns: v(je),
        class: V({ "vue-data-ui-fullscreen--on": A.value, "vue-data-ui-fulscreen--off": !A.value }),
        viewBox: `0 0 ${r.value.width <= 0 ? 1e-4 : r.value.width} ${r.value.height <= 0 ? 1e-4 : r.value.height}`,
        style: q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ye(ut),
        (n(!0), u(F, null, N(m.value, (a, l) => (n(), u("circle", {
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: a.radius <= 0 ? 1e-4 : a.radius,
          stroke: e.value.style.chart.layout.gutter.color,
          "stroke-width": w.value.gutter,
          fill: "none",
          "stroke-dasharray": a.path.bgDashArray,
          "stroke-dashoffset": a.path.fullOffset,
          "stroke-linecap": "round",
          class: V({ "vue-ui-onion-path": !0, "vue-ui-onion-blur": e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value !== l }),
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
        }, null, 10, ht))), 256)),
        (n(!0), u(F, null, N(m.value, (a, l) => (n(), u("circle", {
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: a.radius < 0 ? 1e-4 : a.radius,
          stroke: `${a.color}`,
          "stroke-width": w.value.track,
          fill: "none",
          "stroke-dasharray": a.path.dashArray,
          "stroke-dashoffset": a.path.dashOffset,
          class: V({ "vue-ui-onion-path": !0, "vue-ui-onion-blur": e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value !== l }),
          "stroke-linecap": "round",
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
        }, null, 10, ft))), 256)),
        _("defs", null, [
          _("filter", {
            id: `blur_${x.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            _("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 100 / e.value.style.chart.gradientIntensity
            }, null, 8, pt)
          ], 8, gt)
        ]),
        e.value.style.chart.useGradient ? (n(), u("g", {
          key: 0,
          filter: `url(#blur_${x.value})`
        }, [
          (n(!0), u(F, null, N(m.value, (a, l) => (n(), u("circle", {
            cx: i.value.centerX,
            cy: i.value.centerY,
            r: a.radius <= 0 ? 1e-4 : a.radius,
            stroke: "white",
            "stroke-width": w.value.track / 3,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-dasharray": a.path.dashArray,
            "stroke-dashoffset": a.path.dashOffset,
            style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" }
          }, null, 8, mt))), 256))
        ], 8, yt)) : p("", !0),
        (n(!0), u(F, null, N(m.value, (a, l) => (n(), u("circle", {
          "data-cy-trap": "",
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: a.radius <= 0 ? 1e-4 : a.radius,
          stroke: "transparent",
          "stroke-width": Math.max(w.value.track, w.value.gutter),
          fill: "none",
          "stroke-dasharray": a.path.bgDashArray,
          "stroke-dashoffset": a.path.fullOffset,
          "stroke-linecap": "round",
          class: "vue-ui-onion-path",
          style: { transform: "rotate(-90deg)", "transform-origin": "50% 50%" },
          onMouseenter: (g) => he({
            datapoint: a,
            show: !0,
            seriesIndex: l
          }),
          onMouseleave: o[0] || (o[0] = (g) => {
            b.value = void 0, L.value = !1;
          })
        }, null, 40, bt))), 256)),
        e.value.style.chart.layout.labels.show ? (n(), u("g", kt, [
          (n(!0), u(F, null, N(m.value, (a, l) => (n(), u("g", {
            onMouseenter: (g) => he({
              datapoint: a,
              show: !0,
              seriesIndex: l
            }),
            onMouseleave: o[1] || (o[1] = (g) => {
              b.value = void 0, L.value = !1;
            })
          }, [
            y.value.includes(a.id) ? p("", !0) : (n(), u("text", {
              key: 0,
              x: r.value.width / 2 - w.value.gutter * 0.8 + e.value.style.chart.layout.labels.offsetX,
              y: a.labelY + e.value.style.chart.layout.labels.offsetY,
              "text-anchor": "end",
              "font-size": e.value.style.chart.layout.labels.fontSize,
              fill: e.value.useBlurOnHover && ![null, void 0].includes(b.value) && b.value === l ? a.color : e.value.style.chart.layout.labels.color,
              "font-weight": e.value.style.chart.layout.labels.bold ? "bold" : "normal"
            }, P(a.name ? a.name + ": " : "") + " " + P(e.value.style.chart.layout.labels.percentage.show ? v(R)({
              v: a.percentage,
              s: "%",
              r: e.value.style.chart.layout.labels.roundingPercentage
            }) : "") + " " + P(!e.value.style.chart.layout.labels.percentage.show && e.value.style.chart.layout.labels.value.show ? `: ${v(K)(
              e.value.style.chart.layout.labels.value.formatter,
              a.value,
              v(R)({
                p: a.prefix || "",
                v: a.value || 0,
                s: a.suffix || "",
                r: e.value.style.chart.layout.labels.roundingValue
              }),
              { datapoint: a, seriesIndex: l }
            )}` : `${e.value.style.chart.layout.labels.value.show && a.value ? `(${v(K)(
              e.value.style.chart.layout.labels.value.formatter,
              a.value,
              v(R)({
                p: a.prefix || "",
                v: a.value || 0,
                s: a.suffix || "",
                r: e.value.style.chart.layout.labels.roundingValue
              }),
              { datapoint: a, seriesIndex: l }
            )})` : ""}`), 9, wt))
          ], 40, $t))), 256))
        ])) : p("", !0),
        f(t.$slots, "svg", { svg: r.value }, void 0, !0)
      ], 14, vt)) : p("", !0),
      t.$slots.watermark ? (n(), u("div", Ct, [
        f(t.$slots, "watermark", S(M({ isPrinting: v(ne) || v(se) })), void 0, !0)
      ])) : p("", !0),
      D.value ? p("", !0) : (n(), C(nt, {
        key: 5,
        config: {
          type: "onion",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            onion: {
              color: e.value.style.chart.layout.gutter.color
            }
          }
        }
      }, null, 8, ["config"])),
      _("div", {
        ref_key: "chartLegend",
        ref: ee
      }, [
        e.value.style.chart.legend.show ? (n(), C(lt, {
          key: `legend_${oe.value}`,
          legendSet: c.value,
          config: Se.value,
          onClickMarker: o[2] || (o[2] = ({ legend: a }) => de(a.id))
        }, {
          item: h(({ legend: a }) => [
            _("div", {
              "data-cy-legend-item": "",
              onClick: (l) => a.segregate(),
              style: q(`opacity:${y.value.includes(a.id) ? 0.5 : 1}`)
            }, P(a.name ? a.name + ": " : "") + " " + P((a.percentage || 0).toFixed(e.value.style.chart.legend.roundingPercentage)) + "% ", 13, xt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : f(t.$slots, "legend", {
          key: 1,
          legend: c.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (n(), u("div", {
        key: 6,
        ref_key: "source",
        ref: te,
        dir: "auto"
      }, [
        f(t.$slots, "source", {}, void 0, !0)
      ], 512)) : p("", !0),
      ye(rt, {
        show: $.value.showTooltip && L.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: T.value,
        content: X.value,
        isCustom: v(be)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": h(() => [
          f(t.$slots, "tooltip-before", S(M({ ...E.value })), void 0, !0)
        ]),
        "tooltip-after": h(() => [
          f(t.$slots, "tooltip-after", S(M({ ...E.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      D.value ? (n(), C(st, {
        key: 7,
        hideDetails: "",
        config: {
          open: $.value.showTable,
          maxHeight: 1e4,
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: h(() => [
          (n(), C(ot, {
            key: `table_${le.value}`,
            colNames: Y.value.colNames,
            head: Y.value.head,
            body: Y.value.body,
            config: Y.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[3] || (o[3] = (a) => $.value.showTable = !1)
          }, {
            th: h(({ th: a }) => [
              Ye(P(a), 1)
            ]),
            td: h(({ td: a }) => [
              _("div", { innerHTML: a }, null, 8, Tt)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : p("", !0)
    ], 14, dt));
  }
}, Vt = /* @__PURE__ */ ct(_t, [["__scopeId", "data-v-71fb43d0"]]);
export {
  Vt as default
};
