import { computed as p, ref as u, watch as Be, onMounted as De, onBeforeUnmount as Ge, openBlock as r, createElementBlock as s, normalizeClass as z, normalizeStyle as Q, createBlock as w, createCommentVNode as h, unref as g, createSlots as We, withCtx as y, renderSlot as m, normalizeProps as R, guardReactiveProps as M, createVNode as Z, createElementVNode as $, Fragment as P, renderList as T, toDisplayString as V, createTextVNode as _e, nextTick as Xe } from "vue";
import { u as Ye, c as je, t as qe, a as He, p as x, o as Je, e as S, b as Ke, g as we, d as $e, O as Pe, v as Qe, i as Te, f as U, X as Ze, s as ee, w as et, P as xe, x as tt, y as at, q as ot, r as lt } from "./index-Bya_q1J-.js";
import { t as rt, u as nt } from "./useResponsive-BY8tgM1n.js";
import { _ as st } from "./Title-C5pIfQAz.js";
import { u as ut, U as it } from "./usePrinter-CiHd1FwD.js";
import { _ as ct } from "./Tooltip-Cz24YLfw.js";
import dt from "./vue-ui-sparkbar-CwqlyAyv.js";
import { L as vt } from "./Legend-DNgTCgEK.js";
import { D as pt } from "./DataTable-DYqC2pqu.js";
import ht from "./vue-ui-skeleton-BYssP0K4.js";
import gt from "./vue-ui-accordion-DfUfL2dI.js";
import { u as Ae } from "./useNestedProp-B33hazbH.js";
import { _ as ft } from "./PackageVersion-VkaUzgmt.js";
import { P as yt } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as mt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const bt = ["id"], kt = ["xmlns", "viewBox"], Ct = ["id"], _t = ["stop-color"], wt = ["stop-color"], $t = { key: 0 }, Pt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Tt = { key: 0 }, xt = ["d", "stroke", "stroke-width"], At = ["d", "stroke", "stroke-width"], Ot = { key: 1 }, Nt = ["x", "y", "text-anchor", "font-size", "fill", "onMouseenter"], St = ["points", "stroke", "stroke-width"], Ft = ["points", "stroke", "stroke-width", "fill"], It = { key: 2 }, Lt = ["cx", "cy", "fill", "r", "stroke"], zt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Rt = ["onClick"], Mt = {
  key: 0,
  style: { "max-width": "200px", margin: "0 auto" }
}, Vt = {
  __name: "vue-ui-radar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(Oe, { expose: Ne, emit: Se }) {
    const v = Oe, { vue_ui_radar: Fe } = Ye(), F = p(() => !!v.dataset && Object.keys(v.dataset).length), _ = u(je()), Ie = u(null), W = u(!1), X = u(""), te = u(0), A = u(null), ae = u(null), oe = u(null), le = u(null), re = u(0), ne = u(0), se = u(0), e = p({
      get: () => ue(),
      set: (t) => t
    });
    function ue() {
      const t = Ae({
        userConfig: v.config,
        defaultConfig: Fe
      });
      return t.theme ? {
        ...Ae({
          userConfig: qe.vue_ui_radar[t.theme] || v.config,
          defaultConfig: t
        }),
        customPalette: He[t.theme] || x
      } : t;
    }
    Be(() => v.config, (t) => {
      e.value = ue(), ie(), re.value += 1, ne.value += 1, se.value += 1;
    }, { deep: !0 });
    const E = u(null);
    function ie() {
      if (Je(v.dataset) && S({
        componentName: "VueUiRadar",
        type: "dataset"
      }), e.value.responsive) {
        const t = rt(() => {
          const { width: a, height: o } = nt({
            chart: A.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            legend: e.value.style.chart.legend.show ? oe.value : null,
            source: le.value
          });
          i.value.width = a, i.value.height = o;
        });
        E.value = new ResizeObserver(t), E.value.observe(A.value.parentNode);
      }
    }
    De(() => {
      ie();
    }), Ge(() => {
      E.value && E.value.disconnect();
    });
    const { isPrinting: ce, isImaging: de, generatePdf: ve, generateImage: pe } = ut({
      elementId: `vue-ui-radar_${_.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-radar"
    }), he = p(() => Ke(e.value.customPalette)), k = u({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), Le = p(() => ({
      style: {
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        animation: {
          show: e.value.style.chart.tooltip.animation.show,
          animationFrames: e.value.style.chart.tooltip.animation.animationFrames
        },
        labels: {
          fontSize: e.value.style.chart.tooltip.fontSize,
          name: {
            color: e.value.style.chart.tooltip.color
          }
        },
        gutter: {
          backgroundColor: "#CCCCCC",
          opacity: 30
        }
      }
    })), i = u({
      height: 312,
      width: 512
    }), c = u([]), I = u(null), O = u(!1);
    function ge(t) {
      O.value = !0, c.value.includes(t) ? (I.value = t, c.value = c.value.filter((a) => a !== t), setTimeout(() => {
        O.value = !1, I.value = null;
      }, 500)) : (c.value.push(t), setTimeout(() => {
        O.value = !1;
      }, 500)), Se("selectLegend", N.value.filter((a, o) => !c.value.includes(o)).map((a) => ({
        name: a.name,
        color: a.color,
        proportion: a.totalProportion
      })));
    }
    function ze() {
      return N.value.map((t) => ({
        name: t.name,
        color: t.color,
        proportion: t.totalProportion
      }));
    }
    const f = p(() => [null, void 0].includes(v.dataset.categories) ? (S({
      componentName: "VueUiRadar",
      type: "datasetAttribute",
      property: "categories ({ name: string; prefix?: string; suffix?: string}[])"
    }), []) : (v.dataset.categories.length === 0 ? S({
      componentName: "VueUiRadar",
      type: "datasetAttributeEmpty",
      property: "categories"
    }) : v.dataset.categories.forEach((t, a) => {
      we({
        datasetObject: t,
        requiredAttributes: ["name"]
      }).forEach((o) => {
        S({
          componentName: "VueUiRadar",
          type: "datasetAttribute",
          property: `category.${o} at index ${a}`,
          index: a
        });
      });
    }), [null, void 0].includes(v.dataset.series) ? S({
      componentName: "VueUiRadar",
      type: "datasetAttribute",
      property: "series ({ name: string; values: number[]; color?: string; target: number}[])"
    }) : v.dataset.series.forEach((t, a) => {
      we({
        datasetObject: t,
        requiredAttributes: ["name", "values", "target"]
      }).forEach((o) => {
        S({
          componentName: "VueUiRadar",
          type: "datasetSerieAttribute",
          key: "series",
          property: o,
          index: a
        });
      });
    }), v.dataset.categories.map((t, a) => ({
      name: t.name,
      categoryId: `radar_category_${_.value}_${a}`,
      color: $e(t.color) || he.value[a] || x[a] || x[a % x.length],
      prefix: t.prefix ?? "",
      suffix: t.suffix ?? ""
    })))), b = p(() => F.value ? v.dataset.series.map((t, a) => ({
      ...t,
      color: $e(t.color) || he.value[a] || x[a] || x[a % x.length],
      serieId: `radar_serie_${_.value}_${a}`,
      formatter: t.formatter || null
    })) : []), fe = p(() => Math.max(...b.value.flatMap((t) => t.values))), ye = p(() => b.value.length), Y = p(() => Math.min(i.value.width, i.value.height) / 3), me = p(() => Pe({
      plot: { x: i.value.width / 2, y: i.value.height / 2 },
      radius: Y.value,
      sides: ye.value,
      rotation: 0
    })), Re = p(() => {
      const t = [];
      for (let a = 0; a < Y.value; a += Y.value / e.value.style.chart.layout.grid.graduations)
        t.push(a);
      return t;
    }), C = p(() => me.value.coordinates.map((t, a) => {
      const o = b.value[a].values.map((l) => Me({
        centerX: i.value.width / 2,
        centerY: i.value.height / 2,
        apexX: t.x,
        apexY: t.y,
        proportion: l / (b.value[a].target || fe.value)
      }));
      return {
        ...t,
        ...b.value[a],
        plots: o
      };
    }));
    function j({ x: t, y: a }) {
      let o = "middle";
      return t = Math.round(t), a = Math.round(a), t > i.value.width / 2 && (t += 12, o = "start"), t < i.value.width / 2 && (t -= 12, o = "end"), a > i.value.height / 2 && (a += 20), a < i.value.height / 2 && (a -= 12), a === i.value.height / 2 && (a += 4), { x: t, y: a, anchor: o };
    }
    function Me({ centerX: t, centerY: a, apexX: o, apexY: l, proportion: n }) {
      return {
        x: t + (o - t) * n,
        y: a + (l - a) * n
      };
    }
    const N = p(() => {
      const t = b.value.map((a, o) => a.values.map((l) => l / (a.target || fe.value)));
      return f.value.map((a, o) => ({
        ...a,
        totalProportion: Qe(t.map((l) => l[o]).reduce((l, n) => l + n, 0) / b.value.length),
        shape: "circle",
        opacity: c.value.includes(o) ? 0.5 : 1,
        segregate: () => ge(o),
        isSegregated: c.value.includes(o)
      }));
    }), Ve = p(() => ({
      cy: "radar-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), B = p(() => {
      const t = [
        { name: e.value.translations.datapoint, color: "" },
        { name: e.value.translations.target, color: "" },
        ...N.value
      ], a = v.dataset.series.map((l) => [
        l.name,
        Te(
          l.formatter,
          l.target,
          U({
            p: l.prefix,
            v: l.target,
            s: l.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        ...l.values.map((n, d) => `${Te(
          l.formatter,
          n,
          U({ p: f.value[d].prefix, v: n, s: f.value[d].suffix, r: e.value.table.td.roundingValue })
        )} (${isNaN(n / l.target) ? "" : U({
          v: n / l.target * 100,
          s: "%",
          r: e.value.table.td.roundingPercentage
        })})`)
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: t, body: a, config: o, colNames: t };
    }), D = u(null), q = u([]), H = u(null);
    function Ue(t, a) {
      q.value = [], D.value = a, W.value = !0;
      let o = "";
      H.value = {
        datapoint: t,
        seriesIndex: a,
        series: {
          categories: f.value,
          datapoints: b.value,
          radar: C.value
        },
        config: e.value
      };
      const l = e.value.style.chart.tooltip.customFormat;
      if (tt(l) && at(() => l({
        seriesIndex: a,
        datapoint: t,
        series: { categories: f.value, datapoints: b.value, radar: C.value },
        config: e.value
      })))
        X.value = l({
          seriesIndex: a,
          datapoint: t,
          series: { categories: f.value, datapoints: b.value, radar: C.value },
          config: e.value
        });
      else {
        o += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.name}</div>`;
        for (let n = 0; n < t.values.length; n += 1)
          c.value.includes(n) || q.value.push({
            name: f.value[n].name,
            value: t.values[n] / t.target * 100,
            color: f.value[n].color,
            suffix: "%)",
            prefix: `${U({ p: f.value[n].prefix ?? "", v: t.values[n], s: f.value[n].suffix ?? "", r: e.value.style.chart.tooltip.roundingValue })} (`,
            rounding: e.value.style.chart.tooltip.roundingPercentage,
            formatter: t.formatter
          });
        X.value = o;
      }
    }
    function be() {
      Xe(() => {
        const t = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], a = [[""], [e.value.translations.target], ...N.value.flatMap((d) => [[d.name], ["%"]])], o = v.dataset.series.map((d, Ut) => [d.name, d.target, ...d.values.flatMap((K) => [
          K,
          isNaN(K / d.target) ? "" : K / d.target * 100
        ])]), l = t.concat([a]).concat(o), n = ot(l);
        lt({ csvContent: n, title: e.value.style.chart.title.text || "vue-ui-radar" });
      });
    }
    const L = u(!1);
    function Ee(t) {
      L.value = t, te.value += 1;
    }
    function ke() {
      k.value.showTable = !k.value.showTable;
    }
    function Ce() {
      k.value.showTooltip = !k.value.showTooltip;
    }
    const G = u(!1);
    function J() {
      G.value = !G.value;
    }
    return Ne({
      getData: ze,
      generatePdf: ve,
      generateCsv: be,
      generateImage: pe,
      toggleTable: ke,
      toggleTooltip: Ce,
      toggleAnnotator: J
    }), (t, a) => (r(), s("div", {
      class: z(`vue-ui-radar ${L.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "radarChart",
      ref: A,
      id: `vue-ui-radar_${_.value}`,
      style: Q(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`)
    }, [
      e.value.userOptions.buttons.annotator ? (r(), w(yt, {
        key: 0,
        parent: A.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: G.value,
        onClose: J
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : h("", !0),
      e.value.style.chart.title.text ? (r(), s("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (r(), w(st, {
          key: `title_${re.value}`,
          config: {
            title: {
              cy: "radar-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "radar-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : h("", !0),
      e.value.userOptions.show && F.value ? (r(), w(it, {
        ref_key: "details",
        ref: Ie,
        key: `user_options_${te.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: g(de),
        isPrinting: g(ce),
        uid: _.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: L.value,
        isTooltip: k.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: A.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: G.value,
        onToggleFullscreen: Ee,
        onGeneratePdf: g(ve),
        onGenerateCsv: be,
        onGenerateImage: g(pe),
        onToggleTable: ke,
        onToggleTooltip: Ce,
        onToggleAnnotator: J
      }, We({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: y(() => [
            m(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: y(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: y(() => [
            m(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: y(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: y(() => [
            m(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: y(({ toggleFullscreen: o, isFullscreen: l }) => [
            m(t.$slots, "optionFullscreen", R(M({ toggleFullscreen: o, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: y(({ toggleAnnotator: o, isAnnotator: l }) => [
            m(t.$slots, "optionAnnotator", R(M({ toggleAnnotator: o, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : h("", !0),
      F.value ? (r(), s("svg", {
        key: 3,
        xmlns: g(Ze),
        class: z({ "vue-data-ui-fullscreen--on": L.value, "vue-data-ui-fulscreen--off": !L.value }),
        viewBox: `0 0 ${i.value.width <= 0 ? 10 : i.value.width} ${i.value.height <= 0 ? 10 : i.value.height}`,
        style: Q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Z(ft),
        $("defs", null, [
          (r(!0), s(P, null, T(f.value, (o, l) => (r(), s("radialGradient", {
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `radar_gradient_${_.value}_${l}`
          }, [
            $("stop", {
              offset: "0%",
              "stop-color": g(ee)(g(et)(o.color, 0.05), e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, _t),
            $("stop", {
              offset: "100%",
              "stop-color": g(ee)(o.color, e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, wt)
          ], 8, Ct))), 256))
        ]),
        e.value.style.chart.layout.grid.show ? (r(), s("g", $t, [
          (r(!0), s(P, null, T(C.value, (o) => (r(), s("line", {
            x1: i.value.width / 2,
            y1: i.value.height / 2,
            x2: o.x,
            y2: o.y,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth
          }, null, 8, Pt))), 256)),
          e.value.style.chart.layout.grid.graduations > 0 ? (r(), s("g", Tt, [
            (r(!0), s(P, null, T(Re.value, (o) => (r(), s("path", {
              d: g(Pe)({
                plot: { x: i.value.width / 2, y: i.value.height / 2 },
                radius: o,
                sides: ye.value,
                rotation: 0
              }).path,
              fill: "none",
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth
            }, null, 8, xt))), 256))
          ])) : h("", !0)
        ])) : h("", !0),
        $("path", {
          d: me.value.path,
          fill: "none",
          stroke: e.value.style.chart.layout.outerPolygon.stroke,
          "stroke-width": e.value.style.chart.layout.outerPolygon.strokeWidth,
          "stroke-linejoin": "round",
          "stroke-linecap": "round"
        }, null, 8, At),
        e.value.style.chart.layout.labels.dataLabels.show ? (r(), s("g", Ot, [
          (r(!0), s(P, null, T(C.value, (o, l) => (r(), s("text", {
            x: j(o).x,
            y: j(o).y,
            "text-anchor": j(o).anchor,
            "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
            fill: e.value.style.chart.layout.labels.dataLabels.color,
            onMouseenter: (n) => Ue(o, l),
            onMouseleave: a[0] || (a[0] = (n) => {
              W.value = !1, D.value = null;
            })
          }, V(o.name), 41, Nt))), 256))
        ])) : h("", !0),
        (r(!0), s(P, null, T(f.value, (o, l) => (r(), s("g", null, [
          $("g", null, [
            e.value.useCssAnimation || !e.value.useCssAnimation && !c.value.includes(l) ? (r(), s("polygon", {
              key: 0,
              "data-cy-radar-path": "",
              points: g(xe)(C.value.map((n) => n.plots[l]), !1, !0),
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.dataPolygon.strokeWidth + 1,
              fill: "none",
              class: z({ "animated-out": c.value.includes(l) && e.value.useCssAnimation, "animated-in": O.value && I.value === l && e.value.useCssAnimation })
            }, null, 10, St)) : h("", !0),
            e.value.useCssAnimation || !e.value.useCssAnimation && !c.value.includes(l) ? (r(), s("polygon", {
              key: 1,
              "data-cy-radar-path": "",
              points: g(xe)(C.value.map((n) => n.plots[l]), !1, !0),
              stroke: o.color,
              "stroke-width": e.value.style.chart.layout.dataPolygon.strokeWidth,
              fill: e.value.style.chart.layout.dataPolygon.transparent ? "transparent" : e.value.style.chart.layout.dataPolygon.useGradient ? `url(#radar_gradient_${_.value}_${l})` : g(ee)(o.color, e.value.style.chart.layout.dataPolygon.opacity),
              class: z({ "animated-out": c.value.includes(l) && e.value.useCssAnimation, "animated-in": O.value && I.value === l && e.value.useCssAnimation })
            }, null, 10, Ft)) : h("", !0)
          ])
        ]))), 256)),
        e.value.style.chart.layout.plots.show ? (r(), s("g", It, [
          (r(!0), s(P, null, T(C.value, (o, l) => (r(), s("g", null, [
            (r(!0), s(P, null, T(o.plots, (n, d) => (r(), s("circle", {
              cx: n.x,
              cy: n.y,
              fill: c.value.includes(d) ? "transparent" : f.value[d].color,
              r: D.value !== null && D.value === l ? e.value.style.chart.layout.plots.radius * 1.6 : e.value.style.chart.layout.plots.radius,
              stroke: c.value.includes(d) ? "transparent" : e.value.style.chart.backgroundColor,
              "stroke-width": 0.5,
              class: z({ "animated-out": c.value.includes(d) && e.value.useCssAnimation, "animated-in": O.value && I.value === d && e.value.useCssAnimation })
            }, null, 10, Lt))), 256))
          ]))), 256))
        ])) : h("", !0),
        m(t.$slots, "svg", { svg: i.value }, void 0, !0)
      ], 14, kt)) : h("", !0),
      t.$slots.watermark ? (r(), s("div", zt, [
        m(t.$slots, "watermark", R(M({ isPrinting: g(ce) || g(de) })), void 0, !0)
      ])) : h("", !0),
      F.value ? h("", !0) : (r(), w(ht, {
        key: 5,
        config: {
          type: "radar",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            radar: {
              grid: {
                color: e.value.style.chart.layout.outerPolygon.stroke
              },
              shapes: {
                color: e.value.style.chart.layout.outerPolygon.stroke
              }
            }
          }
        }
      }, null, 8, ["config"])),
      $("div", {
        ref_key: "chartLegend",
        ref: oe
      }, [
        e.value.style.chart.legend.show ? (r(), w(vt, {
          key: `legend_${se.value}`,
          legendSet: N.value,
          config: Ve.value,
          onClickMarker: a[1] || (a[1] = ({ i: o }) => ge(o))
        }, {
          item: y(({ legend: o, index: l }) => [
            $("div", {
              "data-cy-legend-item": "",
              onClick: (n) => o.segregate(),
              style: Q(`opacity:${c.value.includes(l) ? 0.5 : 1}`)
            }, V(o.name) + ": " + V(g(U)({
              v: o.totalProportion * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })), 13, Rt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : m(t.$slots, "legend", {
          key: 1,
          legend: N.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (r(), s("div", {
        key: 6,
        ref_key: "source",
        ref: le,
        dir: "auto"
      }, [
        m(t.$slots, "source", {}, void 0, !0)
      ], 512)) : h("", !0),
      Z(ct, {
        show: k.value.showTooltip && W.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        fontSize: e.value.style.chart.tooltip.fontSize,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: A.value,
        content: X.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": y(() => [
          m(t.$slots, "tooltip-before", R(M({ ...H.value })), void 0, !0)
        ]),
        "tooltip-after": y(() => [
          ["function"].includes(typeof e.value.style.chart.tooltip.customFormat) ? h("", !0) : (r(), s("div", Mt, [
            Z(dt, {
              dataset: q.value,
              config: Le.value,
              backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity
            }, null, 8, ["dataset", "config", "backgroundOpacity"])
          ])),
          m(t.$slots, "tooltip-after", R(M({ ...H.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "fontSize", "position", "offsetY", "parent", "content", "isCustom"]),
      F.value ? (r(), w(gt, {
        key: 7,
        hideDetails: "",
        config: {
          open: k.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: y(() => [
          (r(), w(pt, {
            key: `table_${ne.value}`,
            colNames: B.value.colNames,
            head: B.value.head,
            body: B.value.body,
            config: B.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (o) => k.value.showTable = !1)
          }, {
            th: y(({ th: o }) => [
              _e(V(o.name), 1)
            ]),
            td: y(({ td: o }) => [
              _e(V(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : h("", !0)
    ], 14, bt));
  }
}, ta = /* @__PURE__ */ mt(Vt, [["__scopeId", "data-v-f0bd4098"]]);
export {
  ta as default
};
