import { useCssVars as Ce, computed as c, ref as s, watch as be, onMounted as we, onBeforeUnmount as xe, openBlock as n, createElementBlock as u, normalizeStyle as C, createBlock as A, createCommentVNode as y, unref as h, createSlots as Ae, withCtx as O, renderSlot as m, normalizeProps as S, guardReactiveProps as T, normalizeClass as R, createVNode as Oe, createElementVNode as Pe, Fragment as P, renderList as I, toDisplayString as Ie } from "vue";
import { u as Fe, c as Ee, t as ze, a as Le, p as le, b as Ne, o as Se, e as ne, g as Te, X as Re } from "./index-Bya_q1J-.js";
import { t as Me, u as je } from "./useResponsive-BY8tgM1n.js";
import { _ as Be } from "./Title-C5pIfQAz.js";
import { u as Ge, U as Ue } from "./usePrinter-CiHd1FwD.js";
import De from "./vue-ui-skeleton-BYssP0K4.js";
import { u as re } from "./useNestedProp-B33hazbH.js";
import { _ as Ve } from "./PackageVersion-VkaUzgmt.js";
import { P as We } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Xe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ye = ["id"], qe = ["xmlns", "viewBox"], He = ["cx", "cy", "r", "stroke", "stroke-width"], Je = { key: 0 }, Ke = ["stroke", "d", "stroke-width"], Qe = { key: 1 }, Ze = ["stroke", "x1", "x2", "y1", "y2"], et = ["text-anchor", "transform", "x", "y", "onClick", "font-weight", "font-size", "fill"], tt = ["cx", "cy", "fill", "onClick", "r"], lt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, nt = {
  __name: "vue-ui-relation-circle",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(ae, { expose: se }) {
    const d = ae;
    Ce((e) => ({
      "76cff64e": de.value,
      "0b529da6": ce.value,
      "15b1ac4f": ve.value
    }));
    const { vue_ui_relation_circle: ie } = Fe(), F = c(() => !!d.dataset && Object.keys(d.dataset).length), k = s(Ee()), M = s(0), _ = s(null), j = s(null), B = s(null), G = s(0), l = c({
      get: () => U(),
      set: (e) => e
    });
    function U() {
      const e = re({
        userConfig: d.config,
        defaultConfig: ie
      });
      return e.theme ? {
        ...re({
          userConfig: ze.vue_ui_relation_circle[e.theme] || d.config,
          defaultConfig: e
        }),
        customPalette: Le[e.theme] || le
      } : e;
    }
    be(() => d.config, (e) => {
      l.value = U(), q(), G.value += 1;
    }, { deep: !0 });
    const { isPrinting: D, isImaging: V, generatePdf: W, generateImage: X } = Ge({
      elementId: `relation_circle_${k.value}`,
      fileName: l.value.style.title.text || "vue-ui-relation-circle"
    }), Y = c(() => Ne(l.value.customPalette)), f = s([]), p = s([]), i = s({}), v = s([]), oe = s(0), E = c(() => d.dataset.slice(0, l.value.style.limit)), z = s(l.value.style.size), o = s({
      height: l.value.style.size,
      width: l.value.style.size
    }), g = c({
      get() {
        return z.value * l.value.style.circle.radiusProportion;
      },
      set(e) {
        return e;
      }
    }), ue = c(() => l.value.style.links.curved), ce = c(() => `${l.value.style.animation.speedMs}ms`), de = c(() => g.value * 2), ve = c(() => g.value * 4), b = s(null);
    we(() => {
      q(), document.getElementById(`relation_circle_${k.value}`).addEventListener("click", H);
    });
    function q() {
      if (Se(d.dataset) ? ne({
        componentName: "VueUiRelationCircle",
        type: "dataset"
      }) : d.dataset.forEach((e, r) => {
        Te({
          datasetObject: e,
          requiredAttributes: ["id", "label", "relations", "weights"]
        }).forEach((t) => {
          ne({
            componentName: "VueUiRelationCircle",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), l.value.responsive) {
        const e = Me(() => {
          const { width: r, height: t } = je({
            chart: _.value,
            title: l.value.style.title.text ? j.value : null,
            source: B.value
          });
          z.value = Math.min(r, t), o.value.width = r, o.value.height = t, g.value = z.value * l.value.style.circle.radiusProportion, f.value = [], p.value = [], J(), K();
        });
        b.value = new ResizeObserver(e), b.value.observe(_.value.parentNode);
      } else
        f.value = [], p.value = [], J(), K();
    }
    xe(() => {
      document.getElementById(`relation_circle_${k.value}`).removeEventListener("click", H), b.value && b.value.disconnect();
    });
    function H(e) {
      const r = e.target;
      r && Array.from(r.classList).includes("vue-ui-user-options") || r && Array.from(r.classList).includes("vue-ui-user-options-summary") || r && Array.from(r.classList).includes("vue-data-ui-button") || r && Array.from(r.classList).includes("vue-ui-relation-circle-legend") || (i.value = {}, v.value = []);
    }
    function J() {
      const e = 6.28319 / E.value.length, r = 360 / E.value.length;
      let t = 0, a = 0;
      E.value.forEach(($, N) => {
        const _e = g.value * Math.cos(t) + o.value.width / 2, $e = g.value * Math.sin(t) + o.value.height / 2 + l.value.style.circle.offsetY;
        f.value.push({ x: _e, y: $e, ...$, color: $.color ? $.color : Y.value[N] ? Y.value[N] : le[N], regAngle: a }), t += e, a += r;
      });
    }
    function K() {
      f.value.forEach((e) => {
        f.value.filter((t) => t.relations.includes(e.id)).forEach((t, a) => {
          p.value.push({
            weight: e.weights && e.weights[a] ? e.weights[a] : 1,
            relationId: `${e.id}_${t.id}`,
            x1: e.x,
            y1: e.y,
            x2: t.x,
            y2: t.y,
            colorSource: e.color,
            colorTarget: t.color,
            ...e
          });
        });
      });
    }
    const fe = c(() => Math.max(...p.value.map((e) => e.weight)));
    function ge(e) {
      return Object.hasOwn(i.value, "x") ? v.value.includes(e.id) ? "opacity:1" : "opacity:0.1" : "opacity:1";
    }
    function Q(e) {
      return Object.hasOwn(i.value, "x") ? e.colorTarget : e.colorSource;
    }
    function Z(e) {
      return Object.hasOwn(i.value, "x") ? v.value.includes(e.id) && e.relationId === `${e.id}_${i.value.id}` || e.relationId === `${i.value.id}_${e.id}` ? `opacity:1;stroke-width:${te(e)}` : "opacity: 0" : "opacity: 1";
    }
    function ye(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? "end" : "start";
    }
    function he(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? e.x - 5 : e.x + 5;
    }
    function me(e) {
      return Object.hasOwn(i.value, "x") ? i.value.id === e.id || v.value.includes(e.id) ? "opacity:1" : "opacity:0.2" : "opacity:1";
    }
    function pe(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? `rotate(${e.regAngle + 180},${e.x},${e.y})` : `rotate(${e.regAngle},${e.x},${e.y})`;
    }
    function ee(e) {
      oe.value = 360 - e.regAngle, i.value.id && e.id === i.value.id ? (i.value = {}, v.value = []) : (i.value = e, v.value = [...e.relations]);
    }
    function te(e) {
      return e.weight / fe.value * l.value.style.links.maxWidth;
    }
    const w = s(!1);
    function ke(e) {
      w.value = e, M.value += 1;
    }
    const x = s(!1);
    function L() {
      x.value = !x.value;
    }
    return se({
      generatePdf: W,
      generateImage: X,
      toggleAnnotator: L
    }), (e, r) => (n(), u("div", {
      ref_key: "relationCircleChart",
      ref: _,
      class: "vue-ui-relation-circle",
      style: C(`width:100%;background:${l.value.style.backgroundColor};text-align:center;${l.value.responsive ? "height: 100%" : ""}`),
      id: `relation_circle_${k.value}`
    }, [
      l.value.userOptions.buttons.annotator ? (n(), A(We, {
        key: 0,
        parent: _.value,
        backgroundColor: l.value.style.backgroundColor,
        color: l.value.style.color,
        active: x.value,
        onClose: L
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      l.value.style.title.text ? (n(), u("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: j,
        style: "width:100%;background:transparent"
      }, [
        (n(), A(Be, {
          key: `title_${G.value}`,
          config: {
            title: {
              cy: "relation-div-title",
              ...l.value.style.title
            },
            subtitle: {
              cy: "relation-div-subtitle",
              ...l.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      l.value.userOptions.show && F.value ? (n(), A(Ue, {
        ref: "details",
        key: `user_options_${M.value}`,
        backgroundColor: l.value.style.backgroundColor,
        color: l.value.style.color,
        isPrinting: h(D),
        isImaging: h(V),
        uid: k.value,
        hasPdf: l.value.userOptions.buttons.pdf,
        hasImg: l.value.userOptions.buttons.img,
        hasFullscreen: l.value.userOptions.buttons.img,
        hasXls: !1,
        isFullscreen: w.value,
        titles: { ...l.value.userOptions.buttonTitles },
        chartElement: _.value,
        position: l.value.userOptions.position,
        hasAnnotator: l.value.userOptions.buttons.annotator,
        isAnnotation: x.value,
        onToggleFullscreen: ke,
        onGeneratePdf: h(W),
        onGenerateImage: h(X),
        onToggleAnnotator: L
      }, Ae({ _: 2 }, [
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: O(() => [
            m(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: O(() => [
            m(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: O(({ toggleFullscreen: t, isFullscreen: a }) => [
            m(e.$slots, "optionFullscreen", S(T({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: O(({ toggleAnnotator: t, isAnnotator: a }) => [
            m(e.$slots, "optionAnnotator", S(T({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      F.value ? (n(), u("svg", {
        key: 3,
        xmlns: h(Re),
        class: R([{ "vue-data-ui-fullscreen--on": w.value, "vue-data-ui-fulscreen--off": !w.value }, "relation-circle"]),
        viewBox: `0 0 ${o.value.width <= 0 ? 10 : o.value.width} ${o.value.height <= 0 ? 10 : o.value.height}`,
        width: "100%",
        style: "user-select:none; background:transparent"
      }, [
        Oe(Ve),
        Pe("circle", {
          cx: (o.value.width <= 0 ? 1e-4 : o.value.width) / 2,
          cy: (o.value.height <= 0 ? 1e-4 : o.value.height) / 2 + l.value.style.circle.offsetY,
          r: g.value <= 0 ? 1e-4 : g.value,
          stroke: l.value.style.circle.stroke,
          "stroke-width": l.value.style.circle.strokeWidth,
          fill: "transparent",
          class: "main-circle"
        }, null, 8, He),
        ue.value ? (n(), u("g", Je, [
          (n(!0), u(P, null, I(p.value, (t, a) => (n(), u("path", {
            key: `relation_${a}`,
            style: C(Z(t)),
            stroke: Q(t),
            class: R(["relation", { "vue-ui-relation-circle-selected": i.value.hasOwnProperty("id") && v.value.includes(t.id) }]),
            d: `M${t.x1},${t.y1} C${t.x1},${t.y1} ${o.value.width / 2},${o.value.height / 2 + l.value.style.circle.offsetY} ${t.x2},${t.y2}`,
            fill: "none",
            "stroke-width": te(t),
            "stroke-linecap": "round"
          }, null, 14, Ke))), 128))
        ])) : (n(), u("g", Qe, [
          (n(!0), u(P, null, I(p.value, (t, a) => (n(), u("line", {
            key: `relation_${a}`,
            stroke: Q(t),
            style: C(Z(t)),
            x1: t.x1,
            x2: t.x2,
            y1: t.y1,
            y2: t.y2,
            class: R({ "vue-ui-relation-circle-selected": i.value.hasOwnProperty("id") && v.value.includes(t.id) }),
            "stroke-linecap": "round"
          }, null, 14, Ze))), 128))
        ])),
        (n(!0), u(P, null, I(f.value, (t, a) => (n(), u("text", {
          key: `plot_text_${a}`,
          "text-anchor": ye(t),
          transform: pe(t),
          x: he(t),
          y: t.y + 5,
          onClick: ($) => ee(t),
          class: "vue-ui-relation-circle-legend",
          "transform-origin": "start",
          "font-weight": i.value.id === t.id ? "900" : "400",
          style: C(`font-family:${l.value.style.fontFamily};${me(t)}`),
          "font-size": l.value.style.labels.fontSize,
          fill: l.value.style.labels.color
        }, Ie(t.label), 13, et))), 128)),
        (n(!0), u(P, null, I(f.value, (t, a) => (n(), u("circle", {
          cx: t.x,
          cy: t.y,
          key: `plot_${a}`,
          style: C(ge(t)),
          class: "vue-ui-relation-circle-plot",
          fill: l.value.style.plot.color,
          onClick: ($) => ee(t),
          r: l.value.style.plot.radius
        }, null, 12, tt))), 128)),
        m(e.$slots, "svg", { svg: o.value }, void 0, !0)
      ], 10, qe)) : y("", !0),
      e.$slots.watermark ? (n(), u("div", lt, [
        m(e.$slots, "watermark", S(T({ isPrinting: h(D) || h(V) })), void 0, !0)
      ])) : y("", !0),
      e.$slots.source ? (n(), u("div", {
        key: 5,
        ref_key: "source",
        ref: B,
        dir: "auto"
      }, [
        m(e.$slots, "source", {}, void 0, !0)
      ], 512)) : y("", !0),
      F.value ? y("", !0) : (n(), A(De, {
        key: 6,
        config: {
          type: "relationCircle",
          style: {
            backgroundColor: l.value.style.backgroundColor,
            relationCircle: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Ye));
  }
}, gt = /* @__PURE__ */ Xe(nt, [["__scopeId", "data-v-3dcfe3a3"]]);
export {
  gt as default
};
