import { ref as n, computed as d, watch as Me, onMounted as ze, onBeforeUnmount as Re, openBlock as u, createElementBlock as y, normalizeClass as W, normalizeStyle as F, createBlock as _, createCommentVNode as $, unref as i, createSlots as Ve, withCtx as p, renderSlot as h, normalizeProps as O, guardReactiveProps as M, createVNode as ge, createElementVNode as k, Fragment as fe, renderList as ye, createTextVNode as me, toDisplayString as E, nextTick as Be } from "vue";
import { u as De, c as be, t as Ue, a as We, p as x, o as Ee, e as Y, g as Ge, b as He, I as Xe, d as ke, f as N, X as je, s as Ye, w as qe, v as q, i as Ce, x as Je, y as Ke, q as Qe, r as Ze } from "./index-Bya_q1J-.js";
import { t as et, u as tt } from "./useResponsive-BY8tgM1n.js";
import { _ as lt } from "./Title-C5pIfQAz.js";
import { u as ot, U as at } from "./usePrinter-CiHd1FwD.js";
import { _ as st } from "./Tooltip-Cz24YLfw.js";
import { D as nt } from "./DataTable-DYqC2pqu.js";
import { L as rt } from "./Legend-DNgTCgEK.js";
import ut from "./vue-ui-skeleton-BYssP0K4.js";
import it from "./vue-ui-accordion-DfUfL2dI.js";
import { u as we } from "./useNestedProp-B33hazbH.js";
import { _ as vt } from "./PackageVersion-VkaUzgmt.js";
import { P as ct } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as dt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const pt = ["id"], ht = ["xmlns", "viewBox"], gt = ["id"], ft = ["stop-color"], yt = ["stop-color"], mt = ["stroke", "cx", "cy", "r", "fill"], bt = ["stroke", "stroke-width", "cx", "cy", "r", "fill"], kt = ["cx", "cy", "r", "onMouseenter"], Ct = {
  key: 4,
  class: "vue-data-ui-watermark"
}, wt = ["onClick"], $t = { key: 0 }, Tt = { key: 1 }, _t = ["innerHTML"], xt = {
  __name: "vue-ui-rings",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup($e, { expose: Te, emit: _e }) {
    const f = $e, { vue_ui_rings: xe } = De(), L = n(!1), z = d(() => !!f.dataset && f.dataset.length), S = n(be()), Ne = n(null), R = n(!1), G = n(""), T = n(null), J = n(0), P = n(null), K = n(null), Q = n(null), Z = n(null), ee = n(0), te = n(0), le = n(0), e = d({
      get: () => oe(),
      set: (t) => t
    });
    function oe() {
      const t = we({
        userConfig: f.config,
        defaultConfig: xe
      });
      return t.theme ? {
        ...we({
          userConfig: Ue.vue_ui_rings[t.theme] || f.config,
          defaultConfig: t
        }),
        customPalette: We[t.theme] || x
      } : t;
    }
    Me(() => f.config, (t) => {
      e.value = oe(), ae(), ee.value += 1, te.value += 1, le.value += 1;
    }, { deep: !0 });
    const V = n(null);
    ze(() => {
      ae();
    });
    function ae() {
      if (Ee(f.dataset) ? Y({
        componentName: "VueUiRings",
        type: "dataset"
      }) : f.dataset.forEach((t, o) => {
        t.values.length || Y({
          componentName: "VueUiRings",
          type: "dataset"
        }), Ge({
          datasetObject: t,
          requiredAttributes: ["name", "values"]
        }).forEach((l) => {
          Y({
            componentName: "VueUiRings",
            type: "datasetSerieAttribute",
            property: l,
            index: o
          });
        });
      }), e.value.responsive) {
        const t = et(() => {
          const { width: o, height: l } = tt({
            chart: P.value,
            title: e.value.style.chart.title.text ? K.value : null,
            legend: e.value.style.chart.legend.show ? Q.value : null,
            source: Z.value
          });
          r.value.width = o, r.value.height = l;
        });
        V.value = new ResizeObserver(t), V.value.observe(P.value.parentNode);
      }
      setTimeout(() => {
        L.value = !0;
      }, 600);
    }
    Re(() => {
      V.value && V.value.disconnect();
    });
    const { isPrinting: se, isImaging: ne, generatePdf: re, generateImage: ue } = ot({
      elementId: `rings_${S.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-rings"
    }), ie = d(() => He(e.value.customPalette)), C = n({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), r = n({
      height: 360,
      width: 360
    }), Pe = d(() => Math.min(r.value.height, r.value.width)), v = n([]);
    function H(t) {
      v.value.includes(t) ? v.value = v.value.filter((o) => o !== t) : v.value.push(t), _e("selectLegend", c.value.map((o) => ({
        name: o.name,
        color: o.color,
        value: o.value
      })));
    }
    const Le = d(() => Math.max(
      ...B.value.filter((t) => !v.value.includes(t.uid)).map(({ value: t }) => t)
    ));
    function ve(t) {
      return t / Le.value;
    }
    const B = d(() => f.dataset.map(({ values: t, name: o, color: l = null }, a) => {
      const s = Xe(t).reduce((b, I) => b + I, 0);
      return {
        name: o,
        color: l || ke(l) || ie.value[a] || x[a] || x[a % x.length],
        value: s,
        proportion: s / f.dataset.map((b) => (b.values || []).reduce((I, Oe) => I + Oe, 0)).reduce((b, I) => b + I, 0),
        uid: be()
      };
    })), ce = d(() => B.value.map((t) => ({
      ...t,
      shape: "circle",
      opacity: v.value.includes(t.uid) ? 0.5 : 1,
      segregate: () => H(t.uid),
      isSegregated: v.value.includes(t.uid)
    })).toSorted((t, o) => o.value - t.value)), Se = d(() => ({
      cy: "rings-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), m = d(() => B.value.filter((t) => !v.value.includes(t.uid)).map(({ value: t }) => t).reduce((t, o) => t + o, 0)), c = d(() => B.value.filter((t) => !v.value.includes(t.uid)).map(({ name: t, value: o, color: l = null, uid: a }, s) => ({
      uid: a,
      name: t,
      color: l || ke(l) || ie.value[s] || x[s] || x[s % x.length],
      value: o,
      proportion: ve(o),
      percentage: o / m.value * 100,
      strokeWidth: e.value.style.chart.layout.rings.strokeWidth * ve(o)
    })).toSorted((t, o) => o.value - t.value));
    function Ae() {
      return c.value.map(
        ({ name: t, color: o, value: l, absoluteValues: a, percentage: s }) => ({
          name: t,
          color: o,
          value: l,
          absoluteValues: a,
          percentage: s
        })
      );
    }
    const g = d(() => Pe.value - e.value.style.chart.layout.rings.strokeWidth * 2), X = n(null);
    function Ie(t, o) {
      if (v.value.length === f.dataset.length) return;
      X.value = {
        datapoint: o,
        seriesIndex: t,
        series: c.value,
        config: e.value
      }, T.value = t;
      const l = c.value[t], a = e.value.style.chart.tooltip.customFormat;
      if (Je(a) && Ke(() => a({
        seriesIndex: t,
        datapoint: o,
        series: c.value,
        config: e.value
      })))
        G.value = a({
          seriesIndex: t,
          datapoint: o,
          series: c.value,
          config: e.value
        });
      else {
        let s = "";
        s += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, s += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}" /></svg>`, e.value.style.chart.tooltip.showValue && (s += `<b>${Ce(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          l.value,
          N({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: o, seriesIndex: t }
        )}
      </b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? s += `<span>(${N({
          v: l.value / m.value * 100,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })})</span></div>` : s += `<b>${N({
          v: l.value / m.value * 100,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })}</b></div>`), G.value = s;
      }
      R.value = !0;
    }
    const w = d(() => {
      const t = c.value.map((l) => ({
        name: l.name,
        color: l.color
      })), o = c.value.map((l) => l.value);
      return { head: t, body: o };
    }), D = d(() => {
      const t = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        N({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: m.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], o = w.value.head.map((s, b) => [
        {
          color: s.color,
          name: s.name
        },
        N({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: w.value.body[b], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        isNaN(w.value.body[b] / m.value) ? "-" : (w.value.body[b] / m.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
      ]), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, a = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ];
      return {
        head: t,
        body: o,
        config: l,
        colNames: a
      };
    });
    function de() {
      Be(() => {
        const t = w.value.head.map((a, s) => [[
          a.name
        ], [w.value.body[s]], [isNaN(w.value.body[s] / m.value) ? "-" : w.value.body[s] / m.value * 100]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), l = Qe(o);
        Ze({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-rings" });
      });
    }
    const A = n(!1);
    function Fe(t) {
      A.value = t, J.value += 1;
    }
    function pe() {
      C.value.showTable = !C.value.showTable;
    }
    function he() {
      C.value.showTooltip = !C.value.showTooltip;
    }
    const U = n(!1);
    function j() {
      U.value = !U.value;
    }
    return Te({
      getData: Ae,
      generatePdf: re,
      generateCsv: de,
      generateImage: ue,
      toggleTable: pe,
      toggleTooltip: he,
      toggleAnnotator: j
    }), (t, o) => (u(), y("div", {
      ref_key: "ringsChart",
      ref: P,
      class: W(`vue-ui-rings ${A.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: F(`font-family:${e.value.style.fontFamily};text-align:center;width:100%;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`),
      id: `rings_${S.value}`,
      onMouseleave: o[3] || (o[3] = (l) => {
        T.value = null, R.value = !1;
      })
    }, [
      e.value.userOptions.buttons.annotator ? (u(), _(ct, {
        key: 0,
        parent: P.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: U.value,
        onClose: j
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : $("", !0),
      e.value.style.chart.title.text ? (u(), y("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: K,
        style: "width:100%;background:transparent"
      }, [
        (u(), _(lt, {
          key: `title_${ee.value}`,
          config: {
            title: {
              cy: "rings-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "rings-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : $("", !0),
      e.value.userOptions.show && z.value ? (u(), _(at, {
        ref_key: "details",
        ref: Ne,
        key: `user_options_${J.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: i(se),
        isImaging: i(ne),
        uid: S.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: C.value.showTooltip,
        isFullscreen: A.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: P.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: U.value,
        onToggleFullscreen: Fe,
        onGeneratePdf: i(re),
        onGenerateCsv: de,
        onGenerateImage: i(ue),
        onToggleTable: pe,
        onToggleTooltip: he,
        onToggleAnnotator: j
      }, Ve({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: p(() => [
            h(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: p(() => [
            h(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: p(() => [
            h(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: p(() => [
            h(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: p(() => [
            h(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: p(({ toggleFullscreen: l, isFullscreen: a }) => [
            h(t.$slots, "optionFullscreen", O(M({ toggleFullscreen: l, isFullscreen: a })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: p(({ toggleAnnotator: l, isAnnotator: a }) => [
            h(t.$slots, "optionAnnotator", O(M({ toggleAnnotator: l, isAnnotator: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : $("", !0),
      z.value ? (u(), y("svg", {
        key: 3,
        xmlns: i(je),
        class: W({ "vue-data-ui-fullscreen--on": A.value, "vue-data-ui-fulscreen--off": !A.value }),
        viewBox: `0 0 ${r.value.width <= 0 ? 10 : r.value.width} ${r.value.height <= 0 ? 10 : r.value.height}`,
        style: F(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ge(vt),
        k("defs", null, [
          (u(!0), y(fe, null, ye(c.value, (l, a) => (u(), y("radialGradient", {
            cx: "50%",
            cy: "30%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `gradient_${S.value}_${a}`
          }, [
            k("stop", {
              offset: "0%",
              "stop-color": i(Ye)(i(qe)(l.color, 0.05), 100 - e.value.style.chart.layout.rings.gradient.intensity)
            }, null, 8, ft),
            k("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, yt)
          ], 8, gt))), 256))
        ]),
        (u(!0), y(fe, null, ye(c.value, (l, a) => (u(), y("g", null, [
          k("circle", {
            class: W({
              "vue-ui-rings-item": L.value && e.value.useCssAnimation,
              "vue-rings-item-onload": !L.value && e.value.useCssAnimation,
              "vue-ui-rings-opacity": T.value !== null && T.value !== a
            }),
            style: F(`animation-delay:${a * 100}ms`),
            stroke: e.value.style.chart.layout.rings.stroke,
            cx: r.value.width / 2,
            cy: a === 0 ? r.value.height / 2 : r.value.height / 2 + g.value * c.value[0].proportion / 2 - g.value * l.proportion / 2 - 2 * (a + 1),
            r: i(q)(g.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : g.value * l.proportion / 2 * 0.9),
            fill: e.value.style.chart.layout.rings.gradient.underlayerColor
          }, null, 14, mt),
          k("circle", {
            class: W({
              "vue-ui-rings-item": L.value && e.value.useCssAnimation,
              "vue-rings-item-onload": !L.value && e.value.useCssAnimation,
              "vue-ui-rings-shadow": e.value.style.chart.layout.rings.useShadow,
              "vue-ui-rings-blur": T.value !== null && T.value !== a
            }),
            style: F(`animation-delay:${a * 100}ms`),
            stroke: e.value.style.chart.layout.rings.stroke,
            "stroke-width": l.strokeWidth < 0.5 ? 0.5 : l.strokeWidth,
            cx: r.value.width / 2,
            cy: a === 0 ? r.value.height / 2 : r.value.height / 2 + g.value * c.value[0].proportion / 2 - g.value * l.proportion / 2 - 2 * (a + 1),
            r: i(q)(g.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : g.value * l.proportion / 2 * 0.9),
            fill: e.value.style.chart.layout.rings.gradient.show ? `url(#gradient_${S.value}_${a})` : l.color
          }, null, 14, bt),
          k("circle", {
            "data-cy-trap": "",
            stroke: "none",
            cx: r.value.width / 2,
            cy: a === 0 ? r.value.height / 2 : r.value.height / 2 + g.value * c.value[0].proportion / 2 - g.value * l.proportion / 2 - 2 * (a + 1),
            r: i(q)(g.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : g.value * l.proportion / 2 * 0.9),
            fill: "transparent",
            onMouseenter: (s) => Ie(a, l),
            onMouseleave: o[0] || (o[0] = (s) => {
              T.value = null, R.value = !1;
            })
          }, null, 40, kt)
        ]))), 256)),
        h(t.$slots, "svg", { svg: r.value }, void 0, !0)
      ], 14, ht)) : $("", !0),
      t.$slots.watermark ? (u(), y("div", Ct, [
        h(t.$slots, "watermark", O(M({ isPrinting: i(se) || i(ne) })), void 0, !0)
      ])) : $("", !0),
      z.value ? $("", !0) : (u(), _(ut, {
        key: 5,
        config: {
          type: "rings",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            rings: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      k("div", {
        ref_key: "chartLegend",
        ref: Q
      }, [
        e.value.style.chart.legend.show ? (u(), _(rt, {
          key: `legend_${le.value}`,
          legendSet: ce.value,
          config: Se.value,
          onClickMarker: o[1] || (o[1] = ({ legend: l }) => H(l.uid))
        }, {
          item: p(({ legend: l, index: a }) => [
            k("div", {
              "data-cy-legend-item": "",
              onClick: (s) => H(l.uid),
              style: F(`opacity:${v.value.includes(l.uid) ? 0.5 : 1}`)
            }, [
              me(E(l.name) + ": " + E(i(Ce)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                i(N)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l, seriesIndex: a }
              )) + " ", 1),
              v.value.includes(l.uid) ? (u(), y("span", Tt, " ( - % ) ")) : (u(), y("span", $t, " (" + E(isNaN(l.value / m.value) ? "-" : i(N)({
                v: l.value / m.value * 100,
                s: "%",
                r: e.value.style.chart.legend.roundingPercentage
              })) + ") ", 1))
            ], 12, wt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : h(t.$slots, "legend", {
          key: 1,
          legend: ce.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (u(), y("div", {
        key: 6,
        ref_key: "source",
        ref: Z,
        dir: "auto"
      }, [
        h(t.$slots, "source", {}, void 0, !0)
      ], 512)) : $("", !0),
      ge(st, {
        show: C.value.showTooltip && R.value && v.value.length < f.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: P.value,
        content: G.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": p(() => [
          h(t.$slots, "tooltip-before", O(M({ ...X.value })), void 0, !0)
        ]),
        "tooltip-after": p(() => [
          h(t.$slots, "tooltip-after", O(M({ ...X.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      z.value ? (u(), _(it, {
        key: 7,
        hideDetails: "",
        config: {
          open: C.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: p(() => [
          (u(), _(nt, {
            key: `table_${te.value}`,
            colNames: D.value.colNames,
            head: D.value.head,
            body: D.value.body,
            config: D.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[2] || (o[2] = (l) => C.value.showTable = !1)
          }, {
            th: p(({ th: l }) => [
              k("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, _t)
            ]),
            td: p(({ td: l }) => [
              me(E(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : $("", !0)
    ], 46, pt));
  }
}, Ut = /* @__PURE__ */ dt(xt, [["__scopeId", "data-v-eda91fd5"]]);
export {
  Ut as default
};
