import { computed as k, ref as h, watch as Ke, onMounted as Qe, onBeforeUnmount as Ze, openBlock as o, createElementBlock as r, normalizeClass as Ie, normalizeStyle as q, createBlock as Y, createCommentVNode as c, unref as v, createSlots as et, withCtx as _, renderSlot as $, normalizeProps as Q, guardReactiveProps as Z, createVNode as he, createElementVNode as d, Fragment as P, renderList as X, toDisplayString as M, createTextVNode as tt, nextTick as lt } from "vue";
import { u as at, c as ot, t as st, a as ut, p as U, o as rt, e as pe, b as it, g as De, R as nt, V as vt, X as yt, T as ct, s as fe, i as j, v as C, f as W, x as dt, y as ht, q as pt, r as ft } from "./index-Bya_q1J-.js";
import { t as gt, u as xt } from "./useResponsive-BY8tgM1n.js";
import { _ as mt } from "./Title-C5pIfQAz.js";
import { u as bt, U as kt } from "./usePrinter-CiHd1FwD.js";
import { _ as _t } from "./Tooltip-Cz24YLfw.js";
import { L as wt } from "./Legend-DNgTCgEK.js";
import { _ as Ye } from "./Shape-Bwon0l0g.js";
import { D as $t } from "./DataTable-DYqC2pqu.js";
import Mt from "./vue-ui-skeleton-BYssP0K4.js";
import Ct from "./vue-ui-accordion-DfUfL2dI.js";
import { u as je } from "./useNestedProp-B33hazbH.js";
import { _ as zt } from "./PackageVersion-VkaUzgmt.js";
import { P as At } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as St } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Lt = ["id"], Tt = ["xmlns", "viewBox"], Bt = { key: 0 }, Nt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Pt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Wt = { key: 1 }, Ot = ["points", "fill", "stroke-width", "stroke-dasharray", "stroke"], Ft = { key: 0 }, Xt = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onMouseover"], It = { key: 1 }, Dt = { key: 2 }, Yt = ["id"], jt = ["stop-color"], Vt = ["stop-color"], Et = ["id"], Gt = ["stop-color"], Rt = ["stop-color"], qt = ["x", "y", "width", "height", "fill", "stroke", "stroke-width", "rx"], Ut = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], Ht = { key: 0 }, Jt = ["d", "stroke", "stroke-width"], Kt = ["d", "stroke", "stroke-width"], Qt = ["d", "stroke", "stroke-width"], Zt = ["d", "stroke", "stroke-width"], el = {
  key: 3,
  style: { "pointer-events": "none !important" }
}, tl = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ll = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], al = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], ol = ["x", "y", "font-size", "fill", "font-weight"], sl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], ul = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], rl = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], il = { key: 4 }, nl = ["x", "y", "font-size", "fill"], vl = ["x", "y", "font-size", "fill"], yl = ["id", "transform", "font-size", "font-weight", "fill"], cl = { key: 5 }, dl = ["x", "y", "font-size", "fill"], hl = ["x", "y", "font-size", "fill"], pl = ["font-size", "font-weight", "fill", "x", "y"], fl = ["id"], gl = ["x", "y", "width", "height"], xl = { key: 6 }, ml = ["x1", "x2", "y1", "y2", "stroke-dasharray", "stroke", "stroke-width", "clip-path"], bl = ["x", "y", "fill", "font-size", "font-weight"], kl = {
  key: 4,
  class: "vue-data-ui-watermark"
}, _l = ["onClick"], wl = {
  key: 0,
  style: { width: "100%", display: "flex", "align-items": "center", "justify-content": "center" }
}, $l = {
  viewBox: "0 0 20 20",
  height: "20",
  width: "20",
  style: { overflow: "hidden", background: "transparent" }
}, Ml = { key: 0 }, Cl = ["innerHTML"], zl = {
  __name: "vue-ui-scatter",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(Ve, { expose: Ee }) {
    const O = Ve, { vue_ui_scatter: Ge } = at(), ee = k(() => !!O.dataset && O.dataset.length), z = h(ot()), Re = h(null), ue = h(!1), re = h(""), ge = h(0), H = h(null), xe = h(null), me = h(null), be = h(null), ke = h(0), _e = h(0), we = h(0), e = k({
      get: () => $e(),
      set: (l) => l
    });
    function $e() {
      const l = je({
        userConfig: O.config,
        defaultConfig: Ge
      });
      return l.theme ? {
        ...je({
          userConfig: st.vue_ui_scatter[l.theme] || O.config,
          defaultConfig: l
        }),
        customPalette: ut[l.theme] || U
      } : l;
    }
    Ke(() => O.config, (l) => {
      e.value = $e(), Me(), ke.value += 1, _e.value += 1, we.value += 1;
    }, { deep: !0 });
    const te = h(null);
    Qe(() => {
      Me();
    });
    function Me() {
      if (rt(O.dataset) && pe({
        componentName: "VueUiScatter",
        type: "dataset"
      }), e.value.responsive) {
        const l = gt(() => {
          const { width: i, height: t } = xt({
            chart: H.value,
            title: e.value.style.title.text ? xe.value : null,
            legend: e.value.style.legend.show ? me.value : null,
            source: be.value
          });
          A.value.width = i, A.value.height = t;
        });
        te.value = new ResizeObserver(l), te.value.observe(H.value.parentNode);
      }
    }
    Ze(() => {
      te.value && te.value.disconnect();
    });
    const { isPrinting: Ce, isImaging: ze, generatePdf: Ae, generateImage: Se } = bt({
      elementId: `vue-ui-scatter_${z.value}`,
      fileName: e.value.style.title.text || "vue-ui-scatter"
    }), Le = k(() => it(e.value.customPalette)), I = h({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), A = h({
      height: e.value.style.layout.height,
      width: e.value.style.layout.width
    }), le = k(() => e.value.style.layout.marginalBars.show ? e.value.style.layout.marginalBars.size + e.value.style.layout.marginalBars.offset : 0), u = k(() => ({
      top: e.value.style.layout.padding.top + le.value,
      right: A.value.width - e.value.style.layout.padding.right - le.value,
      bottom: A.value.height - e.value.style.layout.padding.bottom,
      left: e.value.style.layout.padding.left,
      height: A.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom - le.value,
      width: A.value.width - e.value.style.layout.padding.left - e.value.style.layout.padding.right - le.value
    })), p = k(() => {
      O.dataset.forEach((a, n) => {
        De({
          datasetObject: a,
          requiredAttributes: ["values"]
        }).forEach((m) => {
          pe({
            componentName: "VueUiScatter",
            type: "datasetSerieAttribute",
            property: m,
            index: n
          });
        }), a.values && a.values.forEach((m, E) => {
          De({
            datasetObject: m,
            requiredAttributes: ["x", "y"]
          }).forEach((J) => {
            pe({
              componentName: "VueUiScatter",
              type: "datasetSerieAttribute",
              property: `values.${J}`,
              index: `${n} - ${E}`
            });
          });
        });
      });
      const l = Math.min(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), i = Math.max(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), t = Math.min(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y))), s = Math.max(...V.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y)));
      return { xMin: l >= 0 ? 0 : l, xMax: i, yMin: t >= 0 ? 0 : t, yMax: s };
    }), f = k(() => ({
      x: u.value.left + Math.abs(p.value.xMin) / (p.value.xMax + Math.abs(p.value.xMin)) * u.value.width,
      y: u.value.bottom - Math.abs(p.value.yMin) / (p.value.yMax + Math.abs(p.value.yMin)) * u.value.height
    })), V = k(() => O.dataset.map((l, i) => {
      const t = `cluster_${z.value}_${i}`;
      return {
        ...l,
        id: t,
        color: l.color ? l.color : Le.value[i] || U[i] || U[i % U.length],
        opacity: x.value.includes(t) ? 0.5 : 1,
        shape: l.shape ?? "circle",
        segregate: () => We(t),
        isSegregated: x.value.includes(t)
      };
    })), qe = k(() => ({
      cy: "scatter-div-legend",
      backgroundColor: e.value.style.legend.backgroundColor,
      color: e.value.style.legend.color,
      fontSize: e.value.style.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.legend.bold ? "bold" : ""
    })), ie = k(() => V.value.map((l, i) => ({
      ...l,
      plots: l.values.map((t) => ({
        x: u.value.left + (t.x + Math.abs(p.value.xMin)) / (p.value.xMax + Math.abs(p.value.xMin)) * u.value.width,
        y: u.value.bottom - (t.y + Math.abs(p.value.yMin)) / (p.value.yMax + Math.abs(p.value.yMin)) * u.value.height,
        v: {
          ...t,
          name: t.name || ""
        },
        clusterName: l.name,
        color: l.color ? l.color : Le.value[i] || U[i] || U[i % U.length],
        id: `plot_${z.value}_${Math.random()}`,
        weight: t.weight ?? e.value.style.layout.plots.radius
      }))
    })).filter((l) => !x.value.includes(l.id))), S = k(() => ie.value.map((l) => {
      const i = l.plots.reduce((g, G) => g + G.x, 0) / l.plots.length, t = l.plots.reduce((g, G) => g + G.y, 0) / l.plots.length;
      let s = 0, a = 0, n = 0;
      for (const g of l.plots)
        s += (g.x - i) * (g.y - t), a += (g.x - i) ** 2, n += (g.y - t) ** 2;
      const m = s / Math.sqrt(a * n), E = m * (Math.sqrt(n) / Math.sqrt(a)), J = t - E * i, N = {
        x1: u.value.left,
        x2: u.value.right,
        y1: E * u.value.left + J,
        y2: E * u.value.right + J,
        coefficient: m
      }, w = (N.y2 - N.y1) / (N.x2 - N.x1), T = N.y1 - w * N.x1, F = Math.min(A.value.width - e.value.style.layout.padding.right, Math.max(e.value.style.layout.padding.left, (u.value.top - T) / w)), se = {
        x: F,
        y: w * F + T <= e.value.style.layout.padding.top ? u.value.top : w * F + T
      };
      return {
        ...l,
        correlation: N,
        label: se,
        plots: l.plots.map((g) => {
          const G = (g.x + w * g.y - w * T) / (1 + Math.pow(w, 2)), ye = (w * g.x + Math.pow(w, 2) * g.y + T) / (1 + Math.pow(w, 2)), b = Math.sqrt(Math.pow(g.x - G, 2) + Math.pow(g.y - ye, 2));
          return {
            ...g,
            deviation: b,
            shape: l.shape,
            color: l.color
          };
        })
      };
    })), Te = k(() => Math.max(...S.value.flatMap((l) => l.plots.map((i) => Math.abs(i.deviation)))));
    function Ue() {
      return S.value;
    }
    function Be(l, i) {
      const t = Array.isArray(l) ? l.flatMap((b) => b.plots.map((R) => ({
        x: R.x,
        y: R.y
      }))) : l.plots.map((b) => ({
        x: b.x,
        y: b.y
      }));
      let s = 1 / 0, a = -1 / 0, n = 1 / 0, m = -1 / 0;
      t.forEach(({ x: b, y: R }) => {
        s = Math.min(s, b), a = Math.max(a, b), n = Math.min(n, R), m = Math.max(m, R);
      });
      const E = a - s, J = m - n, N = E / i, w = J / i, T = Array(i).fill(0), F = Array(i).fill(0);
      t.forEach(({ x: b, y: R }) => {
        const ce = Math.floor((b - s) / N), de = Math.floor((R - n) / w);
        T[ce] || (T[ce] = 0), F[de] || (F[de] = 0), T[ce] += 1, F[de] += 1;
      });
      const se = [], g = [];
      for (let b = 0; b < i; b += 1)
        se.push(s + (b + 0.5) * N), g.push(n + (b + 0.5) * w);
      const G = Math.max(...T), ye = Math.max(...F);
      return { x: T, y: F, avgX: se, avgY: g, maxX: G, maxY: ye };
    }
    const D = k(() => e.value.style.layout.marginalBars.tranches), L = k(() => Be(ie.value, D.value)), He = k(() => {
      const l = u.value.top - e.value.style.layout.marginalBars.offset, i = u.value.right + e.value.style.layout.marginalBars.offset;
      return ie.value.map((t) => {
        const s = Be(t, D.value);
        return {
          coords: s,
          dX: nt(s.avgX.map((a, n) => ({
            x: a,
            y: l - s.x[n] / s.maxX * e.value.style.layout.marginalBars.size
          }))),
          dY: vt(s.avgY.map((a, n) => ({
            y: a,
            x: i + e.value.style.layout.marginalBars.size * s.y[n] / s.maxY
          }))),
          color: t.color,
          id: t.id
        };
      });
    }), B = h(void 0), y = h(null), ne = h(null);
    function Ne(l, i) {
      B.value = l.id, y.value = l;
      let t = "";
      ne.value = {
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      };
      const s = e.value.style.tooltip.customFormat;
      dt(s) && ht(() => s({
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      })) ? re.value = s({
        datapoint: l,
        seriesIndex: i,
        series: S.value,
        config: e.value
      }) : (l.clusterName && (t += `<div style="display:flex;gap:3px;align-items:center">${l.clusterName}</div>`), l.v.name && (t += `<div>${l.v.name}</div>`), t += `<div style="text-align:left;margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, t += `<div>${e.value.style.layout.dataLabels.xAxis.name}: <b>${isNaN(l.v.x) ? "-" : j(
        e.value.style.layout.plots.selectors.labels.x.formatter,
        l.v.x,
        W({
          p: e.value.style.tooltip.prefix,
          v: l.v.x,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `<div>${e.value.style.layout.dataLabels.yAxis.name}: <b>${isNaN(l.v.y) ? "-" : j(
        e.value.style.layout.plots.selectors.labels.y.formatter,
        l.v.y,
        W({
          p: e.value.style.tooltip.prefix,
          v: l.v.y,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `${e.value.style.layout.plots.deviation.translation}: <b>${W({
        v: l.deviation,
        r: e.value.style.layout.plots.deviation.roundingValue
      })}</b>`, t += "</div>", re.value = `<div>${t}</div>`), ue.value = !0;
    }
    function Pe() {
      ue.value = !1, B.value = void 0, y.value = null;
    }
    const x = h([]);
    function We(l) {
      x.value.includes(l) ? x.value = x.value.filter((i) => i !== l) : x.value.length < O.dataset.length - 1 && x.value.push(l);
    }
    function Oe() {
      lt(() => {
        const l = ["", e.value.table.translations.correlationCoefficient, e.value.table.translations.nbrPlots, `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`, `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`], i = S.value.map((a) => [
          a.name,
          a.correlation.coefficient,
          a.plots.length,
          a.plots.map((n) => n.v.x).reduce((n, m) => n + m, 0) / a.plots.length,
          a.plots.map((n) => n.v.y).reduce((n, m) => n + m, 0) / a.plots.length
        ]), t = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([l]).concat(i), s = pt(t);
        ft({ csvContent: s, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const ae = k(() => {
      const l = [
        e.value.table.translations.series,
        e.value.table.translations.correlationCoefficient,
        e.value.table.translations.nbrPlots,
        `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`,
        `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`
      ], i = S.value.map((s) => [
        {
          shape: s.shape,
          content: s.name,
          color: s.color
        },
        Number((s.correlation.coefficient ?? 0).toFixed(e.value.table.td.roundingValue)).toLocaleString(),
        s.plots.length.toLocaleString(),
        Number((s.plots.map((a) => a.v.x ?? 0).reduce((a, n) => a + n, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString(),
        Number((s.plots.map((a) => a.v.y ?? 0).reduce((a, n) => a + n, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString()
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: l, body: i, config: t, colNames: l };
    }), K = h(!1);
    function Je(l) {
      K.value = l, ge.value += 1;
    }
    function Fe() {
      I.value.showTable = !I.value.showTable;
    }
    function Xe() {
      I.value.showTooltip = !I.value.showTooltip;
    }
    const oe = h(!1);
    function ve() {
      oe.value = !oe.value;
    }
    return Ee({
      getData: Ue,
      generatePdf: Ae,
      generateCsv: Oe,
      generateImage: Se,
      toggleTable: Fe,
      toggleTooltip: Xe,
      toggleAnnotator: ve
    }), (l, i) => (o(), r("div", {
      class: Ie(`vue-ui-scatter ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "scatterChart",
      ref: H,
      id: `vue-ui-scatter_${z.value}`,
      style: q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (o(), Y(At, {
        key: 0,
        parent: H.value,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        active: oe.value,
        onClose: ve
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      e.value.style.title.text ? (o(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: xe,
        style: "width:100%;background:transparent"
      }, [
        (o(), Y(mt, {
          key: `title_${ke.value}`,
          config: {
            title: {
              cy: "scatter-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "scatter-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && ee.value ? (o(), Y(kt, {
        ref_key: "details",
        ref: Re,
        key: `user_options_${ge.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: v(ze),
        isPrinting: v(Ce),
        uid: z.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: I.value.showTooltip,
        isFullscreen: K.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: H.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: oe.value,
        onToggleFullscreen: Je,
        onGeneratePdf: v(Ae),
        onGenerateCsv: Oe,
        onGenerateImage: v(Se),
        onToggleTable: Fe,
        onToggleTooltip: Xe,
        onToggleAnnotator: ve
      }, et({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: _(() => [
            $(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            $(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            $(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            $(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            $(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: t, isFullscreen: s }) => [
            $(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: s })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: t, isAnnotator: s }) => [
            $(l.$slots, "optionAnnotator", Q(Z({ toggleAnnotator: t, isAnnotator: s })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      ee.value ? (o(), r("svg", {
        key: 3,
        xmlns: v(yt),
        class: Ie({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${A.value.width <= 0 ? 10 : A.value.width} ${A.value.height <= 0 ? 10 : A.value.height}`,
        style: q(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.color}`)
      }, [
        he(zt),
        e.value.style.layout.axis.show ? (o(), r("g", Bt, [
          d("line", {
            x1: f.value.x,
            x2: f.value.x,
            y1: u.value.top,
            y2: u.value.bottom,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Nt),
          d("line", {
            x1: u.value.left,
            x2: u.value.right,
            y1: f.value.y,
            y2: f.value.y,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Pt)
        ])) : c("", !0),
        e.value.style.layout.plots.giftWrap.show ? (o(), r("g", Wt, [
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
            t.plots.length > 2 ? (o(), r("polygon", {
              key: 0,
              points: v(ct)({ series: t.plots }),
              fill: v(fe)(t.color, e.value.style.layout.plots.giftWrap.fillOpacity * 100),
              "stroke-width": e.value.style.layout.plots.giftWrap.strokeWidth,
              "stroke-dasharray": e.value.style.layout.plots.giftWrap.strokeDasharray,
              stroke: t.color,
              "stroke-linejoin": "round",
              "stroke-linecap": "round"
            }, null, 8, Ot)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
          !t.shape || t.shape === "circle" ? (o(), r("g", Ft, [
            (o(!0), r(P, null, X(t.plots, (a, n) => (o(), r("circle", {
              cx: a.x,
              cy: a.y,
              r: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              fill: v(fe)(t.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              "stroke-width": e.value.style.layout.plots.strokeWidth,
              onMouseover: (m) => Ne(a, s),
              onMouseleave: Pe,
              style: q(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Te.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 44, Xt))), 256))
          ])) : (o(), r("g", It, [
            (o(!0), r(P, null, X(t.plots, (a, n) => (o(), Y(Ye, {
              plot: { x: a.x, y: a.y },
              radius: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              shape: t.shape,
              color: v(fe)(t.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              strokeWidth: e.value.style.layout.plots.strokeWidth,
              onMouseover: (m) => Ne(a, s),
              onMouseleave: Pe,
              style: q(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Te.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 8, ["plot", "radius", "shape", "color", "stroke", "strokeWidth", "onMouseover", "style"]))), 256))
          ]))
        ]))), 256)),
        e.value.style.layout.marginalBars.show ? (o(), r("g", Dt, [
          d("defs", null, [
            d("linearGradient", {
              id: `marginal_x_${z.value}`,
              x1: "0%",
              y1: "0%",
              x2: "0%",
              y2: "100%"
            }, [
              d("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, jt),
              d("stop", {
                offset: "100%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Vt)
            ], 8, Yt),
            d("linearGradient", {
              id: `marginal_y_${z.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              d("stop", {
                offset: "0%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Gt),
              d("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Rt)
            ], 8, Et)
          ]),
          (o(!0), r(P, null, X(L.value.x, (t, s) => (o(), r("g", null, [
            t && L.value.avgX[s] ? (o(), r("rect", {
              key: 0,
              x: L.value.avgX[s] - u.value.width / D.value / 2,
              y: u.value.top - e.value.style.layout.marginalBars.offset - t / L.value.maxX * e.value.style.layout.marginalBars.size,
              width: u.value.width / D.value <= 0 ? 1e-4 : u.value.width / D.value,
              height: t / L.value.maxX * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / L.value.maxX * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_x_${z.value})` : e.value.style.layout.marginalBars.fill,
              style: q(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, qt)) : c("", !0)
          ]))), 256)),
          (o(!0), r(P, null, X(L.value.y, (t, s) => (o(), r("g", null, [
            t && L.value.avgY[s] ? (o(), r("rect", {
              key: 0,
              x: u.value.right + e.value.style.layout.marginalBars.offset,
              y: L.value.avgY[s] - u.value.height / D.value / 2,
              height: u.value.height / D.value <= 0 ? 1e-4 : u.value.height / D.value,
              width: t / L.value.maxY * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / L.value.maxY * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_y_${z.value})` : e.value.style.layout.marginalBars.fill,
              style: q(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, Ut)) : c("", !0)
          ]))), 256)),
          e.value.style.layout.marginalBars.showLines ? (o(), r("g", Ht, [
            (o(!0), r(P, null, X(He.value, (t) => (o(), r(P, null, [
              x.value.includes(t.id) ? c("", !0) : (o(), r("path", {
                key: 0,
                d: `M ${t.dX}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Jt)),
              x.value.includes(t.id) ? c("", !0) : (o(), r("path", {
                key: 1,
                d: `M ${t.dX}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Kt)),
              x.value.includes(t.id) ? c("", !0) : (o(), r("path", {
                key: 2,
                d: `M ${t.dY}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Qt)),
              x.value.includes(t.id) ? c("", !0) : (o(), r("path", {
                key: 3,
                d: `M ${t.dY}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Zt))
            ], 64))), 256))
          ])) : c("", !0)
        ])) : c("", !0),
        y.value && e.value.style.layout.plots.selectors.show ? (o(), r("g", el, [
          d("line", {
            x1: f.value.x,
            x2: y.value.x,
            y1: y.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, tl),
          d("line", {
            x1: y.value.x,
            x2: y.value.x,
            y1: f.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, ll),
          d("text", {
            x: f.value.x + (y.value.x > f.value.x ? -6 : 6),
            y: y.value.y + e.value.style.layout.plots.selectors.labels.fontSize / 3,
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x > f.value.x ? "end" : "start"
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v(C)(y.value.v.y),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(y.value.v.y),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, al),
          d("text", {
            x: y.value.x,
            y: f.value.y + (y.value.y > f.value.y ? -6 : e.value.style.layout.plots.selectors.labels.fontSize + 6),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v(C)(y.value.v.x),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(y.value.v.x),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, ol),
          d("circle", {
            cx: f.value.x,
            cy: y.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, sl),
          d("circle", {
            cx: y.value.x,
            cy: f.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, ul),
          e.value.style.layout.plots.selectors.labels.showName ? (o(), r("text", {
            key: 0,
            x: y.value.x,
            y: y.value.y + (y.value.y < f.value.y ? -e.value.style.layout.plots.selectors.labels.fontSize / 2 : e.value.style.layout.plots.selectors.labels.fontSize),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x < u.value.left + 100 ? "start" : y.value.x > u.value.right - 100 ? "end" : y.value.x > f.value.x ? "start" : "end"
          }, M(y.value.v.name), 9, rl)) : c("", !0)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.xAxis.show ? (o(), r("g", il, [
          d("text", {
            x: u.value.left - 5,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "end",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            v(C)(p.value.xMin),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(p.value.xMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, nl),
          d("text", {
            x: u.value.right + 3,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "start",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            v(C)(p.value.xMax),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(p.value.xMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, vl),
          d("text", {
            id: `vue-ui-scatter-xAxis-label-${z.value}`,
            transform: `translate(${e.value.style.layout.dataLabels.xAxis.fontSize * 2}, ${u.value.top + u.value.height / 2}), rotate(-90)`,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, M(e.value.style.layout.dataLabels.xAxis.name), 9, yl)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.yAxis.show ? (o(), r("g", cl, [
          d("text", {
            x: f.value.x,
            y: u.value.bottom + e.value.style.layout.dataLabels.yAxis.fontSize + 3,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v(C)(p.value.yMin),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(p.value.yMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, dl),
          d("text", {
            x: f.value.x,
            y: u.value.top - e.value.style.layout.dataLabels.yAxis.fontSize / 2,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, M(v(j)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            v(C)(p.value.yMax),
            v(W)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: v(C)(p.value.yMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, hl),
          d("text", {
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.yAxis.color,
            x: u.value.left + u.value.width / 2,
            y: u.value.bottom + 8 + e.value.style.layout.dataLabels.yAxis.fontSize * 2
          }, M(e.value.style.layout.dataLabels.yAxis.name), 9, pl)
        ])) : c("", !0),
        d("clipPath", {
          id: `clip_path_${z.value}`
        }, [
          d("rect", {
            x: u.value.left,
            y: u.value.top,
            width: u.value.width <= 0 ? 1e-4 : u.value.width,
            height: u.value.height <= 0 ? 1e-4 : u.value.height
          }, null, 8, gl)
        ], 8, fl),
        e.value.style.layout.correlation.show ? (o(), r("g", xl, [
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("line", {
            x1: t.correlation.x1,
            x2: t.correlation.x2,
            y1: t.correlation.y1,
            y2: t.correlation.y2,
            "stroke-dasharray": e.value.style.layout.correlation.strokeDasharray,
            stroke: t.color,
            "stroke-width": e.value.style.layout.correlation.strokeWidth,
            "clip-path": `url(#clip_path_${z.value})`
          }, null, 8, ml))), 256)),
          (o(!0), r(P, null, X(S.value, (t, s) => (o(), r("g", null, [
            e.value.style.layout.correlation.label.show ? (o(), r("text", {
              key: 0,
              x: t.label.x,
              y: t.label.y,
              fill: e.value.style.layout.correlation.label.useSerieColor ? t.color : e.value.style.layout.correlation.label.color,
              "font-size": e.value.style.layout.correlation.label.fontSize,
              "font-weight": e.value.style.layout.correlation.label.bold ? "bold" : "normal"
            }, M(v(W)({
              v: v(C)(t.correlation.coefficient),
              r: e.value.style.layout.correlation.label.roundingValue
            })), 9, bl)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        $(l.$slots, "svg", { svg: A.value }, void 0, !0)
      ], 14, Tt)) : c("", !0),
      l.$slots.watermark ? (o(), r("div", kl, [
        $(l.$slots, "watermark", Q(Z({ isPrinting: v(Ce) || v(ze) })), void 0, !0)
      ])) : c("", !0),
      ee.value ? c("", !0) : (o(), Y(Mt, {
        key: 5,
        config: {
          type: "quadrant",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            quadrant: {
              grid: {
                color: e.value.style.layout.axis.stroke
              },
              plots: {
                color: e.value.style.layout.axis.stroke,
                radius: 1
              }
            }
          }
        }
      }, null, 8, ["config"])),
      d("div", {
        ref_key: "chartLegend",
        ref: me
      }, [
        e.value.style.legend.show ? (o(), Y(wt, {
          key: `legend_${we.value}`,
          legendSet: V.value,
          config: qe.value,
          onClickMarker: i[0] || (i[0] = ({ legend: t }) => We(t.id))
        }, {
          item: _(({ legend: t }) => [
            d("div", {
              onClick: (s) => t.segregate(),
              style: q(`opacity:${x.value.includes(t.id) ? 0.5 : 1}`)
            }, M(t.name), 13, _l)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : $(l.$slots, "legend", {
          key: 1,
          legend: V.value
        }, void 0, !0)
      ], 512),
      l.$slots.source ? (o(), r("div", {
        key: 6,
        ref_key: "source",
        ref: be,
        dir: "auto"
      }, [
        $(l.$slots, "source", {}, void 0, !0)
      ], 512)) : c("", !0),
      he(_t, {
        show: I.value.showTooltip && ue.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: H.value,
        content: re.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": _(() => [
          $(l.$slots, "tooltip-before", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": _(() => [
          $(l.$slots, "tooltip-after", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        default: _(() => [
          e.value.style.tooltip.showShape ? (o(), r("div", wl, [
            (o(), r("svg", $l, [
              he(Ye, {
                shape: y.value.shape,
                color: y.value.color,
                plot: { x: 10, y: 10 },
                radius: 7
              }, null, 8, ["shape", "color"])
            ]))
          ])) : c("", !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      ee.value ? (o(), Y(Ct, {
        key: 7,
        hideDetails: "",
        config: {
          open: I.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: _(() => [
          (o(), Y($t, {
            key: `table_${_e.value}`,
            colNames: ae.value.colNames,
            head: ae.value.head,
            body: ae.value.body,
            config: ae.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: i[1] || (i[1] = (t) => I.value.showTable = !1)
          }, {
            th: _(({ th: t }) => [
              tt(M(t), 1)
            ]),
            td: _(({ td: t }) => [
              t.shape ? (o(), r("div", Ml, [
                d("span", null, M(t.content), 1)
              ])) : (o(), r("div", {
                key: 1,
                innerHTML: t
              }, null, 8, Cl))
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, Lt));
  }
}, Vl = /* @__PURE__ */ St(zl, [["__scopeId", "data-v-8bf19e2f"]]);
export {
  Vl as default
};
