import { computed as p, ref as n, watch as Fe, onMounted as We, onBeforeUnmount as Ie, openBlock as o, createElementBlock as i, normalizeClass as F, normalizeStyle as Q, createBlock as T, createCommentVNode as c, unref as d, createSlots as Me, withCtx as f, renderSlot as y, normalizeProps as W, guardReactiveProps as I, createVNode as ke, Fragment as g, renderList as C, createElementVNode as k, toDisplayString as L, mergeProps as De, createTextVNode as Ge, nextTick as Ee } from "vue";
import { u as Ve, c as Z, t as He, a as Re, p as A, o as Ue, e as ee, g as xe, b as Be, d as Ce, v as Xe, C as je, f as B, X as Ye, i as te, l as Je, h as qe, x as we, y as Ke, q as Qe, r as Ze, E as et } from "./index-Bya_q1J-.js";
import { t as tt, u as lt } from "./useResponsive-BY8tgM1n.js";
import { _ as at } from "./Title-C5pIfQAz.js";
import { u as ot, U as st } from "./usePrinter-CiHd1FwD.js";
import { _ as rt } from "./Tooltip-Cz24YLfw.js";
import { D as ut } from "./DataTable-DYqC2pqu.js";
import it from "./vue-ui-skeleton-BYssP0K4.js";
import { _ as nt } from "./Shape-Bwon0l0g.js";
import vt from "./vue-ui-accordion-DfUfL2dI.js";
import { u as $e } from "./useNestedProp-B33hazbH.js";
import { _ as ct } from "./PackageVersion-VkaUzgmt.js";
import { P as dt } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as ht } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const pt = ["id"], ft = ["xmlns", "viewBox"], yt = { key: 0 }, bt = { key: 0 }, mt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], gt = { key: 1 }, kt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], xt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ct = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], wt = ["x", "y", "fill", "font-size"], $t = ["x", "y", "font-size", "fill"], _t = ["fill", "font-size", "transform"], Tt = ["fill", "font-size", "x", "y"], Lt = ["x1", "x2", "y1", "y2", "stroke"], At = ["cx", "cy", "fill"], Pt = ["cx", "cy", "fill"], St = ["id"], zt = ["stop-color"], Nt = ["stop-color"], Ot = ["stop-color"], Ft = { key: 0 }, Wt = ["x", "y", "font-size", "fill"], It = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Mt = ["innerHTML"], Dt = {
  __name: "vue-ui-strip-plot",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(_e, { expose: Te, emit: Le }) {
    const b = _e, { vue_ui_strip_plot: Ae } = Ve(), w = p({
      get() {
        return !!b.dataset && b.dataset.length;
      },
      set(t) {
        return t;
      }
    }), X = n(Z()), le = n(0), j = n(!1), Y = n(""), P = n(null), ae = n(null), oe = n(null), se = n(!1), re = n(0), ue = n(0), e = p({
      get: () => ie(),
      set: (t) => t
    });
    function ie() {
      const t = $e({
        userConfig: b.config,
        defaultConfig: Ae
      });
      return t.theme ? {
        ...$e({
          userConfig: He.vue_ui_strip_plot[t.theme] || b.config,
          defaultConfig: t
        }),
        customPalette: Re[t.theme] || A
      } : t;
    }
    Fe(() => b.config, (t) => {
      e.value = ie(), ne(), re.value += 1, ue.value += 1;
    }, { deep: !0 });
    const M = n(null);
    We(() => {
      ne();
    });
    function ne() {
      if (Ue(b.dataset) ? ee({
        componentName: "VueUiStripPlot",
        type: "dataset"
      }) : b.dataset.forEach((t, s) => {
        xe({
          datasetObject: t,
          requiredAttributes: ["name", "plots"]
        }).forEach((l) => {
          w.value = !1, ee({
            componentName: "VueUiStripPlot",
            type: "datasetSerieAttribute",
            property: l,
            index: s
          });
        }), t.plots && t.plots.forEach((l, r) => {
          xe({
            datasetObject: l,
            requiredAttributes: ["name", "value"]
          }).forEach((u) => {
            w.value = !1, ee({
              componentName: "VueUiStripPlot",
              type: "datasetSerieAttribute",
              property: u,
              index: `${s},${r}`
            });
          });
        });
      }), e.value.responsive) {
        const t = tt(() => {
          const { width: s, height: l } = lt({
            chart: P.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            source: oe.value
          });
          D.value = l, S.value.width = s, S.value.height = l, N.value = (s - m.value.left - m.value.right) / b.dataset.length, G.value = et({
            relator: Math.min(l, s),
            adjuster: 600,
            source: e.value.style.chart.plots.radius,
            threshold: 6,
            fallback: 6
          });
        });
        M.value = new ResizeObserver(t), M.value.observe(P.value.parentNode);
      }
      se.value = !0, setTimeout(() => {
        z.value = !1;
      }, Pe.value * 50);
    }
    Ie(() => {
      M.value && M.value.disconnect();
    });
    const { isPrinting: ve, isImaging: ce, generatePdf: de, generateImage: he } = ot({
      elementId: `strip-plot_${X.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-strip-plot"
    }), pe = p(() => Be(e.value.customPalette)), z = n(e.value.useCssAnimation), h = n({
      showTable: e.value.table.show,
      dataLabels: {
        show: e.value.style.chart.labels.bestPlotLabel.show
      },
      showTooltip: e.value.style.chart.tooltip.show
    }), m = n({
      top: e.value.style.chart.padding.top,
      bottom: e.value.style.chart.padding.bottom,
      left: e.value.style.chart.padding.left,
      right: e.value.style.chart.padding.right
    }), N = n(e.value.style.chart.stripWidth), D = n(e.value.style.chart.height), G = n(e.value.style.chart.plots.radius), S = n({
      width: N.value * b.dataset.length + m.value.left + m.value.right,
      height: e.value.style.chart.height
    }), a = p(() => {
      const t = N.value * b.dataset.length + m.value.left + m.value.right;
      return {
        left: m.value.left,
        right: t - m.value.right,
        top: m.value.top,
        bottom: D.value - m.value.bottom,
        width: N.value * b.dataset.length,
        height: D.value - m.value.top - m.value.bottom,
        stripWidth: N.value,
        absoluteHeight: D.value,
        absoluteWidth: t
      };
    }), E = p(() => w.value ? b.dataset.map((t, s) => {
      const l = Z();
      return {
        ...t,
        id: l,
        color: t.color ? Ce(t.color) : pe.value[s] || A[s] || A[s % A.length],
        plots: t.plots.map((r) => ({
          ...r,
          value: Xe(r.value),
          parentId: l,
          color: t.color ? Ce(t.color) : pe.value[s] || A[s] || A[s % A.length],
          id: Z()
        })).sort((r, u) => r.value - u.value)
      };
    }) : null), x = p(() => (E.value || []).map((t, s) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        x: a.value.left + (s + 1) * a.value.stripWidth - a.value.stripWidth / 2
      }))
    }))), Pe = p(() => Math.max(...x.value.map((t) => t.plots.length))), J = p(() => {
      const t = x.value.flatMap((s) => s.plots.map((l) => l.value));
      return {
        max: Math.max(...t),
        min: Math.min(...t)
      };
    }), $ = p(() => je(J.value.min < 0 ? J.value.min : 0, J.value.max, e.value.style.chart.grid.scaleSteps)), Se = p(() => (x.value || []).map((t, s) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        y: a.value.bottom - (l.value + Math.abs($.value.min)) / ($.value.max + Math.abs($.value.min)) * a.value.height
      }))
    }))), fe = p(() => $.value.ticks.map((t) => ({
      y: a.value.bottom - a.value.height * ((t + Math.abs($.value.min)) / ($.value.max + Math.abs($.value.min))),
      x1: a.value.left,
      x2: a.value.right,
      value: t
    }))), q = n(null), v = n(null);
    function ze({ datapoint: t, seriesIndex: s }) {
      q.value = { datapoint: t, seriesIndex: s, config: e.value, series: E.value }, j.value = !0, v.value = t;
      const l = e.value.style.chart.tooltip.customFormat;
      if (we(l) && Ke(() => l({
        seriesIndex: s,
        datapoint: t,
        series: E.value,
        config: e.value
      })))
        Y.value = l({
          seriesIndex: s,
          datapoint: t,
          series: E.value,
          config: e.value
        });
      else {
        let r = "";
        r += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${e.value.style.chart.plots.gradient.show ? `url(#${t.parentId})` : t.color}"/></svg>${t.name}</div>`, r += `<div>${te(
          e.value.style.chart.labels.formatter,
          t.value,
          B({
            p: e.value.style.chart.labels.prefix,
            v: t.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: s }
        )}</div>`, Y.value = `<div>${r}</div>`;
      }
    }
    const V = p(() => {
      const t = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((r, u) => u.value - r.value).map((r) => ({
        name: `${l.name} - ${r.name}`,
        color: r.color
      }))), s = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((r, u) => u.value - r.value).map((r) => r.value));
      return { head: t, body: s };
    });
    function ye() {
      Ee(() => {
        const t = V.value.head.map((r, u) => [[
          r.name
        ], [V.value.body[u]]]), s = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[e.value.table.columnNames.series], [e.value.table.columnNames.value]]].concat(t), l = Qe(s);
        Ze({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-strip-plot" });
      });
    }
    const H = p(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value
      ], s = V.value.head.map((u, _) => {
        const U = B({
          p: e.value.style.chart.labels.prefix,
          v: V.value.body[_],
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        });
        return [
          {
            color: u.color,
            name: u.name
          },
          U
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: s,
        config: l
      };
    }), O = n(!1);
    function Ne(t) {
      O.value = t, le.value += 1;
    }
    function Oe() {
      return x.value;
    }
    function be() {
      h.value.showTable = !h.value.showTable;
    }
    function me() {
      h.value.dataLabels.show = !h.value.dataLabels.show;
    }
    function ge() {
      h.value.showTooltip = !h.value.showTooltip;
    }
    const R = n(!1);
    function K() {
      R.value = !R.value;
    }
    return Te({
      getData: Oe,
      generatePdf: de,
      generateCsv: ye,
      generateImage: he,
      toggleTable: be,
      toggleLabels: me,
      toggleTooltip: ge,
      toggleAnnotator: K
    }), (t, s) => (o(), i("div", {
      ref_key: "stripPlotChart",
      ref: P,
      class: F(`vue-ui-strip-plot ${O.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `strip-plot_${X.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (o(), T(dt, {
        key: 0,
        parent: P.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: R.value,
        onClose: K
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      e.value.style.chart.title.text ? (o(), i("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), T(at, {
          key: `title_${re.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && w.value ? (o(), T(st, {
        ref: "details",
        key: `user_option_${le.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(ve),
        isImaging: d(ce),
        uid: X.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: h.value.showTooltip,
        isFullscreen: O.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: P.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: R.value,
        onToggleFullscreen: Ne,
        onGeneratePdf: d(de),
        onGenerateCsv: ye,
        onGenerateImage: d(he),
        onToggleTable: be,
        onToggleLabels: me,
        onToggleTooltip: ge,
        onToggleAnnotator: K
      }, Me({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: f(() => [
            y(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: f(() => [
            y(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: f(() => [
            y(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: f(() => [
            y(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: f(() => [
            y(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: f(() => [
            y(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: f(({ toggleFullscreen: l, isFullscreen: r }) => [
            y(t.$slots, "optionFullscreen", W(I({ toggleFullscreen: l, isFullscreen: r })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: f(({ toggleAnnotator: l, isAnnotator: r }) => [
            y(t.$slots, "optionAnnotator", W(I({ toggleAnnotator: l, isAnnotator: r })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      w.value ? (o(), i("svg", {
        key: 3,
        xmlns: d(Ye),
        class: F({ "vue-data-ui-fullscreen--on": O.value, "vue-data-ui-fulscreen--off": !O.value }),
        viewBox: `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`,
        style: Q(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color};`)
      }, [
        ke(ct),
        e.value.style.chart.grid.show ? (o(), i("g", yt, [
          e.value.style.chart.grid.horizontalGrid.show ? (o(), i("g", bt, [
            (o(!0), i(g, null, C(fe.value, (l) => (o(), i("line", {
              x1: l.x1,
              x2: l.x2,
              y1: l.y,
              y2: l.y,
              stroke: e.value.style.chart.grid.horizontalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, mt))), 256))
          ])) : c("", !0),
          e.value.style.chart.grid.verticalGrid.show ? (o(), i("g", gt, [
            (o(!0), i(g, null, C(x.value, (l, r) => (o(), i("line", {
              x1: a.value.left + (r + 1) * a.value.stripWidth,
              x2: a.value.left + (r + 1) * a.value.stripWidth,
              y1: a.value.top,
              y2: a.value.bottom,
              stroke: e.value.style.chart.grid.verticalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.verticalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.verticalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, kt))), 256))
          ])) : c("", !0),
          k("line", {
            x1: a.value.left,
            x2: a.value.left,
            y1: a.value.top,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, xt),
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: a.value.bottom,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Ct)
        ])) : c("", !0),
        e.value.style.chart.labels.yAxisLabels.show ? (o(!0), i(g, { key: 1 }, C(fe.value, (l, r) => (o(), i("text", {
          x: l.x1 - e.value.style.chart.labels.yAxisLabels.fontSize / 2 + e.value.style.chart.labels.yAxisLabels.offsetX,
          y: l.y + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
          fill: e.value.style.chart.labels.yAxisLabels.color,
          "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
          "text-anchor": "end"
        }, L(d(te)(
          e.value.style.chart.labels.formatter,
          l.value,
          d(B)({
            p: e.value.style.chart.labels.prefix,
            v: l.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.labels.yAxisLabels.rounding
          }),
          { datapoint: l, seriesIndex: r }
        )), 9, wt))), 256)) : c("", !0),
        e.value.style.chart.labels.xAxisLabels.show ? (o(!0), i(g, { key: 2 }, C(x.value, (l, r) => (o(), i("text", {
          x: a.value.left + (r + 1) * a.value.stripWidth - a.value.stripWidth / 2,
          y: a.value.bottom + e.value.style.chart.labels.xAxisLabels.fontSize * 2 + e.value.style.chart.labels.xAxisLabels.offsetY,
          "font-size": e.value.style.chart.labels.xAxisLabels.fontSize,
          fill: e.value.style.chart.labels.xAxisLabels.color,
          "text-anchor": "middle"
        }, L(l.name), 9, $t))), 256)) : c("", !0),
        e.value.style.chart.labels.axis.yLabel ? (o(), i("text", {
          key: 3,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          transform: `translate(${e.value.style.chart.labels.axis.fontSize + e.value.style.chart.labels.axis.yLabelOffsetX}, ${a.value.top + a.value.height / 2}) rotate(-90)`,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.yLabel), 9, _t)) : c("", !0),
        e.value.style.chart.labels.axis.xLabel ? (o(), i("text", {
          key: 4,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          x: a.value.left + a.value.width / 2,
          y: a.value.absoluteHeight,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.xLabel), 9, Tt)) : c("", !0),
        v.value ? (o(), i(g, { key: 5 }, [
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: v.value.y,
            y2: v.value.y,
            stroke: v.value.color,
            "stroke-width": 1,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, Lt),
          k("circle", {
            cx: a.value.left,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, At),
          k("circle", {
            cx: a.value.right,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, Pt)
        ], 64)) : c("", !0),
        k("defs", null, [
          (o(!0), i(g, null, C(x.value, (l) => (o(), i("radialGradient", {
            id: l.id,
            fy: "30%"
          }, [
            k("stop", {
              offset: "10%",
              "stop-color": d(Je)(l.color, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, zt),
            k("stop", {
              offset: "90%",
              "stop-color": d(qe)(l.color, 0.1)
            }, null, 8, Nt),
            k("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, Ot)
          ], 8, St))), 256))
        ]),
        (o(!0), i(g, null, C(Se.value, (l, r) => (o(), i(g, null, [
          (o(!0), i(g, null, C(l.plots, (u, _) => (o(), T(nt, De({
            plot: { x: u.x, y: se.value ? u.y : a.value.top },
            radius: v.value && v.value.id === u.id ? G.value * 1.5 : G.value,
            shape: e.value.style.chart.plots.shape,
            stroke: e.value.style.chart.plots.stroke,
            strokeWidth: e.value.style.chart.plots.strokeWidth,
            color: e.value.style.chart.plots.gradient.show ? `url(#${l.id})` : l.color,
            onMouseenter: (U) => ze({ datapoint: u, seriesIndex: _ }),
            onMouseleave: s[0] || (s[0] = (U) => {
              j.value = !1, v.value = null;
            }),
            onClick: (U) => Le("selectDatapoint", u),
            style: `transition: all 0.2s ease-in-out; opacity:${v.value ? v.value.id === u.id ? 1 : 0.2 : e.value.style.chart.plots.opacity};${z.value ? `transition-delay:${_ * 50}ms` : ""}`,
            class: { "vue-ui-strip-plot-animated": e.value.useCssAnimation && z.value, "vue-ui-strip-plot-select-circle": e.value.useCssAnimation && !z.value }
          }, t.$attrs), null, 16, ["plot", "radius", "shape", "stroke", "strokeWidth", "color", "onMouseenter", "onClick", "style", "class"]))), 256)),
          h.value.dataLabels.show ? (o(), i("g", Ft, [
            (o(!0), i(g, null, C(l.plots, (u, _) => (o(), i(g, null, [
              _ === l.plots.length - 1 || v.value && v.value.id === u.id && !h.value.showTooltip ? (o(), i("text", {
                key: 0,
                x: u.x,
                y: u.y + e.value.style.chart.labels.bestPlotLabel.offsetY - G.value * (v.value && v.value.id === u.id && !h.value.showTooltip ? 2 : 1.5),
                "font-size": e.value.style.chart.labels.bestPlotLabel.fontSize,
                fill: e.value.style.chart.labels.bestPlotLabel.color,
                "text-anchor": "middle",
                style: Q(`opacity:${e.value.useCssAnimation && z.value ? 0 : 1};transition:opacity 0.2s ease-in;`)
              }, L(u.name) + " " + L(e.value.style.chart.labels.bestPlotLabel.showValue ? d(te)(
                e.value.style.chart.labels.formatter,
                u.value,
                d(B)({
                  p: `(${e.value.style.chart.labels.prefix}`,
                  v: u.value,
                  s: `${e.value.style.chart.labels.suffix})`,
                  r: e.value.style.chart.labels.bestPlotLabel.rounding
                }),
                { datapoint: u, seriesIndex: _ }
              ) : ""), 13, Wt)) : c("", !0)
            ], 64))), 256))
          ])) : c("", !0)
        ], 64))), 256)),
        y(t.$slots, "svg", { svg: a.value }, void 0, !0)
      ], 14, ft)) : c("", !0),
      t.$slots.watermark ? (o(), i("div", It, [
        y(t.$slots, "watermark", W(I({ isPrinting: d(ve) || d(ce) })), void 0, !0)
      ])) : c("", !0),
      w.value ? c("", !0) : (o(), T(it, {
        key: 5,
        config: {
          type: "stripPlot",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            stripPlot: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      t.$slots.source ? (o(), i("div", {
        key: 6,
        ref_key: "source",
        ref: oe,
        dir: "auto"
      }, [
        y(t.$slots, "source", {}, void 0, !0)
      ], 512)) : c("", !0),
      ke(rt, {
        show: h.value.showTooltip && j.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: P.value,
        content: Y.value,
        isCustom: d(we)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": f(() => [
          y(t.$slots, "tooltip-before", W(I({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": f(() => [
          y(t.$slots, "tooltip-after", W(I({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      w.value ? (o(), T(vt, {
        key: 7,
        hideDetails: "",
        config: {
          open: h.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: f(() => [
          (o(), T(ut, {
            key: `table_${ue.value}`,
            colNames: H.value.colNames,
            head: H.value.head,
            body: H.value.body,
            config: H.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: s[1] || (s[1] = (l) => h.value.showTable = !1)
          }, {
            th: f(({ th: l }) => [
              k("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Mt)
            ]),
            td: f(({ td: l }) => [
              Ge(L(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, pt));
  }
}, Zt = /* @__PURE__ */ ht(Dt, [["__scopeId", "data-v-f6133f25"]]);
export {
  Zt as default
};
