import { useCssVars as ve, computed as h, onMounted as ye, ref as g, watch as fe, openBlock as l, createElementBlock as n, normalizeClass as P, normalizeStyle as ge, createBlock as F, createCommentVNode as i, unref as v, createSlots as me, withCtx as I, renderSlot as m, normalizeProps as G, guardReactiveProps as V, createVNode as pe, createElementVNode as d, Fragment as A, renderList as K, toDisplayString as ke } from "vue";
import { u as be, o as _e, e as Q, g as xe, c as we, t as Ce, a as $e, p as _, b as Pe, v as f, d as O, X as Fe, s as Ie, i as Ae, f as Oe } from "./index-Bya_q1J-.js";
import { _ as Ye } from "./Title-C5pIfQAz.js";
import { u as Me, U as Ne } from "./usePrinter-CiHd1FwD.js";
import Se from "./vue-ui-skeleton-BYssP0K4.js";
import { u as Z } from "./useNestedProp-B33hazbH.js";
import { _ as Ue } from "./PackageVersion-VkaUzgmt.js";
import { P as qe } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Le } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Te = ["id"], Ge = {
  key: 1,
  style: "width:100%"
}, Ve = ["xmlns", "viewBox"], We = {
  id: "vueUiPill",
  clipPathUnits: "objectBoundingBox"
}, Ee = ["fill"], ze = ["id"], Be = ["stop-color"], je = ["stop-color"], De = ["stop-color"], He = { "clip-path": "url(#vueUiPill)" }, Xe = ["x", "y", "height", "width"], Re = ["x", "y", "height", "width", "fill"], Je = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Ke = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Qe = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Ze = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], et = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], tt = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], ot = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], st = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], at = ["x", "y", "height", "width"], lt = ["y", "x", "fill", "font-size", "font-weight"], rt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, ut = {
  key: 5,
  ref: "source",
  dir: "auto"
}, nt = {
  __name: "vue-ui-thermometer",
  props: {
    dataset: {
      type: Object,
      default() {
        return {};
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(x, { expose: ee }) {
    const a = x;
    ve((o) => ({
      "067bf1c5": re.value,
      "94b8612e": le.value,
      "29802a96": ae.value
    }));
    const { vue_ui_thermometer: te } = be(), Y = h(() => !!a.dataset && Object.keys(a.dataset).length);
    ye(() => {
      W();
    });
    function W() {
      _e(a.dataset) ? Q({
        componentName: "VueUiThermometer",
        type: "dataset"
      }) : xe({
        datasetObject: a.dataset,
        requiredAttributes: ["value", "from", "to"]
      }).forEach((o) => {
        Q({
          componentName: "VueUiThermometer",
          type: "datasetAttribute",
          property: o
        });
      });
    }
    const p = g(we()), M = g(null), E = g(0), z = g(0), e = h({
      get: () => B(),
      set: (o) => o
    });
    function B() {
      const o = Z({
        userConfig: a.config,
        defaultConfig: te
      });
      return o.theme ? {
        ...Z({
          userConfig: Ce.vue_ui_thermometer[o.theme] || a.config,
          defaultConfig: o
        }),
        customPalette: $e[o.theme] || _
      } : o;
    }
    fe(() => a.config, (o) => {
      e.value = B(), W(), z.value += 1;
    }, { deep: !0 });
    const { isPrinting: j, isImaging: D, generatePdf: H, generateImage: X } = Me({
      elementId: `thermometer__${p.value}`,
      fileName: e.value.style.title.text || "vue-ui-thermometer"
    }), w = h(() => Pe(e.value.customPalette)), oe = h(() => e.value.style.chart.thermometer.width), y = h(() => a.dataset.steps || 10), c = g({
      top: e.value.style.chart.padding.top,
      left: e.value.style.chart.padding.left,
      right: e.value.style.chart.padding.right,
      bottom: e.value.style.chart.padding.bottom
    });
    function C(o, u, t) {
      const r = [], L = R(o), T = R(u);
      for (let b = 0; b < t; b++) {
        const ie = N(L.red, T.red, b, t), ce = N(L.green, T.green, b, t), he = N(L.blue, T.blue, b, t), de = `#${S(ie)}${S(ce)}${S(he)}`;
        r.push(de);
      }
      return r;
    }
    function R(o) {
      const u = o.slice(1);
      return {
        red: parseInt(u.slice(0, 2), 16),
        green: parseInt(u.slice(2, 4), 16),
        blue: parseInt(u.slice(4, 6), 16)
      };
    }
    function N(o, u, t, r) {
      return Math.round(o + (u - o) * t / r);
    }
    function S(o) {
      return o.toString(16).padStart(2, "0");
    }
    const s = h(() => {
      const o = oe.value + c.value.left + c.value.right, u = e.value.style.chart.height;
      return {
        width: o,
        left: c.value.left,
        right: o - c.value.right,
        top: c.value.top,
        bottom: u - c.value.bottom,
        height: u
      };
    }), se = h(() => s.value), U = h(() => {
      const o = f(a.dataset.from) < 0 ? Math.abs(f(a.dataset.from)) : f(a.dataset.from), u = f(a.dataset.to) < 0 ? Math.abs(f(a.dataset.to)) : f(a.dataset.to);
      let t = 0;
      return f(a.dataset.to) > 0 ? t = o + u : o > u ? t = o - u : t = u - o, (1 - (Math.abs(f(a.dataset.from)) + f(a.dataset.value)) / t) * (s.value.height - c.value.top - c.value.bottom);
    }), ae = h(() => `${U.value}px`), le = h(() => `${s.value.height - e.value.style.chart.padding.bottom - c.value.top}px`), re = h(() => `${e.value.style.chart.animation.speedMs}ms`), ue = h(() => {
      if (a.dataset.colors) {
        if (!a.dataset.colors.from)
          return C(w.value[0] || _[0], O(a.dataset.colors.to), y.value || 10);
        if (!a.dataset.colors.to)
          return C(O(a.dataset.colors.from), w.value[1] || _[1], y.value || 10);
      } else
        return C(w.value[1] || _[1], w.value[0] || _[0], y.value || 10);
      return C(O(a.dataset.colors.from), O(a.dataset.colors.to), y.value || 10);
    }), J = h(() => {
      const o = [];
      let u = 0;
      const t = s.value.height - c.value.top - c.value.bottom;
      for (let r = 0; r < t - 1; r += t / y.value)
        o.push({
          x: s.value.left,
          y: s.value.top + r,
          qYLess: s.value.top + r + t / y.value / 4,
          halfY: s.value.top + r + t / y.value / 2,
          qYMore: s.value.top + r + t / y.value / 4 * 3,
          color: ue.value[u],
          height: t / y.value
        }), u += 1;
      return o;
    }), k = g(!1);
    function ne(o) {
      k.value = o, E.value += 1;
    }
    const $ = g(!1);
    function q() {
      $.value = !$.value;
    }
    return ee({
      generatePdf: H,
      generateImage: X,
      toggleAnnotator: q
    }), (o, u) => (l(), n("div", {
      ref_key: "thermoChart",
      ref: M,
      class: P(`vue-ui-thermometer ${k.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: ge(`width:100%;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color};font-family:${e.value.style.fontFamily}`),
      id: `thermometer__${p.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (l(), F(qe, {
        key: 0,
        parent: M.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: $.value,
        onClose: q
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : i("", !0),
      e.value.style.title.text ? (l(), n("div", Ge, [
        (l(), F(Ye, {
          key: `title_${z.value}`,
          config: {
            title: {
              cy: "thermometer-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "thermometer-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : i("", !0),
      e.value.userOptions.show && Y.value ? (l(), F(Ne, {
        ref: "details",
        key: `user_options_${E.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: v(D),
        isPrinting: v(j),
        uid: p.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: k.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: M.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: $.value,
        onToggleFullscreen: ne,
        onGeneratePdf: v(H),
        onGenerateImage: v(X),
        onToggleAnnotator: q
      }, me({ _: 2 }, [
        o.$slots.optionPdf ? {
          name: "optionPdf",
          fn: I(() => [
            m(o.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        o.$slots.optionImg ? {
          name: "optionImg",
          fn: I(() => [
            m(o.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        o.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: I(({ toggleFullscreen: t, isFullscreen: r }) => [
            m(o.$slots, "optionFullscreen", G(V({ toggleFullscreen: t, isFullscreen: r })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        o.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: I(({ toggleAnnotator: t, isAnnotator: r }) => [
            m(o.$slots, "optionAnnotator", G(V({ toggleAnnotator: t, isAnnotator: r })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : i("", !0),
      Y.value ? (l(), n("svg", {
        key: 3,
        xmlns: v(Fe),
        class: P({ "vue-data-ui-fullscreen--on": k.value, "vue-data-ui-fulscreen--off": !k.value }),
        width: "100%",
        viewBox: `0 0 ${s.value.width} ${s.value.height}`,
        style: "background:transparent"
      }, [
        pe(Ue),
        d("defs", null, [
          d("clipPath", We, [
            d("rect", {
              x: "0",
              y: "0",
              width: "1",
              height: "1",
              rx: "0.5",
              ry: "0.07",
              fill: e.value.style.chart.backgroundColor
            }, null, 8, Ee)
          ]),
          (l(!0), n(A, null, K(J.value, (t, r) => (l(), n("linearGradient", {
            id: `vueUiThermometerGradient_${r}_${p.value}`,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": t.color
            }, null, 8, Be),
            d("stop", {
              offset: "50%",
              "stop-color": v(Ie)(t.color, 100 - e.value.style.chart.graduations.gradient.intensity)
            }, null, 8, je),
            d("stop", {
              offset: "100%",
              "stop-color": t.color
            }, null, 8, De)
          ], 8, ze))), 256))
        ]),
        d("g", He, [
          d("rect", {
            x: s.value.left,
            y: s.value.top,
            height: s.value.height - c.value.top - c.value.bottom,
            width: s.value.width - c.value.left - c.value.right,
            fill: "#FFFFFF"
          }, null, 8, Xe),
          (l(!0), n(A, null, K(J.value, (t, r) => (l(), n("g", {
            key: `graduation_${r}`
          }, [
            d("rect", {
              x: t.x,
              y: t.y,
              height: t.height,
              width: s.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right,
              fill: e.value.style.chart.graduations.gradient.show ? `url(#vueUiThermometerGradient_${r}_${p.value})` : t.color,
              "shape-rendering": "crispEdges"
            }, null, 8, Re),
            e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
              key: 0,
              x1: t.x,
              x2: t.x + 10,
              y1: t.y,
              y2: t.y,
              "stroke-width": e.value.style.chart.graduations.strokeWidth,
              stroke: e.value.style.chart.graduations.stroke,
              "stroke-linecap": "round"
            }, null, 8, Je)) : i("", !0),
            e.value.style.chart.graduations.showIntermediate ? (l(), n(A, { key: 1 }, [
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 0,
                x1: t.x,
                x2: t.x + 5,
                y1: t.halfY,
                y2: t.halfY,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, Ke)) : i("", !0),
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 1,
                x1: t.x,
                x2: t.x + 2.5,
                y1: t.qYLess,
                y2: t.qYLess,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, Qe)) : i("", !0),
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 2,
                x1: t.x,
                x2: t.x + 2.5,
                y1: t.qYMore,
                y2: t.qYMore,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, Ze)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
              key: 2,
              x1: s.value.right,
              x2: s.value.right - 10,
              y1: t.y,
              y2: t.y,
              "stroke-width": e.value.style.chart.graduations.strokeWidth,
              stroke: e.value.style.chart.graduations.stroke,
              "stroke-linecap": "round"
            }, null, 8, et)) : i("", !0),
            e.value.style.chart.graduations.showIntermediate ? (l(), n(A, { key: 3 }, [
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 0,
                x1: s.value.right,
                x2: s.value.right - 5,
                y1: t.halfY,
                y2: t.halfY,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, tt)) : i("", !0),
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 1,
                x1: s.value.right,
                x2: s.value.right - 2.5,
                y1: t.qYLess,
                y2: t.qYLess,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, ot)) : i("", !0),
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (l(), n("line", {
                key: 2,
                x1: s.value.right,
                x2: s.value.right - 2.5,
                y1: t.qYMore,
                y2: t.qYMore,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, st)) : i("", !0)
            ], 64)) : i("", !0)
          ]))), 128)),
          d("rect", {
            class: P({ "vue-ui-thermometer-temperature": e.value.style.chart.animation.use }),
            x: s.value.left,
            y: s.value.top,
            height: U.value,
            width: s.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right,
            fill: "#FFFFFF66"
          }, null, 10, at)
        ]),
        d("text", {
          class: P({ "vue-ui-thermometer-temperature-value": e.value.style.chart.animation.use }),
          y: U.value + s.value.top + e.value.style.chart.label.fontSize / 3,
          x: s.value.left - 10,
          "text-anchor": "end",
          fill: e.value.style.chart.label.color,
          "font-size": e.value.style.chart.label.fontSize,
          "font-weight": e.value.style.chart.label.bold ? "bold" : "normal"
        }, ke(v(Ae)(
          e.value.style.chart.label.formatter,
          x.dataset.value,
          v(Oe)({
            p: e.value.style.chart.label.prefix,
            v: x.dataset.value,
            s: e.value.style.chart.label.suffix,
            r: e.value.style.chart.label.rounding
          }),
          { datapoint: x.dataset }
        )), 11, lt),
        m(o.$slots, "svg", { svg: se.value }, void 0, !0)
      ], 10, Ve)) : i("", !0),
      o.$slots.watermark ? (l(), n("div", rt, [
        m(o.$slots, "watermark", G(V({ isPrinting: v(j) || v(D) })), void 0, !0)
      ])) : i("", !0),
      o.$slots.source ? (l(), n("div", ut, [
        m(o.$slots, "source", {}, void 0, !0)
      ], 512)) : i("", !0),
      Y.value ? i("", !0) : (l(), F(Se, {
        key: 6,
        config: {
          type: "thermometer",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            thermometer: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 14, Te));
  }
}, pt = /* @__PURE__ */ Le(nt, [["__scopeId", "data-v-ae62bd8a"]]);
export {
  pt as default
};
