import { c as J, a as K, t as Q, z as j, p as $, U as q, O as R, f as U, K as ee, F as te, i as ae, $ as ie, Z as re, a0 as le, v as se, a1 as ne, d as oe, B as ce, b as he, q as de, R as ue, a2 as ge, r as fe, e as Ne, y as me, M as Ie, x as xe, a3 as be, o as Fe, s as _e, w as ye, E as Ae, A as Ce, u as Le } from "./index-Bya_q1J-.js";
import { D as Se } from "./DataTable-DYqC2pqu.js";
import { _ as ke } from "./Title-C5pIfQAz.js";
import { _ as we, u as Oe } from "./Tooltip-Cz24YLfw.js";
import { U as Ge } from "./usePrinter-CiHd1FwD.js";
import { _ as ve } from "./Shape-Bwon0l0g.js";
import pe from "./BaseIcon-BbvG1AlW.js";
import ze from "./vue-ui-table-sparkline-CbjfAaj2.js";
import Me from "./vue-ui-skeleton-BYssP0K4.js";
import { S as Pe } from "./Slicer-TfpN2Cr4.js";
import Te from "./vue-ui-accordion-DfUfL2dI.js";
import { u as Z } from "./useNestedProp-B33hazbH.js";
import { _ as Ve } from "./PackageVersion-VkaUzgmt.js";
import { P as Re } from "./PenAndPaper-DAZYA8Ew.js";
import { resolveComponent as T, openBlock as r, createElementBlock as l, normalizeClass as V, normalizeStyle as C, createBlock as D, createCommentVNode as h, createSlots as De, withCtx as M, renderSlot as w, normalizeProps as H, guardReactiveProps as E, createVNode as X, createElementVNode as u, Fragment as N, renderList as I, toDisplayString as S, withDirectives as We, vModelCheckbox as He, createTextVNode as Ee } from "vue";
import { _ as Be } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ye = J(), Xe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: Se,
    Shape: ve,
    Title: ke,
    Tooltip: we,
    UserOptions: Ge,
    BaseIcon: pe,
    TableSparkline: ze,
    Skeleton: Me,
    Slicer: Pe,
    Accordion: Te,
    PackageVersion: Ve,
    PenAndPaper: Re
  },
  data() {
    this.dataset.forEach((c, f) => {
      [null, void 0].includes(c.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: f
      });
    });
    const t = Math.max(...this.dataset.map((c) => c.series.length)), s = {
      start: 0,
      end: t
    };
    return {
      themePalettes: K,
      themes: Q,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: s,
      __to__: null,
      maxX: t,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Ye,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  watch: {
    dataset: {
      handler(t, s) {
        this.maxX = Math.max(...this.dataset.map((c) => c.series.length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(t, s) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const t = this.datasetWithIds.filter((a) => !this.segregatedSeries.includes(a.id)), s = Math.max(...t.map((a) => a.series.length)), c = [];
      for (let a = 0; a < s; a += 1)
        c.push(t.map((e) => e.series[a] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const f = Math.min(...c);
      return c.map((a) => a + (f < 0 ? Math.abs(f) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const t = this.lineSet.map((a) => ({
        name: a.name,
        color: a.color,
        scale: a.individualScale,
        scaleYLabels: a.scaleYLabels,
        zero: a.zeroPosition,
        max: a.individualMax,
        scaleLabel: a.scaleLabel || "",
        id: a.id,
        yOffset: a.yOffset || 0,
        individualHeight: a.individualHeight || this.drawingArea.height,
        autoScaleYLabels: a.autoScaleYLabels
      })), s = this.barSet.map((a) => ({
        name: a.name,
        color: a.color,
        scale: a.individualScale,
        scaleYLabels: a.scaleYLabels,
        zero: a.zeroPosition,
        max: a.individualMax,
        scaleLabel: a.scaleLabel || "",
        id: a.id,
        yOffset: a.yOffset || 0,
        individualHeight: a.individualHeight || this.drawingArea.height
      })), c = this.plotSet.map((a) => ({
        name: a.name,
        color: a.color,
        scale: a.individualScale,
        scaleYLabels: a.scaleYLabels,
        // FIX
        zero: a.zeroPosition,
        max: a.individualMax,
        scaleLabel: a.scaleLabel || "",
        id: a.id,
        yOffset: a.yOffset || 0,
        individualHeight: a.individualHeight || this.drawingArea.height
      })), f = [...t, ...s, ...c].flatMap((a) => a).length;
      return [...t, ...s, ...c].flatMap((a, e) => ({
        id: a.id,
        scaleLabel: a.scaleLabel,
        name: a.name,
        color: a.color,
        scale: a.scale,
        yOffset: a.yOffset,
        individualHeight: a.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / f * (e + 1),
        yLabels: a.scaleYLabels || a.scale.ticks.map((x) => ({
          y: x >= 0 ? a.zero - a.individualHeight * (x / a.max) : a.zero + a.individualHeight * Math.abs(x) / a.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const t = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(t, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(t) {
        return t;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((t) => t.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const t = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...t, span: t.from === t.to ? 1 : t.to < t.from ? 0 : t.to - t.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((t, s) => ({
        ...t,
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((t, s) => ({
        ...t,
        series: t.series.map((c) => this.isSafeValue(c) ? c : null).slice(this.slicer.start, this.slicer.end),
        color: this.convertColorToHex(t.color ? t.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((t, s) => ({
        ...t,
        series: t.series.map((c) => c + this.relativeZero),
        absoluteValues: t.series
      })).filter((t) => !this.segregatedSeries.includes(t.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((t) => {
        const s = t.absoluteValues.map((c) => [void 0, null].includes(c) ? 0 : c);
        return {
          id: t.id,
          name: t.name,
          color: t.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((t, s) => ({
        absoluteIndex: s,
        ...t,
        series: t.series.map((c) => c + this.relativeZero),
        absoluteValues: t.series,
        segregate: () => this.segregate(t),
        isSegregated: this.segregatedSeries.includes(t.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "bar").map((t, s) => {
        this.checkAutoScaleError(t);
        const c = Math.min(...t.absoluteValues.filter((d) => ![null, void 0].includes(d))), f = Math.max(...t.absoluteValues.filter((d) => ![null, void 0].includes(d))), e = {
          ratios: t.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - c) / (f - c)),
          valueMin: c,
          valueMax: f < 0 ? 0 : f
        }, x = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))) > 0 ? 0 : Math.min(...t.absoluteValues.filter((d) => ![null, void 0].includes(d)))
        }, y = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, k = 1.0000001, m = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * k : x.max, y), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * k : e.valueMax, y), P = m.min >= 0 ? 0 : Math.abs(m.min), O = 0, G = m.max + P, p = b.max + Math.abs(O), _ = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, L = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, z = this.drawingArea.bottom - _ - L * P / G, i = this.drawingArea.bottom - _ - L * O / p, o = this.absoluteDataset.filter((d) => d.type === "bar").filter((d) => !this.segregatedSeries.includes(d.id)).length, n = t.series.map((d, F) => {
          const B = this.mutableConfig.useIndividualScale ? (t.absoluteValues[F] + P) / G : this.ratioToMax(d), Y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left + this.slot.bar * s + this.slot.bar * F * o - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(Y),
            y: this.drawingArea.bottom - _ - L * B,
            value: t.absoluteValues[F],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(G),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), g = t.absoluteValues.map((d) => b.min >= 0 ? (d - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (d + Math.abs(b.min)) / (b.max + Math.abs(b.min))), W = t.series.map((d, F) => {
          const B = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * F * this.absoluteDataset.filter((Y) => Y.type === "bar").filter((Y) => !this.segregatedSeries.includes(Y.id)).length;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(B),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(_) - (this.checkNaN(L) * g[F] || 0)),
            value: t.absoluteValues[F],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(G),
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), A = m.ticks.map((d) => ({
          y: d >= 0 ? z - L * (d / G) : z + L * Math.abs(d) / G,
          value: d,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), v = b.ticks.map((d) => {
          const F = (d - b.min) / (b.max - b.min);
          return {
            y: d >= 0 ? i - L * F : i + L * F,
            value: d,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: _,
          autoScaleYLabels: v,
          individualHeight: L,
          scaleYLabels: t.autoScaling ? v : A,
          individualScale: t.autoScaling ? b : m,
          individualMax: t.autoScaling ? p : G,
          zeroPosition: t.autoScaling ? i : z,
          plots: t.autoScaling ? W : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((t) => !this.segregatedSeries.includes(t.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "line").map((t) => {
        this.checkAutoScaleError(t);
        const s = Math.min(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))), c = Math.max(...t.absoluteValues.filter((d) => ![void 0, null].includes(d))) || 1, a = {
          ratios: t.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - s) / (c - s)),
          valueMin: s,
          valueMax: c
        }, e = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || (Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues))
        }, x = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, y = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * y : e.max, x), m = this.calculateNiceScaleWithExactExtremes(a.valueMin, a.valueMax === a.valueMin ? a.valueMax * y : a.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), P = 0, O = k.max + Math.abs(b), G = m.max + Math.abs(P), p = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - p - _ * b / O, z = this.drawingArea.bottom - p - _ * P / G, i = t.series.map((d, F) => {
          const B = this.mutableConfig.useIndividualScale ? (t.absoluteValues[F] + Math.abs(b)) / O : this.ratioToMax(d);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
            y: this.checkNaN(this.drawingArea.bottom - p - _ * B),
            value: t.absoluteValues[F],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), o = t.absoluteValues.map((d) => m.min >= 0 ? (d - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (d + Math.abs(m.min)) / (m.max + Math.abs(m.min))), n = t.series.map((d, F) => [void 0, null].includes(t.absoluteValues[F]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: L,
          value: t.absoluteValues[F],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: this.checkNaN(this.drawingArea.bottom - p - (_ * o[F] || 0)),
          value: t.absoluteValues[F],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        }), g = this.createSmoothPath(i), W = this.createSmoothPath(n), A = k.ticks.map((d) => ({
          y: d >= 0 ? L - _ * (d / O) : L + _ * Math.abs(d) / O,
          value: d,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), v = m.ticks.map((d) => {
          const F = (d - m.min) / (m.max - m.min);
          return {
            y: d >= 0 ? z - _ * F : z + _ * F,
            value: d,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: p,
          autoScaleYLabels: v,
          individualHeight: _,
          scaleYLabels: t.autoScaling ? v : A,
          individualScale: t.autoScaling ? m : k,
          individualMax: t.autoScaling ? G : O,
          zeroPosition: t.autoScaling ? z : L,
          curve: t.autoScaling ? W : g,
          plots: t.autoScaling ? n : i,
          area: t.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(t.autoScaling ? n : i, t.autoScaling ? z : L) : this.createArea(i) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((t) => t.type === "plot").map((t) => {
        this.checkAutoScaleError(t);
        const s = Math.min(...t.absoluteValues.filter((A) => ![null, void 0].includes(A))), c = Math.max(...t.absoluteValues.filter((A) => ![null, void 0].includes(A))) || 1, a = {
          ratios: t.absoluteValues.filter((A) => ![null, void 0].includes(A)).map((A) => (A - s) / (c - s)),
          valueMin: s,
          valueMax: c
        }, e = {
          max: t.scaleMax || Math.max(...t.absoluteValues) || 1,
          min: t.scaleMin || Math.min(...t.absoluteValues) > 0 ? 0 : Math.min(...t.absoluteValues)
        }, x = t.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, y = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * y : e.max, x), m = this.calculateNiceScaleWithExactExtremes(a.valueMin, a.valueMax === a.valueMin ? a.valueMax * y : a.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), P = 0, O = k.max + b, G = m.max + Math.abs(P), p = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - t.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * t.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - p - _ * b / O, z = this.drawingArea.bottom - p - _ * P / G, i = t.series.map((A, v) => {
          const d = this.mutableConfig.useIndividualScale ? (t.absoluteValues[v] + Math.abs(b)) / O : this.ratioToMax(A);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * v),
            y: this.checkNaN(this.drawingArea.bottom - p - _ * d),
            value: t.absoluteValues[v],
            comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[v] || ""
          };
        }), o = t.absoluteValues.map((A) => m.min >= 0 ? (A - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (A + Math.abs(m.min)) / (m.max + Math.abs(m.min))), n = t.series.map((A, v) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * v),
          y: this.checkNaN(this.drawingArea.bottom - p - (_ * o[v] || 0)),
          value: t.absoluteValues[v],
          comment: t.comments && t.comments.slice(this.slicer.start, this.slicer.end)[v] || ""
        })), g = k.ticks.map((A) => ({
          y: A >= 0 ? L - _ * (A / O) : L + _ * Math.abs(A) / O,
          value: A,
          prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: t
        })), W = m.ticks.map((A) => {
          const v = (A - m.min) / (m.max - m.min);
          return {
            y: A >= 0 ? z - _ * v : z + _ * v,
            value: A,
            prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: t
          };
        });
        return {
          ...t,
          yOffset: p,
          autoScaleYLabels: W,
          individualHeight: _,
          scaleYLabels: t.autoScaling ? W : g,
          individualScale: t.autoScaling ? m : k,
          individualMax: t.autoScaling ? G : O,
          zeroPosition: t.autoScaling ? z : L,
          plots: t.autoScaling ? n : i
        };
      });
    },
    drawingArea() {
      const t = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + t,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + t)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((t) => !this.segregatedSeries.includes(t.id)).map((t) => Math.max(...t.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const t = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return t > 0 ? 0 : t;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      return this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((t) => t.type === "bar").filter((t) => !this.segregatedSeries.includes(t.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const t = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / t - this.barPeriodGap * t;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((t) => t !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const t = this.relativeDataset.map((c) => ({
        label: c.name,
        color: c.color,
        type: c.type
      })), s = [];
      return this.timeLabels.forEach((c, f) => {
        const a = [c];
        this.relativeDataset.forEach((e) => {
          a.push(this.canShowValue(e.absoluteValues[f]) ? Number(e.absoluteValues[f].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(a);
      }), { head: t, body: s };
    },
    dataTable() {
      const t = this.FINAL_CONFIG.table.showSum;
      let s = [""].concat(this.relativeDataset.map((e) => e.name));
      t && (s = s.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let c = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((y) => y.absoluteValues[e] ?? 0).reduce((y, k) => y + k, 0);
        c.push(
          [
            this.timeLabels[e] ?? "-"
          ].concat(this.relativeDataset.map(
            (y) => this.applyDataLabel(
              y.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : y.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              y.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: y.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: y.absoluteValues[e] ?? 0,
                s: y.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(t ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const f = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, a = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: s, body: c, config: f, colNames: a };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((t) => ({
        shape: t.shape || null,
        name: t.name,
        color: t.color,
        type: t.type,
        value: t.absoluteValues.find((s, c) => c === this.selectedSerieIndex),
        comments: t.comments || [],
        prefix: t.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: t.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let t = "", s = this.selectedSeries.map((a) => a.value).filter((a) => this.isSafeValue(a) && a !== null).reduce((a, e) => Math.abs(a) + Math.abs(e), 0);
      const c = this.timeLabels[this.selectedSerieIndex], f = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(f) && this.functionReturnsString(() => f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (c && (t += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${c}</div>`), this.selectedSeries.forEach((a) => {
        if (this.isSafeValue(a.value)) {
          let e = "", x = "";
          switch (this.icons[a.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${a.color}" /></svg>`;
              break;
            case "line":
              !a.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(a.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${a.color}" />` : a.shape === "triangle" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : a.shape === "square" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : a.shape === "diamond" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : a.shape === "pentagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : a.shape === "hexagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : a.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${a.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="3" x="0" y="6" stroke="none" height="4" width="20" fill="${a.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!a.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(a.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${a.color}" /></svg>`;
                break;
              }
              if (a.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${a.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (a.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (a.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (a.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (a.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (a.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${a.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          t += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${a.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            a.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : a.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            a.value,
            this.dataLabel({
              p: a.prefix,
              v: a.value,
              s: a.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: a }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(a.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && a.comments.length && a.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (t += `<div class="vue-data-ui-tooltip-comment" style="background:${a.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${a.color}">${a.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${t}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((t) => ({
        y: t >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(t) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(t)),
        value: t,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), document.addEventListener("mousemove", (t) => {
      this.clientPosition = {
        x: t.clientX,
        y: t.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ae,
    assignStackRatios: ie,
    calcLinearProgression: re,
    calculateNiceScaleWithExactExtremes: le,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: oe,
    convertConfigColors: ce,
    convertCustomPalette: he,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: U,
    downloadCsv: fe,
    error: Ne,
    functionReturnsString: me,
    hasDeepProperty: Ie,
    isFunction: xe,
    isSafeValue: be,
    objectIsEmpty: Fe,
    setOpacity: _e,
    shiftHue: ye,
    translateSize: Ae,
    treeShake: Ce,
    useMouse: Oe,
    useNestedProp: Z,
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    getHighlightAreaPosition(t) {
      const s = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (t.from - this.slicer.start), c = this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * t.span;
      return {
        x: s < this.drawingArea.left ? this.drawingArea.left : s,
        width: c
      };
    },
    prepareConfig() {
      const t = Le().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return t;
      const s = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: t
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, s.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
          defaultConfig: s
        }),
        customPalette: this.themePalettes[s.theme] || this.palette
      } : s;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((t, s) => {
        [null, void 0].includes(t.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: s
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((t) => {
        t.series.forEach((s, c) => {
          this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${t.name}' contains the value '${s}' at index ${c}.
'${s}' was converted to null to allow the chart to display.`);
        });
      }), this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const s = this.$refs.chart.parentNode, { height: c, width: f } = s.getBoundingClientRect();
        let a = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (a = this.$refs.chartTitle, e = a.getBoundingClientRect().height);
        let x = null, y = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, y = x.getBoundingClientRect().height);
        let k = null, m = 0;
        this.FINAL_CONFIG.chart.legend.show && (k = this.$refs.chartLegend, m = k.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = c - e - m - y - b, this.width = f, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((O) => {
          for (const G of O)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (y = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (m = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = G.contentBoxSize[0].blockSize - e - m - y - b - 24, this.width = G.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(s);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(t) {
      this.selectedMinimapIndex = t;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(t) {
      t.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${t.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(t) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const s = { x: t[0].x, y: this.zero }, c = { x: t.at(-1).x, y: this.zero }, f = [];
      return t.forEach((a) => {
        f.push(`${a.x},${a.y} `);
      }), [s.x, s.y, ...f, c.x, c.y].toString();
    },
    createIndividualArea(t, s) {
      if (!t[0]) return [-10, -10, "", -10, -10];
      const c = { x: t[0] ? t[0].x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: s }, f = { x: t.at(-1) ? t.at(-1).x : Math.min(...t.filter((e) => !!e).map((e) => e.x)), y: s }, a = [];
      return t.filter((e) => !!e).forEach((e) => {
        a.push(`${e.x},${e.y} `);
      }), [c.x, c.y, ...a, f.x, f.y].toString();
    },
    createStar: q,
    createPolygonPath: R,
    fillArray(t, s) {
      let c = Array(t).fill(0);
      for (let f = 0; f < s.length && f < t; f += 1)
        c[f] = s[f];
      return c;
    },
    refreshSlicer() {
      this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((t) => t.series.length))
      }, this.slicerStep += 1;
    },
    calcRectHeight(t) {
      return t.value >= 0 ? this.checkNaN(this.zero - t.y <= 0 ? 1e-5 : this.zero - t.y) : this.checkNaN(t.y - this.zero <= 0 ? 1e-5 : t.y - this.zero);
    },
    calcIndividualHeight(t) {
      return t.value >= 0 ? this.checkNaN(t.zeroPosition - t.y <= 0 ? 1e-5 : t.zeroPosition - t.y) : this.checkNaN(t.y - t.zeroPosition <= 0 ? 1e-5 : t.zeroPosition - t.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(t) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? t.x + this.drawingArea.width / this.maxSeries * 0.05 : t.x + this.slot.bar / 2;
    },
    calcRectY(t) {
      return t.value >= 0 ? t.y : this.zero;
    },
    calcIndividualRectY(t) {
      return t.value >= 0 ? t.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(t.zeroPosition) ? 0 : t.zeroPosition;
    },
    canShowValue(t) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(t);
    },
    findClosestValue(t, s) {
      let c = s[0], f = Math.abs(t - s[0]);
      for (let a = 1; a < s.length; a += 1) {
        const e = Math.abs(t - s[a]);
        e < f && s[a] < t && (c = s[a], f = e);
      }
      return c;
    },
    ratioToMax(t) {
      return t / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(t) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[t]) ? null : s.absoluteValues[t],
            color: s.color,
            type: s.type
          })),
          index: t,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((t) => ({
        values: t.absoluteValues,
        color: t.color,
        name: t.name,
        type: t.type
      }));
    },
    segregate(t) {
      if (this.segregatedSeries.includes(t.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== t.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(t.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(t, s = null) {
      this.isTooltip = t, t ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(t) {
      this.isFullscreen = t, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./pdf-B7oVat64.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (t) {
          console.error("Error generating PDF:", t);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const t = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], c = this.table.body, f = t.concat([s]).concat(c), a = this.createCsvContent(f);
      this.downloadCsv({ csvContent: a, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: t } = await import("./img-DGzWcJ4Y.js");
          await t({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (t) {
          console.error("Error generating image:", t);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, qe = ["id"], Ue = ["viewBox"], Ze = { key: 0 }, Je = { class: "vue-ui-xy-grid" }, Ke = ["stroke", "x1", "x2", "y1", "y2"], Qe = ["stroke", "x1", "x2", "y1", "y2"], je = { key: 1 }, $e = ["x1", "x2", "y1", "y2", "stroke"], et = ["x1", "x2", "y1", "y2", "stroke"], tt = ["x1", "x2", "y1", "y2", "stroke"], at = { key: 3 }, it = ["x1", "x2", "y1", "y2", "stroke"], rt = ["id"], lt = ["stop-color"], st = ["stop-color"], nt = ["stop-color"], ot = ["id"], ct = ["stop-color"], ht = ["stop-color"], dt = ["stop-color"], ut = ["id"], gt = ["stop-color"], ft = ["stop-color"], Nt = ["id"], mt = ["stop-color"], It = ["stop-color"], xt = ["id"], bt = ["stop-color"], Ft = ["stop-color"], _t = ["x", "y", "height", "width", "fill"], yt = ["x", "y", "width"], At = ["x", "y", "height", "width", "fill"], Ct = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Lt = ["width", "x", "y"], St = { key: 0 }, kt = ["id"], wt = ["fill"], Ot = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Gt = ["x", "y", "font-size", "fill"], vt = ["stroke", "x1", "x2", "y1", "y2"], pt = { key: 2 }, zt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Mt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Pt = { key: 4 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Vt = ["fill", "font-size", "transform"], Rt = ["x1", "x2", "y1", "y2", "stroke"], Dt = ["x", "y", "font-size", "fill"], Wt = ["x1", "x2", "y1", "y2", "stroke"], Ht = ["x", "y", "font-size", "fill"], Et = ["width", "x", "y"], Bt = { style: { width: "100%" } }, Yt = { key: 0 }, Xt = ["id"], qt = ["fill"], Ut = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Zt = ["x", "y", "font-size", "fill"], Jt = ["d", "stroke", "stroke-width", "stroke-dasharray"], Kt = { key: 1 }, Qt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], jt = { key: 0 }, $t = ["d", "fill"], ea = ["d", "fill"], ta = ["d", "stroke", "stroke-width", "stroke-dasharray"], aa = { key: 2 }, ia = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ra = ["width", "x", "y"], la = { style: { width: "100%" } }, sa = { key: 3 }, na = ["id"], oa = ["fill"], ca = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ha = ["x", "y", "font-size", "fill"], da = { key: 5 }, ua = ["x", "y", "font-size", "fill"], ga = ["x", "y", "font-size", "fill", "font-weight"], fa = { key: 6 }, Na = ["x", "y", "font-size", "fill"], ma = ["x", "y"], Ia = ["x", "y"], xa = { key: 7 }, ba = ["x", "y", "font-size", "fill"], Fa = ["x", "y"], _a = ["x", "y"], ya = ["x", "y", "font-size", "fill", "innerHTML"], Aa = ["x", "y", "font-size", "fill", "innerHTML"], Ca = ["x", "y", "font-size", "fill", "innerHTML"], La = ["x", "y", "font-size", "fill", "innerHTML"], Sa = ["x", "y", "width", "height", "fill", "onMouseenter"], ka = ["font-size", "fill", "transform"], wa = ["x", "y", "font-size", "fill"], Oa = { key: 9 }, Ga = ["text-anchor", "font-size", "fill", "transform"], va = ["x", "y", "height", "width", "onMouseenter", "onClick"], pa = { key: 10 }, za = ["x", "y"], Ma = ["cx", "cy", "r", "fill"], Pa = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Ta = ["onClick"], Va = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ra = ["fill"], Da = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Wa = ["fill"], Ha = {
  key: 8,
  ref: "chartLegend"
}, Ea = {
  key: 9,
  ref: "source",
  dir: "auto"
}, Ba = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, Ya = ["innerHTML"];
function Xa(t, s, c, f, a, e) {
  const x = T("PenAndPaper"), y = T("Title"), k = T("UserOptions"), m = T("PackageVersion"), b = T("Shape"), P = T("Skeleton"), O = T("Slicer"), G = T("Tooltip"), p = T("BaseIcon"), _ = T("TableSparkline"), L = T("DataTable"), z = T("Accordion");
  return r(), l("div", {
    id: `vue-ui-xy_${a.uniqueId}`,
    class: V(`vue-ui-xy ${a.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: C(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;${e.FINAL_CONFIG.chart.title.text ? "" : "padding-top:36px"};font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (r(), D(x, {
      key: 0,
      parent: t.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: a.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : h("", !0),
    e.FINAL_CONFIG.chart.title.show ? (r(), l("div", {
      key: 1,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: C(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (r(), D(y, {
        key: `title_${a.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : h("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (r(), D(k, {
      ref: "defails",
      key: `user_options_${a.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: a.isPrinting,
      isImaging: a.isImaging,
      uid: a.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: c.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: a.mutableConfig.isStacked,
      isFullscreen: a.isFullscreen,
      chartElement: t.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: a.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: a.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator
    }, De({ _: 2 }, [
      t.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: M(() => [
          w(t.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      t.$slots.optionPdf ? {
        name: "optionPdf",
        fn: M(() => [
          w(t.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      t.$slots.optionCsv ? {
        name: "optionCsv",
        fn: M(() => [
          w(t.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      t.$slots.optionImg ? {
        name: "optionImg",
        fn: M(() => [
          w(t.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      t.$slots.optionTable ? {
        name: "optionTable",
        fn: M(() => [
          w(t.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      t.$slots.optionLabels ? {
        name: "optionLabels",
        fn: M(() => [
          w(t.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      t.$slots.optionStack ? {
        name: "optionStack",
        fn: M(() => [
          w(t.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      t.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: M(({ toggleFullscreen: i, isFullscreen: o }) => [
          w(t.$slots, "optionFullscreen", H(E({ toggleFullscreen: i, isFullscreen: o })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      t.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: M(({ toggleAnnotator: i, isAnnotator: o }) => [
          w(t.$slots, "optionAnnotator", H(E({ toggleAnnotator: i, isAnnotator: o })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator"])) : h("", !0),
    e.isDataset ? (r(), l("svg", {
      key: 3,
      xmlns: "http://www.w3.org/2000/svg",
      class: V([{ "vue-data-ui-fullscreen--on": a.isFullscreen, "vue-data-ui-fulscreen--off": !a.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: a.viewBox,
      style: C(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(m),
      e.maxSeries > 0 ? (r(), l("g", Ze, [
        u("g", Je, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (r(), l("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, Ke)) : h("", !0),
          a.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(!0), l(N, { key: 2 }, I(e.allScales, (i) => (r(), l("g", null, [
            i.id === a.selectedScale && i.yLabels.length ? (r(!0), l(N, { key: 0 }, I(i.yLabels, (o) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: i.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, et))), 256)) : i.yLabels.length ? (r(!0), l(N, { key: 1 }, I(i.yLabels, (o) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, tt))), 256)) : h("", !0)
          ]))), 256)) : h("", !0) : (r(), l(N, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (r(), l("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, Qe)) : h("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(), l("g", je, [
              (r(!0), l(N, null, I(e.yLabels, (i) => (r(), l("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(i.y),
                y2: e.checkNaN(i.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, $e))), 256))
            ])) : h("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (r(), l("g", at, [
            (r(!0), l(N, null, I(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (i, o) => (r(), l("line", {
              key: `grid_vertical_line_${o}`,
              x1: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, it))), 128))
          ])) : h("", !0)
        ]),
        (r(!0), l(N, null, I(e.barSet, (i, o) => (r(), l("defs", {
          key: `def_rect_${o}`
        }, [
          u("linearGradient", {
            id: `rectGradient_pos_${o}_${a.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": i.color
            }, null, 8, lt),
            u("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, st),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, nt)
          ], 8, rt),
          u("linearGradient", {
            id: `rectGradient_neg_${o}_${a.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, ct),
            u("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(i.color, 0.02)}`
            }, null, 8, ht),
            u("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, dt)
          ], 8, ot)
        ]))), 128)),
        (r(!0), l(N, null, I(e.plotSet, (i, o) => (r(), l("defs", {
          key: `def_plot_${o}`
        }, [
          u("radialGradient", {
            id: `plotGradient_${o}_${a.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, gt),
            u("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, ft)
          ], 8, ut)
        ]))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (i, o) => (r(), l("defs", {
          key: `def_line_${o}`
        }, [
          u("radialGradient", {
            id: `lineGradient_${o}_${a.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(i.color, 0.05)}`
            }, null, 8, mt),
            u("stop", {
              offset: "100%",
              "stop-color": i.color
            }, null, 8, It)
          ], 8, Nt),
          u("linearGradient", {
            id: `areaGradient_${o}_${a.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(i.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, bt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, Ft)
          ], 8, xt)
        ]))), 128)),
        (r(!0), l(N, null, I(e.highlightAreas, (i) => (r(), l("g", null, [
          i.show ? (r(!0), l(N, { key: 0 }, I(i.span, (o, n) => (r(), l("g", null, [
            u("rect", {
              style: C({
                transition: "none",
                opacity: i.from + n >= a.slicer.start && i.from + n <= a.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - a.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(i.color, i.opacity)
            }, null, 12, _t),
            i.caption.text && n === 0 ? (r(), l("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (i.from + n - a.slicer.start) - (i.caption.width === "auto" ? 0 : i.caption.width / 2 - e.drawingArea.width / e.maxSeries * i.span / 2),
              y: e.drawingArea.top + i.caption.offsetY,
              style: C({
                overflow: "visible",
                opacity: i.to >= a.slicer.start && i.from < a.slicer.end ? 1 : 0
              }),
              height: "1",
              width: i.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * i.span : i.caption.width
            }, [
              u("div", {
                style: C(`padding:${i.caption.padding}px;text-align:${i.caption.textAlign};font-size:${i.caption.fontSize}px;color:${i.caption.color};font-weight:${i.caption.bold ? "bold" : "normal"}`)
              }, S(i.caption.text), 5)
            ], 12, yt)) : h("", !0)
          ]))), 256)) : h("", !0)
        ]))), 256)),
        u("g", null, [
          (r(!0), l(N, null, I(e.maxSeries, (i, o) => (r(), l("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [a.selectedMinimapIndex, a.selectedSerieIndex, a.selectedRowIndex].includes(o) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, At)
          ]))), 128))
        ]),
        e.barSet.length ? (r(!0), l(N, { key: 0 }, I(e.barSet, (i, o) => (r(), l("g", {
          key: `serie_bar_${o}`,
          class: V(`serie_bar_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
            key: `bar_plot_${o}_${g}`
          }, [
            e.canShowValue(n.value) ? (r(), l("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: a.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: a.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${o}_${a.uniqueId})` : `url(#rectGradient_neg_${o}_${a.uniqueId})` : i.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? i.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, Ct)) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              w(t.$slots, "plot-comment", {
                plot: { ...n, color: i.color, seriesIndex: o, datapointIndex: g }
              }, void 0, !0)
            ], 8, Lt)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", St, [
            u("defs", null, [
              u("marker", {
                id: `bar_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, wt)
              ], 8, kt)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${o})`
            }, null, 8, Ot)) : h("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": a.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Gt)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)) : h("", !0),
        !a.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (r(), l("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, vt)) : h("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(a.selectedSerieIndex) || a.selectedMinimapIndex !== null) ? (r(), l("g", pt, [
          u("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.selectedSerieIndex || a.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.selectedSerieIndex || a.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, zt)
        ])) : h("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (r(), l("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Mt)) : h("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (r(), l("g", Pt, [
          a.mutableConfig.useIndividualScale ? (r(), l(N, { key: 0 }, [
            (r(!0), l(N, null, I(e.allScales, (i) => (r(), l("g", null, [
              u("line", {
                x1: i.x + e.xPadding,
                x2: i.x + e.xPadding,
                y1: a.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - i.yOffset - i.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: a.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - i.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: i.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Tt)
            ]))), 256)),
            (r(!0), l(N, null, I(e.allScales, (i) => (r(), l("g", {
              style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              u("text", {
                fill: i.color,
                "font-size": a.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${a.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset - i.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(i.name) + " " + S(i.scaleLabel ? `- ${i.scaleLabel}` : ""), 9, Vt),
              (r(!0), l(N, null, I(i.yLabels, (o, n) => (r(), l("line", {
                x1: i.x - 3 + e.xPadding,
                x2: i.x + e.xPadding,
                y1: e.checkNaN(o.y),
                y2: e.checkNaN(o.y),
                stroke: i.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Rt))), 256)),
              (r(!0), l(N, null, I(i.yLabels, (o, n) => (r(), l("text", {
                x: i.x - 5 + e.xPadding,
                y: e.checkNaN(o.y) + a.fontSizes.dataLabels / 3,
                "font-size": a.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: i.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                o.value,
                e.dataLabel({
                  p: o.prefix,
                  v: o.value,
                  s: o.suffix,
                  r: 1
                }),
                { datapoint: o.datapoint, seriesIndex: n }
              )), 9, Dt))), 256))
            ], 4))), 256))
          ], 64)) : (r(!0), l(N, { key: 1 }, I(e.yLabels, (i, o) => (r(), l("g", {
            key: `yLabel_${o}`
          }, [
            e.canShowValue(i) && i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (r(), l("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(i.y),
              y2: e.checkNaN(i.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Wt)) : h("", !0),
            i.value >= e.niceScale.min && i.value <= e.niceScale.max ? (r(), l("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(i.y + a.fontSizes.dataLabels / 3),
              "font-size": a.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(i.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              i.value,
              e.dataLabel({
                p: i.prefix,
                v: i.value,
                s: i.suffix,
                r: 1
              })
            ) : ""), 9, Ht)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        (r(!0), l(N, null, I(e.plotSet, (i, o) => (r(), l("g", {
          key: `serie_plot_${o}`,
          class: V(`serie_plot_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
            key: `circle_plot_${o}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${o}_${a.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? i.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: a.selectedSerieIndex !== null && a.selectedSerieIndex === g || a.selectedMinimapIndex !== null && a.selectedMinimapIndex === g ? (a.plotRadii.plot || 6) * 1.5 : a.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", Bt, [
                w(t.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: o, datapointIndex: g }
                }, void 0, !0)
              ])
            ], 8, Et)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", Yt, [
            u("defs", null, [
              u("marker", {
                id: `plot_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, qt)
              ], 8, Xt)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${o})`
            }, null, 8, Ut)) : h("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": a.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Zt)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (i, o) => (r(), l("g", {
          key: `serie_line_${o}`,
          class: V(`serie_line_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.smooth && i.plots.length > 1 ? (r(), l("path", {
            key: 0,
            d: `M${i.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Jt)) : i.plots.length > 1 ? (r(), l("g", Kt, [
            (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < i.plots.length - 1 && i.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(i.plots[g + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: i.plots[g + 1].x,
                y1: n.y,
                y2: i.plots[g + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, Qt)) : h("", !0)
            ]))), 128))
          ])) : h("", !0)
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (i, o) => (r(), l("g", {
          key: `serie_line_${o}`,
          class: V(`serie_line_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          i.useArea && i.plots.length > 1 ? (r(), l("g", jt, [
            i.smooth ? (r(), l("path", {
              key: 0,
              d: `M ${i.plots[0] ? i.plots[0].x : Math.min(...i.plots.filter((n) => !!n).map((n) => n.x))},${a.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} ${i.curve} L ${i.plots.at(-1) ? i.plots.at(-1).x : e.drawingArea.left + e.slot.line * o + e.slot.line / 2},${a.mutableConfig.isStacked ? e.drawingArea.bottom - i.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${a.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, $t)) : (r(), l("path", {
              key: 1,
              d: `M${i.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${a.uniqueId})` : e.setOpacity(i.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ea))
          ])) : h("", !0),
          i.smooth && i.plots.length > 1 ? (r(), l("path", {
            key: 1,
            d: `M${i.curve}`,
            stroke: i.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ta)) : i.plots.length > 1 ? (r(), l("g", aa, [
            (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < i.plots.length - 1 && i.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(i.plots[g + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: i.plots[g + 1].x,
                y1: n.y,
                y2: i.plots[g + 1].y,
                stroke: i.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": i.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, ia)) : h("", !0)
            ]))), 128))
          ])) : h("", !0),
          (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
            key: `circle_line_${o}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${o}_${a.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? i.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: a.selectedSerieIndex !== null && a.selectedSerieIndex === g || a.selectedMinimapIndex !== null && a.selectedMinimapIndex === g ? (a.plotRadii.line || 6) * 1.5 : a.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : i.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : h("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", la, [
                w(t.$slots, "plot-comment", {
                  plot: { ...n, color: i.color, seriesIndex: o, datapointIndex: g }
                }, void 0, !0)
              ])
            ], 8, ra)) : h("", !0)
          ]))), 128)),
          Object.hasOwn(i, "useProgression") && i.useProgression === !0 && !isNaN(e.calcLinearProgression(i.plots).trend) ? (r(), l("g", sa, [
            u("defs", null, [
              u("marker", {
                id: `line_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: i.color
                }, null, 8, oa)
              ], 8, na)
            ]),
            i.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(i.plots).x1,
              x2: e.calcLinearProgression(i.plots).x2,
              y1: e.calcLinearProgression(i.plots).y1,
              y2: e.calcLinearProgression(i.plots).y2,
              "stroke-width": 1,
              stroke: i.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${o})`
            }, null, 8, ca)) : h("", !0),
            i.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(i.plots).x2,
              y: e.calcLinearProgression(i.plots).y2 - 6,
              "font-size": a.fontSizes.plotLabels,
              fill: i.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(i.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ha)) : h("", !0)
          ])) : h("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && a.mutableConfig.dataLabels.show ? (r(), l("g", da, [
          (r(!0), l(N, null, I(e.barSet, (i, o) => (r(), l("g", {
            key: `xLabel_bar_${o}`,
            class: V(`xLabel_bar_${o}`),
            style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
              key: `xLabel_bar_${o}_${g}`
            }, [
              n && (!Object.hasOwn(i, "dataLabels") || i.dataLabels === !0) && e.FINAL_CONFIG.bar.labels.show ? (r(), l("text", {
                key: 0,
                x: a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value > 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": a.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, ua)) : h("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (r(), l("text", {
                key: 1,
                x: a.mutableConfig.useIndividualScale && a.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": a.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? i.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: i.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : i.name), 9, ga)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.plot.labels.show && a.mutableConfig.dataLabels.show ? (r(), l("g", fa, [
          (r(!0), l(N, null, I(e.plotSet, (i, o) => (r(), l("g", {
            key: `xLabel_plot_${o}`,
            class: V(`xLabel_plot_${o}`),
            style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
              key: `xLabel_plot_${o}_${g}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": a.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, Na)) : h("", !0),
              n && g === 0 && i.useTag && i.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${a.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, ma)) : h("", !0),
              n && g === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (a.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${a.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, Ia)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        e.FINAL_CONFIG.line.labels.show && a.mutableConfig.dataLabels.show ? (r(), l("g", xa, [
          (r(!0), l(N, null, I(e.lineSet, (i, o) => (r(), l("g", {
            key: `xLabel_line_${o}`,
            class: V(`xLabel_line_${o}`),
            style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
              key: `xLabel_line_${o}_${g}`
            }, [
              n && !Object.hasOwn(i, "dataLabels") || i.dataLabels === !0 ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": a.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: i.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: i.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: i
                }
              ) : ""), 9, ba)) : h("", !0),
              n && g === 0 && i.useTag && i.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${a.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, Fa)) : h("", !0),
              n && g === i.plots.length - 1 && i.useTag && i.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - i.name.length * (a.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(i.color, 80)};color:${e.adaptColorToBackground(i.color)};width:fit-content;font-size:${a.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(i.name), 5)
              ], 8, _a)) : h("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : h("", !0),
        (r(!0), l(N, null, I(e.lineSet, (i, o) => (r(), l("g", {
          key: `xLabel_line_${o}`,
          class: V(`xLabel_line_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
            key: `xLabel_line_${o}_${g}`
          }, [
            n && g === 0 && i.showSerieName && i.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - a.fontSizes.plotLabels,
              y: n.y,
              "font-size": a.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: a.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - a.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ya)) : h("", !0),
            n && g === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + a.fontSizes.plotLabels,
              y: n.y,
              "font-size": a.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: a.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + a.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Aa)) : h("", !0)
          ]))), 128))
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.plotSet, (i, o) => (r(), l("g", {
          key: `xLabel_plot_${o}`,
          class: V(`xLabel_plot_${o}`),
          style: C(`opacity:${a.selectedScale ? a.selectedScale === i.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(i.plots, (n, g) => (r(), l("g", {
            key: `xLabel_plot_${o}_${g}`
          }, [
            n && g === 0 && i.showSerieName && i.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - a.fontSizes.plotLabels,
              y: n.y,
              "font-size": a.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: a.fontSizes.plotLabels,
                fill: i.color,
                x: n.x - a.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ca)) : h("", !0),
            n && g === i.plots.length - 1 && i.showSerieName && i.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + a.fontSizes.plotLabels,
              y: n.y,
              "font-size": a.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: i.color,
              innerHTML: e.createTSpans({
                content: i.name,
                fontSize: a.fontSizes.plotLabels,
                fill: i.color,
                x: n.x + a.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, La)) : h("", !0)
          ]))), 128))
        ], 6))), 128)),
        a.mutableConfig.useIndividualScale && !a.mutableConfig.isStacked ? (r(!0), l(N, { key: 8 }, I(e.allScales, (i) => (r(), l("rect", {
          x: i.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: a.selectedScale === i.id ? e.setOpacity(i.color, 20) : "transparent",
          onMouseenter: (o) => a.selectedScale = i.id,
          onMouseleave: s[0] || (s[0] = (o) => a.selectedScale = null)
        }, null, 40, Sa))), 256)) : h("", !0),
        u("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !a.mutableConfig.useIndividualScale ? (r(), l("text", {
            key: 0,
            "font-size": a.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${a.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, ka)) : h("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (r(), l("text", {
            key: 1,
            "text-anchor": "middle",
            x: a.width / 2,
            y: e.drawingArea.bottom + a.fontSizes.yAxis + a.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": a.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, wa)) : h("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (r(), l("g", Oa, [
          (r(!0), l(N, null, I(e.timeLabels, (i, o) => (r(), l("g", {
            key: `time_label_${o}`
          }, [
            i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (o === 0 || o === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && a.selectedSerieIndex === o && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || i && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && o % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (r(), l("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": a.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * o + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + a.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`
            }, S(i || ""), 9, Ga)) : h("", !0)
          ]))), 128))
        ])) : h("", !0),
        u("g", null, [
          (r(!0), l(N, null, I(e.maxSeries, (i, o) => (r(), l("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, o),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(o)
            }, null, 40, va)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && ![null, void 0].includes(a.selectedSerieIndex) ? (r(), l("g", pa, [
          (r(), l("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * a.selectedSerieIndex - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            u("div", {
              class: "vue-ui-xy-time-tag",
              style: C(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[a.selectedSerieIndex] || a.selectedSerieIndex), 5)
          ], 8, za)),
          u("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * a.selectedSerieIndex + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Ma)
        ])) : h("", !0)
      ])) : h("", !0),
      w(t.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Ue)) : h("", !0),
    t.$slots.watermark ? (r(), l("div", Pa, [
      w(t.$slots, "watermark", H(E({ isPrinting: a.isPrinting || a.isImaging })), void 0, !0)
    ])) : h("", !0),
    e.isDataset ? h("", !0) : (r(), D(P, {
      key: 5,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && a.maxX > 6 && e.isDataset ? (r(), D(O, {
      ref: "chartSlicer",
      key: `slicer_${a.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[a.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[a.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: a.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: a.maxX,
      min: 0,
      valueStart: a.slicer.start,
      valueEnd: a.slicer.end,
      start: a.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (i) => a.slicer.start = i),
      end: a.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (i) => a.slicer.end = i),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": M(({ reset: i }) => [
        w(t.$slots, "reset-action", H(E({ reset: i })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "onReset", "onTrapMouse"])) : h("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (r(), l("div", {
      key: 7,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: C(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (r(!0), l(N, null, I(e.absoluteDataset, (i, o) => (r(), l("div", {
        key: `div_legend_item_${o}`,
        onClick: (n) => e.segregate(i),
        class: V({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": a.segregatedSeries.includes(i.id) })
      }, [
        a.icons[i.type] === "line" ? (r(), l("svg", Va, [
          u("rect", {
            x: "0",
            y: "7",
            rx: "3",
            stroke: "none",
            height: "4",
            width: "20",
            fill: i.color
          }, null, 8, Ra),
          X(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 1
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (r(), l("svg", Da, [
          a.icons[i.type] === "bar" ? (r(), l("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: i.color
          }, null, 8, Wa)) : (r(), D(b, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: i.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(i.shape) ? i.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        u("span", {
          style: C(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(i.name), 5)
      ], 10, Ta))), 128))
    ], 4)) : (r(), l("div", Ha, [
      w(t.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    t.$slots.source ? (r(), l("div", Ea, [
      w(t.$slots, "source", {}, void 0, !0)
    ], 512)) : h("", !0),
    X(G, {
      show: a.mutableConfig.showTooltip && a.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: t.$refs.chart,
      content: e.tooltipContent,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": M(() => [
        w(t.$slots, "tooltip-before", H(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": M(() => [
        w(t.$slots, "tooltip-after", H(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
    e.isDataset ? (r(), D(z, {
      key: 10,
      hideDetails: "",
      config: {
        open: a.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: M(() => [
        u("div", {
          style: C(`${a.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          u("div", Ba, [
            We(u("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (i) => a.showSparklineTable = i)
            }, null, 512), [
              [He, a.showSparklineTable]
            ]),
            u("div", {
              onClick: s[5] || (s[5] = (i) => a.showSparklineTable = !a.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(p, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          a.showSparklineTable ? (r(), D(_, {
            key: `sparkline_${a.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (r(), D(L, {
            key: `table_${a.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (i) => a.mutableConfig.showTable = !1)
          }, {
            th: M(({ th: i }) => [
              u("div", { innerHTML: i }, null, 8, Ya)
            ]),
            td: M(({ td: i }) => [
              Ee(S(isNaN(Number(i)) ? i : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: i,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : h("", !0)
  ], 14, qe);
}
const oi = /* @__PURE__ */ Be(Xe, [["render", Xa], ["__scopeId", "data-v-fd323aed"]]);
export {
  oi as default
};
