import { computed as h, onMounted as Pe, ref as u, watch as Se, openBlock as s, createElementBlock as n, normalizeClass as F, normalizeStyle as H, createBlock as $, createCommentVNode as i, unref as p, createSlots as Ne, withCtx as c, renderSlot as v, normalizeProps as S, guardReactiveProps as N, createVNode as re, createElementVNode as x, Fragment as ue, renderList as ne, createTextVNode as ie, toDisplayString as E, nextTick as Le } from "vue";
import { u as Ie, o as Oe, e as ce, g as Ae, c as ve, t as Fe, a as Ee, p as D, b as De, d as Ve, I as de, L as Be, f as k, X as Ge, i as he, x as pe, y as Me, q as ze, r as We } from "./index-Bya_q1J-.js";
import { L as He } from "./Legend-DNgTCgEK.js";
import { _ as Ue } from "./Title-C5pIfQAz.js";
import { _ as Xe } from "./Tooltip-Cz24YLfw.js";
import { D as Re } from "./DataTable-DYqC2pqu.js";
import { u as Ye, U as je } from "./usePrinter-CiHd1FwD.js";
import qe from "./vue-ui-skeleton-BYssP0K4.js";
import Je from "./vue-ui-accordion-DfUfL2dI.js";
import { u as ye } from "./useNestedProp-B33hazbH.js";
import { _ as Ke } from "./PackageVersion-VkaUzgmt.js";
import { P as Qe } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const et = ["id"], tt = {
  key: 1,
  style: "width:100%;background:transparent;padding-bottom:24px"
}, lt = ["xmlns", "viewBox"], at = ["id"], ot = ["stdDeviation"], st = ["d", "stroke", "stroke-width"], rt = ["d", "stroke", "stroke-width"], ut = ["filter"], nt = ["d", "stroke", "stroke-width"], it = ["d", "stroke-width", "onMouseenter", "onClick"], ct = {
  key: 4,
  class: "vue-data-ui-watermark"
}, vt = ["onClick"], dt = { key: 0 }, ht = { key: 1 }, pt = {
  key: 7,
  ref: "source",
  dir: "auto"
}, yt = ["innerHTML"], ft = {
  __name: "vue-ui-galaxy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(fe, { expose: ge, emit: U }) {
    const y = fe, { vue_ui_galaxy: be } = Ie(), L = h(() => !!y.dataset && y.dataset.length);
    Pe(() => {
      X();
    });
    function X() {
      Oe(y.dataset) ? ce({
        componentName: "VueUiGalaxy",
        type: "dataset"
      }) : y.dataset.forEach((t, a) => {
        Ae({
          datasetObject: t,
          requiredAttributes: ["name", "values"]
        }).forEach((l) => {
          ce({
            componentName: "VueUiGalaxy",
            type: "datasetSerieAttribute",
            property: l,
            index: a
          });
        });
      });
    }
    const _ = u(ve()), I = u(null), me = u(null), V = u(!1), B = u(""), f = u(null), R = u(0), Y = u(0), j = u(0), q = u(0), e = h({
      get: () => J(),
      set: (t) => t
    });
    function J() {
      const t = ye({
        userConfig: y.config,
        defaultConfig: be
      });
      return t.theme ? {
        ...ye({
          userConfig: Fe.vue_ui_galaxy[t.theme] || y.config,
          defaultConfig: t
        }),
        customPalette: Ee[t.theme] || D
      } : t;
    }
    Se(() => y.config, (t) => {
      e.value = J(), X(), Y.value += 1, j.value += 1, q.value += 1;
    }, { deep: !0 });
    const { isPrinting: K, isImaging: Q, generatePdf: Z, generateImage: ee } = Ye({
      elementId: `galaxy_${_.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-galaxy"
    }), ke = h(() => De(e.value.customPalette)), b = u({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), G = u({
      height: 180,
      // or 250 if non fibo
      width: 250
    }), d = u([]);
    function M(t) {
      d.value.includes(t.id) ? d.value = d.value.filter((a) => a !== t.id) : d.value.push(t.id), U("selectLegend", T.value.map((a) => ({
        name: a.name,
        color: a.color,
        value: a.value
      })));
    }
    const C = h(() => y.dataset.map((t, a) => ({
      name: t.name,
      color: Ve(t.color) || ke.value[a] || D[a] || D[a % D.length],
      value: t.values ? de(t.values).reduce((l, o) => l + o, 0) : 0,
      absoluteValues: de(t.values),
      id: ve(),
      seriesIndex: a
    })).sort((t, a) => a.value - t.value));
    function Ce() {
      return C.value.map((t) => ({
        name: t.name,
        color: t.color,
        value: t.value
      }));
    }
    const g = h(() => C.value.filter((t) => !d.value.includes(t.id)).map((t) => t.value).reduce((t, a) => t + a, 0)), we = u(190), te = h(() => C.value.filter((t) => !d.value.includes(t.id))), T = h(() => {
      const t = [];
      for (let a = 0; a < te.value.length; a += 1) {
        const l = te.value[a];
        let o = l.value / g.value * we.value;
        a > 0 && t.length && (o += t[a - 1].points), t.push({
          points: o,
          ...l,
          seriesIndex: a,
          proportion: l.value / g.value,
          path: Be({
            points: o,
            startX: 115 + e.value.style.chart.layout.arcs.offsetX,
            startY: 90 + e.value.style.chart.layout.arcs.offsetY
          })
        });
      }
      return t.filter((a, l) => !d.value.includes(a.id)).toSorted((a, l) => l.points - a.points);
    }), P = u(!1);
    function $e(t) {
      P.value = t, R.value += 1;
    }
    const z = u(null);
    function xe({ datapoint: t, _relativeIndex: a, seriesIndex: l, show: o = !1 }) {
      z.value = {
        datapoint: t,
        seriesIndex: l,
        series: C.value,
        config: e.value
      }, V.value = o, f.value = t.id;
      let r = "";
      const w = e.value.style.chart.tooltip.customFormat;
      pe(w) && Me(() => w({
        seriesIndex: l,
        datapoint: t,
        series: C.value,
        config: e.value
      })) ? B.value = w({
        seriesIndex: l,
        datapoint: t,
        series: C.value,
        config: e.value
      }) : (r += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.name}</div>`, r += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${t.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (r += `<b>${he(
        e.value.style.chart.layout.labels.dataLabels.formatter,
        t.value,
        k({
          p: e.value.style.chart.layout.labels.dataLabels.prefix,
          v: t.value,
          s: e.value.style.chart.layout.labels.dataLabels.suffix,
          r: e.value.style.chart.tooltip.roundingValue
        }),
        { datapoint: t, seriesIndex: l }
      )}</b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? r += `<span>(${k({
        v: t.proportion * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })})</span></div>` : r += `<b>${k({
        v: t.proportion * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })}</b></div>`), B.value = `<div>${r}</div>`);
    }
    const le = h(() => C.value.map((t, a) => ({
      ...t,
      proportion: (t.value || 0) / y.dataset.map((l) => (l.values || []).reduce((o, r) => o + r, 0)).reduce((l, o) => l + o, 0),
      opacity: d.value.includes(t.id) ? 0.5 : 1,
      shape: t.shape || "circle",
      segregate: () => M(t),
      isSegregated: d.value.includes(t.id)
    }))), _e = h(() => ({
      cy: "galaxy-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), m = h(() => {
      const t = T.value.map((l) => ({
        name: l.name,
        color: l.color
      })), a = T.value.map((l) => l.value);
      return { head: t, body: a };
    });
    function ae() {
      Le(() => {
        const t = m.value.head.map((o, r) => [[
          o.name
        ], [m.value.body[r]], [isNaN(m.value.body[r] / g.value) ? "-" : m.value.body[r] / g.value * 100]]), a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), l = ze(a);
        We({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-galaxy" });
      });
    }
    const O = h(() => {
      const t = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        k({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: g.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], a = m.value.head.map((r, w) => {
        const Te = k({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: m.value.body[w], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: r.color,
            name: r.name
          },
          Te,
          isNaN(m.value.body[w] / g.value) ? "-" : k({
            v: m.value.body[w] / g.value * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: t,
        body: a,
        config: l
      };
    });
    function oe() {
      b.value.showTable = !b.value.showTable;
    }
    function se() {
      b.value.showTooltip = !b.value.showTooltip;
    }
    const A = u(!1);
    function W() {
      A.value = !A.value;
    }
    return ge({
      getData: Ce,
      generatePdf: Z,
      generateCsv: ae,
      generateImage: ee,
      toggleTable: oe,
      toggleTooltip: se,
      toggleAnnotator: W
    }), (t, a) => (s(), n("div", {
      ref_key: "galaxyChart",
      ref: I,
      class: F(`vue-ui-galaxy ${P.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: H(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `galaxy_${_.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (s(), $(Qe, {
        key: 0,
        parent: I.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: A.value,
        onClose: W
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : i("", !0),
      e.value.style.chart.title.text ? (s(), n("div", tt, [
        (s(), $(Ue, {
          key: `title_${Y.value}`,
          config: {
            title: {
              cy: "galaxy-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "galaxy-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : i("", !0),
      e.value.userOptions.show && L.value ? (s(), $(je, {
        ref_key: "details",
        ref: me,
        key: `user_option_${R.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: p(K),
        isImaging: p(Q),
        uid: _.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: b.value.showTooltip,
        isFullscreen: P.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: I.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: A.value,
        onToggleFullscreen: $e,
        onGeneratePdf: p(Z),
        onGenerateCsv: ae,
        onGenerateImage: p(ee),
        onToggleTable: oe,
        onToggleTooltip: se,
        onToggleAnnotator: W
      }, Ne({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: c(() => [
            v(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: c(() => [
            v(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: c(() => [
            v(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: c(() => [
            v(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: c(() => [
            v(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: c(({ toggleFullscreen: l, isFullscreen: o }) => [
            v(t.$slots, "optionFullscreen", S(N({ toggleFullscreen: l, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: c(({ toggleAnnotator: l, isAnnotator: o }) => [
            v(t.$slots, "optionAnnotator", S(N({ toggleAnnotator: l, isAnnotator: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : i("", !0),
      L.value ? (s(), n("svg", {
        key: 3,
        xmlns: p(Ge),
        class: F({ "vue-data-ui-fullscreen--on": P.value, "vue-data-ui-fulscreen--off": !P.value }),
        viewBox: `0 0 ${G.value.width} ${G.value.height}`,
        style: H(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        re(Ke),
        x("defs", null, [
          x("filter", {
            id: `blur_${_.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            x("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 100 / e.value.style.chart.layout.arcs.gradient.intensity
            }, null, 8, ot)
          ], 8, at)
        ]),
        (s(!0), n(ue, null, ne(T.value, (l) => (s(), n("g", null, [
          l.value ? (s(), n("path", {
            key: 0,
            d: l.path,
            fill: "none",
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": (e.value.style.chart.layout.arcs.strokeWidth + e.value.style.chart.layout.arcs.borderWidth) * (f.value === l.id && e.value.style.chart.layout.arcs.hoverEffect.show ? e.value.style.chart.layout.arcs.hoverEffect.multiplicator : 1),
            "stroke-linecap": "round"
          }, null, 8, st)) : i("", !0),
          l.value ? (s(), n("path", {
            key: 1,
            d: l.path,
            fill: "none",
            stroke: l.color,
            "stroke-width": e.value.style.chart.layout.arcs.strokeWidth * (f.value === l.id && e.value.style.chart.layout.arcs.hoverEffect.show ? e.value.style.chart.layout.arcs.hoverEffect.multiplicator : 1),
            "stroke-linecap": "round",
            class: F(`${f.value && f.value !== l.id && e.value.useBlurOnHover ? "vue-ui-galaxy-blur" : ""}`)
          }, null, 10, rt)) : i("", !0),
          l.value && e.value.style.chart.layout.arcs.gradient.show ? (s(), n("g", {
            key: 2,
            filter: `url(#blur_${_.value})`
          }, [
            x("path", {
              d: l.path,
              fill: "none",
              stroke: e.value.style.chart.layout.arcs.gradient.color,
              "stroke-width": e.value.style.chart.layout.arcs.strokeWidth / 2 * (f.value === l.id && e.value.style.chart.layout.arcs.hoverEffect.show ? e.value.style.chart.layout.arcs.hoverEffect.multiplicator : 1),
              "stroke-linecap": "round",
              class: F(`vue-ui-galaxy-gradient ${f.value && f.value !== l.id && e.value.useBlurOnHover ? "vue-ui-galaxy-blur" : ""}`)
            }, null, 10, nt)
          ], 8, ut)) : i("", !0)
        ]))), 256)),
        (s(!0), n(ue, null, ne(T.value, (l, o) => (s(), n("g", null, [
          l.value ? (s(), n("path", {
            key: 0,
            d: l.path,
            fill: "none",
            stroke: "transparent",
            "stroke-width": e.value.style.chart.layout.arcs.strokeWidth + e.value.style.chart.layout.arcs.borderWidth,
            "stroke-linecap": "round",
            onMouseenter: (r) => xe({
              datapoint: l,
              relativeIndex: o,
              seriesIndex: l.seriesIndex,
              show: !0
            }),
            onMouseleave: a[0] || (a[0] = (r) => {
              V.value = !1, f.value = null;
            }),
            onClick: (r) => U("selectDatapoint", l)
          }, null, 40, it)) : i("", !0)
        ]))), 256)),
        v(t.$slots, "svg", { svg: G.value }, void 0, !0)
      ], 14, lt)) : i("", !0),
      t.$slots.watermark ? (s(), n("div", ct, [
        v(t.$slots, "watermark", S(N({ isPrinting: p(K) || p(Q) })), void 0, !0)
      ])) : i("", !0),
      L.value ? i("", !0) : (s(), $(qe, {
        key: 5,
        config: {
          type: "galaxy",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            galaxy: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.chart.legend.show ? (s(), $(He, {
        key: `legend_${q.value}`,
        legendSet: le.value,
        config: _e.value,
        onClickMarker: a[1] || (a[1] = ({ legend: l }) => M(l))
      }, {
        item: c(({ legend: l, index: o }) => [
          x("div", {
            onClick: (r) => M(l),
            style: H(`opacity:${d.value.includes(l.id) ? 0.5 : 1}`)
          }, [
            ie(E(l.name) + ": " + E(p(he)(
              e.value.style.chart.layout.labels.dataLabels.formatter,
              l.value,
              p(k)({
                p: e.value.style.chart.layout.labels.dataLabels.prefix,
                v: l.value,
                s: e.value.style.chart.layout.labels.dataLabels.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: l, seriesIndex: o }
            )) + " ", 1),
            d.value.includes(l.id) ? (s(), n("span", ht, " ( - % ) ")) : (s(), n("span", dt, " (" + E(isNaN(l.value / g.value) ? "-" : p(k)({
              v: l.value / g.value * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })) + ") ", 1))
          ], 12, vt)
        ]),
        _: 1
      }, 8, ["legendSet", "config"])) : i("", !0),
      v(t.$slots, "legend", { legend: le.value }, void 0, !0),
      t.$slots.source ? (s(), n("div", pt, [
        v(t.$slots, "source", {}, void 0, !0)
      ], 512)) : i("", !0),
      re(Xe, {
        show: b.value.showTooltip && V.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: I.value,
        content: B.value,
        isCustom: p(pe)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": c(() => [
          v(t.$slots, "tooltip-before", S(N({ ...z.value })), void 0, !0)
        ]),
        "tooltip-after": c(() => [
          v(t.$slots, "tooltip-after", S(N({ ...z.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      L.value ? (s(), $(Je, {
        key: 8,
        hideDetails: "",
        config: {
          open: b.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: c(() => [
          (s(), $(Re, {
            key: `table_${j.value}`,
            colNames: O.value.colNames,
            head: O.value.head,
            body: O.value.body,
            config: O.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (l) => b.value.showTable = !1)
          }, {
            th: c(({ th: l }) => [
              x("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, yt)
            ]),
            td: c(({ td: l }) => [
              ie(E(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : i("", !0)
    ], 14, et));
  }
}, Lt = /* @__PURE__ */ Ze(ft, [["__scopeId", "data-v-f8542232"]]);
export {
  Lt as default
};
