import { computed as c, onMounted as me, ref as v, watch as pe, openBlock as n, createElementBlock as g, normalizeClass as Y, normalizeStyle as V, createBlock as y, createCommentVNode as u, createVNode as j, unref as s, createSlots as ge, withCtx as h, renderSlot as f, normalizeProps as B, guardReactiveProps as D, createElementVNode as a, Fragment as J, renderList as Q, toDisplayString as M, createTextVNode as Z, nextTick as ke } from "vue";
import { u as be, o as Ce, e as ee, c as xe, t as _e, O as we, X as $e, s as C, w as Me, P as Pe, i as te, f as O, q as Ne, r as Ae } from "./index-Bya_q1J-.js";
import { _ as Le } from "./Title-C5pIfQAz.js";
import { u as Te, U as Oe } from "./usePrinter-CiHd1FwD.js";
import { L as Ie } from "./Legend-DNgTCgEK.js";
import P from "./BaseIcon-BbvG1AlW.js";
import { D as Fe } from "./DataTable-DYqC2pqu.js";
import Se from "./vue-ui-skeleton-BYssP0K4.js";
import Ve from "./vue-ui-accordion-DfUfL2dI.js";
import { u as oe } from "./useNestedProp-B33hazbH.js";
import { _ as je } from "./PackageVersion-VkaUzgmt.js";
import { P as Be } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as De } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const We = ["id"], ze = {
  key: 1,
  style: "width:100%;background:transparent"
}, Ge = ["xmlns", "viewBox"], Ee = ["id"], Ue = ["stop-color"], He = ["stop-color"], Re = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Xe = ["d", "stroke", "stroke-width"], Ke = ["stroke"], qe = ["fill"], Ye = ["stroke"], Je = ["fill"], Qe = ["stroke"], Ze = ["fill"], et = ["stroke"], tt = ["fill"], ot = ["stroke"], lt = ["fill"], at = ["d", "stroke", "stroke-width", "fill"], st = ["x1", "y1", "stroke"], rt = ["cx", "cy", "fill", "stroke"], nt = ["fill", "stroke"], ut = ["y", "fill", "font-weight"], it = ["y", "fill"], dt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, ct = ["onClick"], vt = { style: { "font-weight": "bold" } }, yt = {
  key: 7,
  ref: "source",
  dir: "auto"
}, ht = ["innerHTML"], ft = {
  __name: "vue-ui-mood-radar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(le, { expose: ae }) {
    const i = le, { vue_ui_mood_radar: se } = be(), _ = c(() => !!i.dataset && Object.keys(i.dataset).length);
    me(() => {
      W();
    });
    function W() {
      Ce(i.dataset) && ee({
        componentName: "VueUiMoodRadar",
        type: "dataset"
      });
    }
    const w = v(xe()), I = v(null), re = v(null), r = v(null), ne = v(0), ue = v(0), z = v(0), e = c({
      get: () => G(),
      set: (o) => o
    });
    function G() {
      const o = oe({
        userConfig: i.config,
        defaultConfig: se
      });
      return o.theme ? {
        ...oe({
          userConfig: _e.vue_ui_mood_radar[o.theme] || i.config,
          defaultConfig: o
        })
      } : o;
    }
    pe(() => i.config, (o) => {
      e.value = G(), W(), ne.value += 1, ue.value += 1, z.value += 1;
    }, { deep: !0 });
    const { isPrinting: E, isImaging: U, generatePdf: H, generateImage: R } = Te({
      elementId: w.value,
      fileName: e.value.style.chart.title.text || "vue-ui-mood-radar"
    }), N = v({
      showTable: e.value.table.show
    }), k = c(() => ({
      height: 256,
      width: 256
    })), F = c(() => we({
      plot: { x: 128, y: k.value.height / 2 },
      radius: 90,
      sides: 5,
      rotation: 11
    }));
    function ie({ centerX: o, centerY: l, apexX: t, apexY: d, proportion: p, key: $, value: fe }) {
      return {
        x: o + (t - o) * p,
        y: l + (d - l) * p,
        key: $,
        value: fe
      };
    }
    const de = c(() => Math.max(...Object.values(i.dataset).map((o) => isNaN(o) ? 0 : o))), x = c(() => Object.values(i.dataset).reduce((o, l) => (isNaN(o) ? 0 : o) + (isNaN(l) ? 0 : l), 0)), m = c(() => Object.keys(i.dataset).map((o, l) => {
      const t = typeof i.dataset[o] != "number" || isNaN(i.dataset[o]) ? 0 : i.dataset[o];
      return {
        index: l,
        key: o,
        value: t,
        proportion: t / x.value,
        color: e.value.style.chart.layout.smileys.colors[o]
      };
    }).sort((o, l) => l.key - o.key)), X = c(() => _.value ? (["1", "2", "3", "4", "5"].forEach((o) => {
      [null, void 0].includes(i.dataset[o]) && ee({
        componentName: "VueUiMoodRadar",
        type: "datasetAttribute",
        property: o
      });
    }), F.value.coordinates.map((o, l) => {
      const t = ie({
        centerX: k.value.width / 2,
        centerY: k.value.height / 2,
        apexX: o.x,
        apexY: o.y,
        proportion: m.value[l].value / de.value,
        key: m.value[l].key,
        value: m.value[l].value
      });
      return {
        ...o,
        plots: t,
        key: m.value[l].key
      };
    })) : []), ce = c(() => ({
      cy: "mood-radar-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function ve(o) {
      o === r.value ? r.value = null : r.value = o;
    }
    const b = c(() => {
      const o = m.value.map((t) => ({
        name: t.key,
        color: t.color
      })), l = m.value.map((t) => isNaN(t.value) ? 0 : t.value);
      return { head: o, body: l };
    });
    function K() {
      ke(() => {
        const o = b.value.head.map((d, p) => [[
          d.name
        ], [b.value.body[p]], [isNaN(b.value.body[p] / x.value) ? "-" : b.value.body[p] / x.value * 100]]), l = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(o), t = Ne(l);
        Ae({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-mood-radar" });
      });
    }
    const A = c(() => {
      const o = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        Number(x.value.toFixed(e.value.table.td.roundingValue)).toLocaleString(),
        "100%"
      ], l = b.value.head.map((p, $) => [
        {
          color: p.color,
          name: p.name
        },
        b.value.body[$].toFixed(e.value.table.td.roundingValue),
        isNaN(b.value.body[$] / x.value) ? "-" : (b.value.body[$] / x.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, d = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ];
      return {
        head: o,
        body: l,
        config: t,
        colNames: d
      };
    });
    function ye() {
      return m.value;
    }
    function q() {
      N.value.showTable = !N.value.showTable;
    }
    const L = v(!1);
    function he(o) {
      L.value = o;
    }
    const T = v(!1);
    function S() {
      T.value = !T.value;
    }
    return ae({
      getData: ye,
      generatePdf: H,
      generateCsv: K,
      generateImage: R,
      toggleTable: q,
      toggleAnnotator: S
    }), (o, l) => (n(), g("div", {
      class: Y(`vue-ui-mood-radar ${L.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "moodRadarChart",
      ref: I,
      id: `${w.value}`,
      style: V(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`)
    }, [
      e.value.userOptions.buttons.annotator ? (n(), y(Be, {
        key: 0,
        parent: I.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: T.value,
        onClose: S
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : u("", !0),
      e.value.style.chart.title.text ? (n(), g("div", ze, [
        j(Le, {
          config: {
            title: {
              cy: "mood-radar-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "mood-radar-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ])) : u("", !0),
      e.value.userOptions.show && _.value ? (n(), y(Oe, {
        key: 2,
        ref_key: "details",
        ref: re,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: s(E),
        isImaging: s(U),
        uid: w.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: I.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: T.value,
        onToggleFullscreen: he,
        onGeneratePdf: s(H),
        onGenerateCsv: K,
        onGenerateImage: s(R),
        onToggleTable: q,
        onToggleAnnotator: S
      }, ge({ _: 2 }, [
        o.$slots.optionPdf ? {
          name: "optionPdf",
          fn: h(() => [
            f(o.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        o.$slots.optionCsv ? {
          name: "optionCsv",
          fn: h(() => [
            f(o.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        o.$slots.optionImg ? {
          name: "optionImg",
          fn: h(() => [
            f(o.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        o.$slots.optionTable ? {
          name: "optionTable",
          fn: h(() => [
            f(o.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        o.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: h(({ toggleFullscreen: t, isFullscreen: d }) => [
            f(o.$slots, "optionFullscreen", B(D({ toggleFullscreen: t, isFullscreen: d })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        o.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: h(({ toggleAnnotator: t, isAnnotator: d }) => [
            f(o.$slots, "optionAnnotator", B(D({ toggleAnnotator: t, isAnnotator: d })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : u("", !0),
      _.value ? (n(), g("svg", {
        key: 3,
        xmlns: s($e),
        viewBox: `0 0 ${k.value.width} ${k.value.height}`,
        class: Y({ "vue-data-ui-fullscreen--on": L.value, "vue-data-ui-fulscreen--off": !L.value }),
        style: V(`overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        j(je),
        a("defs", null, [
          a("radialGradient", {
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `mood_radar_gradient_${w.value}`
          }, [
            a("stop", {
              offset: "0%",
              "stop-color": s(C)(e.value.style.chart.layout.dataPolygon.color, e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, Ue),
            a("stop", {
              offset: "100%",
              "stop-color": s(C)(s(Me)(e.value.style.chart.layout.dataPolygon.color, e.value.style.chart.layout.dataPolygon.gradient.intensity / 100), e.value.style.chart.layout.dataPolygon.opacity)
            }, null, 8, He)
          ], 8, Ee)
        ]),
        (n(!0), g(J, null, Q(F.value.coordinates, (t) => (n(), g("line", {
          x1: k.value.width / 2,
          y1: k.value.height / 2,
          x2: t.x,
          y2: t.y,
          stroke: e.value.style.chart.layout.grid.stroke,
          "stroke-width": e.value.style.chart.layout.grid.strokeWidth
        }, null, 8, Re))), 256)),
        a("path", {
          d: F.value.path,
          fill: "none",
          stroke: e.value.style.chart.layout.outerPolygon.stroke,
          "stroke-width": e.value.style.chart.layout.outerPolygon.strokeWidth,
          "stroke-linejoin": "round",
          "stroke-linecap": "round"
        }, null, 8, Xe),
        a("path", {
          fill: "none",
          stroke: e.value.style.chart.layout.smileys.colors[5],
          "stroke-width": "1",
          "stroke-linecap": "round",
          d: "M119 25A1 1 0 00137 25 1 1 0 00119 25M123 26C124 33 132 33 133 26L123 26M123 22A1 1 0 00126 22 1 1 0 00123 22M130 22A1 1 0 00133 22 1 1 0 00130 22"
        }, null, 8, Ke),
        a("circle", {
          class: "vue-ui-mood-radar-trap",
          onMouseenter: l[0] || (l[0] = (t) => r.value = 5),
          onMouseleave: l[1] || (l[1] = (t) => r.value = null),
          cx: "128",
          cy: "25",
          r: "20",
          fill: r.value === 5 ? s(C)(e.value.style.chart.layout.smileys.colors[5], 20) : "transparent"
        }, null, 40, qe),
        a("path", {
          fill: "none",
          stroke: e.value.style.chart.layout.smileys.colors[4],
          "stroke-width": "1",
          "stroke-linecap": "round",
          d: "M218 95A1 1 0 00236 95 1 1 0 00218 95M222 97C225 99 229 99 232 97M222 92A1 1 0 00225 92 1 1 0 00222 92M229 92A1 1 0 00232 92 1 1 0 00229 92"
        }, null, 8, Ye),
        a("circle", {
          class: "vue-ui-mood-radar-trap",
          onMouseenter: l[2] || (l[2] = (t) => r.value = 4),
          onMouseleave: l[3] || (l[3] = (t) => r.value = null),
          cx: "227",
          cy: "95.5",
          r: "20",
          fill: r.value === 4 ? s(C)(e.value.style.chart.layout.smileys.colors[4], 20) : "transparent"
        }, null, 40, Je),
        a("path", {
          fill: "none",
          stroke: e.value.style.chart.layout.smileys.colors[3],
          "stroke-width": "1",
          "stroke-linecap": "round",
          d: "M181 213A1 1 0 00199 213 1 1 0 00181 213M185 210A1 1 0 00188 210 1 1 0 00185 210M192 210A1 1 0 00195 210 1 1 0 00192 210M185 215 195 215"
        }, null, 8, Qe),
        a("circle", {
          class: "vue-ui-mood-radar-trap",
          onMouseenter: l[4] || (l[4] = (t) => r.value = 3),
          onMouseleave: l[5] || (l[5] = (t) => r.value = null),
          cx: "190",
          cy: "213.5",
          r: "20",
          fill: r.value === 3 ? s(C)(e.value.style.chart.layout.smileys.colors[3], 20) : "transparent"
        }, null, 40, Ze),
        a("path", {
          fill: "none",
          stroke: e.value.style.chart.layout.smileys.colors[2],
          "stroke-width": "1",
          "stroke-linecap": "round",
          d: "M56 213A1 1 0 0074 213 1 1 0 0056 213M60 216C63 214 67 214 70 216M60 210A1 1 0 0063 210 1 1 0 0060 210M67 210A1 1 0 0070 210 1 1 0 0067 210"
        }, null, 8, et),
        a("circle", {
          class: "vue-ui-mood-radar-trap",
          onMouseenter: l[6] || (l[6] = (t) => r.value = 2),
          onMouseleave: l[7] || (l[7] = (t) => r.value = null),
          cx: "65",
          cy: "213.5",
          r: "20",
          fill: r.value === 2 ? s(C)(e.value.style.chart.layout.smileys.colors[2], 20) : "transparent"
        }, null, 40, tt),
        a("path", {
          fill: "none",
          stroke: e.value.style.chart.layout.smileys.colors[1],
          "stroke-width": "1",
          "stroke-linecap": "round",
          d: "M20 96A1 1 0 0038 96 1 1 0 0020 96M24 100C25 95 33 95 34 100L24 100M24 93A1 1 0 0027 93 1 1 0 0024 93M31 93A1 1 0 0034 93 1 1 0 0031 93"
        }, null, 8, ot),
        a("circle", {
          class: "vue-ui-mood-radar-trap",
          onMouseenter: l[8] || (l[8] = (t) => r.value = 1),
          onMouseleave: l[9] || (l[9] = (t) => r.value = null),
          cx: "29",
          cy: "95.5",
          r: "20",
          fill: r.value === 1 ? s(C)(e.value.style.chart.layout.smileys.colors[1], 20) : "transparent"
        }, null, 40, lt),
        a("path", {
          d: s(Pe)(X.value.map((t) => t.plots)),
          stroke: e.value.style.chart.layout.dataPolygon.stroke,
          "stroke-width": e.value.style.chart.layout.dataPolygon.strokeWidth,
          "stroke-linecap": "round",
          "stroke-linejoin": "round",
          fill: e.value.style.chart.layout.dataPolygon.gradient.show ? `url(#mood_radar_gradient_${w.value})` : s(C)(e.value.style.chart.layout.dataPolygon.color, e.value.style.chart.layout.dataPolygon.opacity)
        }, null, 8, at),
        (n(!0), g(J, null, Q(X.value.map((t) => t.plots), (t, d) => (n(), g("g", {
          class: "vue-ui-mood-radar-trap",
          style: V(`opacity:${r.value == t.key ? "1" : "0"}`)
        }, [
          a("line", {
            x1: t.x,
            y1: t.y,
            x2: 128,
            y2: 128,
            stroke: e.value.style.chart.layout.smileys.colors[t.key]
          }, null, 8, st),
          a("circle", {
            cx: t.x,
            cy: t.y,
            fill: e.value.style.chart.layout.smileys.colors[t.key],
            r: "3",
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": 0.5
          }, null, 8, rt),
          a("circle", {
            cx: 128,
            cy: 128,
            fill: e.value.style.chart.layout.smileys.colors[t.key],
            r: "3",
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": 0.5
          }, null, 8, nt),
          a("text", {
            x: 128,
            y: ["5", 5].includes(t.key) ? 145 : 120,
            fill: e.value.style.chart.layout.dataLabel.color,
            "font-size": "12",
            "text-anchor": "middle",
            "font-weight": e.value.style.chart.layout.dataLabel.bold ? "bold" : "normal"
          }, M(s(te)(
            e.value.style.chart.layout.dataLabel.formatter,
            t.value,
            s(O)({
              p: e.value.style.chart.layout.dataLabel.prefix,
              v: t.value,
              s: e.value.style.chart.layout.dataLabel.suffix,
              r: e.value.style.chart.layout.dataLabel.roundingValue
            }),
            { datapoint: t, seriesIndex: d }
          )), 9, ut),
          a("text", {
            x: 128,
            y: ["5", 5].includes(t.key) ? 163 : 102,
            fill: e.value.style.chart.layout.dataLabel.color,
            "font-size": "12",
            "text-anchor": "middle"
          }, " (" + M(s(O)({
            v: t.value / x.value * 100,
            s: "%",
            r: e.value.style.chart.layout.dataLabel.roundingPercentage
          })) + ") ", 9, it)
        ], 4))), 256)),
        f(o.$slots, "svg", { svg: k.value }, void 0, !0)
      ], 14, Ge)) : u("", !0),
      o.$slots.watermark ? (n(), g("div", dt, [
        f(o.$slots, "watermark", B(D({ isPrinting: s(E) || s(U) })), void 0, !0)
      ])) : u("", !0),
      _.value ? u("", !0) : (n(), y(Se, {
        key: 5,
        config: {
          type: "radar",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            radar: {
              grid: {
                color: "#CCCCCC"
              },
              shapes: {
                color: "#CCCCCC"
              }
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.chart.legend.show ? (n(), y(Ie, {
        legendSet: m.value,
        config: ce.value,
        key: `legend_${z.value}`,
        style: { display: "flex", "row-gap": "6px" }
      }, {
        item: h(({ legend: t, index: d }) => [
          a("div", {
            onClick: () => ve(t.key),
            style: { display: "flex", "flex-direction": "row", gap: "3px", "align-items": "center", margin: "3px 0" }
          }, [
            t.key == 1 ? (n(), y(P, {
              key: 0,
              strokeWidth: 1,
              name: "moodSad",
              stroke: e.value.style.chart.layout.smileys.colors[t.key]
            }, null, 8, ["stroke"])) : u("", !0),
            t.key == 2 ? (n(), y(P, {
              key: 1,
              strokeWidth: 1,
              name: "moodFlat",
              stroke: e.value.style.chart.layout.smileys.colors[t.key]
            }, null, 8, ["stroke"])) : u("", !0),
            t.key == 3 ? (n(), y(P, {
              key: 2,
              strokeWidth: 1,
              name: "moodNeutral",
              stroke: e.value.style.chart.layout.smileys.colors[t.key]
            }, null, 8, ["stroke"])) : u("", !0),
            t.key == 4 ? (n(), y(P, {
              key: 3,
              strokeWidth: 1,
              name: "smiley",
              stroke: e.value.style.chart.layout.smileys.colors[t.key]
            }, null, 8, ["stroke"])) : u("", !0),
            t.key == 5 ? (n(), y(P, {
              key: 4,
              strokeWidth: 1,
              name: "moodHappy",
              stroke: e.value.style.chart.layout.smileys.colors[t.key]
            }, null, 8, ["stroke"])) : u("", !0),
            a("span", vt, M(s(te)(
              e.value.style.chart.layout.dataLabel.formatter,
              t.value,
              s(O)({
                p: e.value.style.chart.layout.dataLabel.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabel.suffix,
                r: e.value.style.chart.layout.dataLabel.roundingValue
              }),
              { datapoint: t, seriesIndex: d }
            )), 1),
            Z(" (" + M(s(O)({
              v: t.proportion * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })) + ") ", 1)
          ], 8, ct)
        ]),
        _: 1
      }, 8, ["legendSet", "config"])) : u("", !0),
      f(o.$slots, "legend", { legend: m.value }, void 0, !0),
      o.$slots.source ? (n(), g("div", yt, [
        f(o.$slots, "source", {}, void 0, !0)
      ], 512)) : u("", !0),
      _.value ? (n(), y(Ve, {
        key: 8,
        hideDetails: "",
        config: {
          open: N.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: h(() => [
          j(Fe, {
            colNames: A.value.colNames,
            head: A.value.head,
            body: A.value.body,
            config: A.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[10] || (l[10] = (t) => N.value.showTable = !1)
          }, {
            th: h(({ th: t }) => [
              a("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, ht)
            ]),
            td: h(({ td: t }) => [
              Z(M(t.name || t), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : u("", !0)
    ], 14, We));
  }
}, At = /* @__PURE__ */ De(ft, [["__scopeId", "data-v-03614b4a"]]);
export {
  At as default
};
