import { computed as g, ref as c, watch as Be, onMounted as Re, onBeforeUnmount as je, openBlock as u, createElementBlock as r, normalizeClass as U, normalizeStyle as T, createBlock as z, createCommentVNode as y, unref as M, createSlots as Ue, withCtx as x, renderSlot as b, normalizeProps as W, guardReactiveProps as E, createVNode as $e, Fragment as C, renderList as I, createElementVNode as P, toDisplayString as L, createTextVNode as Ve } from "vue";
import { u as Ge, c as Z, t as He, a as Xe, p as V, o as Ye, e as we, g as qe, b as Qe, d as Je, C as Ke, Q as Ze, R as et, S as tt, X as at, x as Ae, i as _e, f as Te, y as lt, q as ot, r as st, E as G } from "./index-Bya_q1J-.js";
import { t as nt, u as ut } from "./useResponsive-BY8tgM1n.js";
import { _ as rt } from "./Title-C5pIfQAz.js";
import { L as it } from "./Legend-DNgTCgEK.js";
import { _ as ct } from "./Tooltip-Cz24YLfw.js";
import { _ as vt } from "./Shape-Bwon0l0g.js";
import { u as dt, U as ht } from "./usePrinter-CiHd1FwD.js";
import { D as pt } from "./DataTable-DYqC2pqu.js";
import mt from "./vue-ui-accordion-DfUfL2dI.js";
import yt from "./vue-ui-skeleton-BYssP0K4.js";
import { u as ze } from "./useNestedProp-B33hazbH.js";
import { _ as ft } from "./PackageVersion-VkaUzgmt.js";
import { P as gt } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as bt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const xt = ["id"], kt = ["xmlns", "viewBox"], Ct = { style: { "pointer-events": "none" } }, $t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], wt = ["x", "y", "fill", "font-size", "font-weight"], At = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], _t = ["x", "y", "fill", "font-size", "font-weight"], Tt = { key: 0 }, zt = ["x", "y", "font-size", "fill"], Mt = ["width", "x", "y"], It = { style: { width: "100%" } }, Pt = ["x", "y", "fill", "font-weight", "font-size", "onMouseenter"], Ft = ["d", "stroke", "stroke-width", "onMouseenter"], Nt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, St = ["onClick"], Lt = ["innerHTML"], Ot = {
  __name: "vue-ui-parallel-coordinate-plot",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(Me, { expose: Ie, emit: ee }) {
    const A = Me, { vue_ui_parallel_coordinate_plot: Pe } = Ge(), F = g({
      get() {
        return !!A.dataset && A.dataset.length;
      },
      set(t) {
        return t;
      }
    }), te = c(0), N = c(null), ae = c(null), le = c(null), oe = c(null), se = c(0), ne = c(0), ue = c(0), H = c(Z()), O = c(!1);
    function Fe(t) {
      O.value = t, te.value += 1;
    }
    const e = g({
      get: () => re(),
      set: (t) => t
    });
    function re() {
      const t = ze({
        userConfig: A.config,
        defaultConfig: Pe
      });
      return t.theme ? {
        ...ze({
          userConfig: He.vue_ui_parallel_coordinate_plot[t.theme] || A.config,
          defaultConfig: t
        }),
        customPalette: Xe[t.theme] || V
      } : t;
    }
    Be(() => A.config, (t) => {
      e.value = re(), ie(), se.value += 1, ue.value += 1, ne.value += 1;
    }, { deep: !0 });
    const B = c(null);
    Re(() => {
      ie();
    });
    function ie() {
      if (Ye(A.dataset) ? we({
        componentName: "VueUiParallelCoordinatePlot",
        type: "dataset"
      }) : A.dataset.forEach((t, l) => {
        qe({
          datasetObject: t,
          requiredAttributes: ["name", "series"]
        }).forEach((a) => {
          F.value = !1, we({
            componentName: "VueUiParallelCoordinatePlot",
            type: "datasetSerieAttribute",
            property: a,
            index: l
          });
        });
      }), e.value.responsive) {
        const t = nt(() => {
          const { width: l, height: a } = ut({
            chart: N.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            legend: e.value.style.chart.legend.show ? le.value : null,
            source: oe.value
          });
          v.value.width = l, v.value.height = a, v.value.plotSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.plots.radius,
            threshold: 2,
            fallback: 2
          }), v.value.ticksFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.ticks.fontSize,
            threshold: 10,
            fallback: 10
          }), v.value.datapointFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.datapoints.fontSize,
            threshold: 10,
            fallback: 10
          }), v.value.axisNameFontSize = G({
            relator: Math.min(l, a),
            adjuster: 600,
            source: e.value.style.chart.yAxis.labels.axisNamesFontSize,
            threshold: 12,
            fallback: 12
          });
        });
        B.value = new ResizeObserver(t), B.value.observe(N.value.parentNode);
      }
    }
    je(() => {
      B.value && B.value.disconnect();
    });
    const { isPrinting: ce, isImaging: ve, generatePdf: de, generateImage: he } = dt({
      elementId: `pcp_${H.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-parallel-coordinate-plot"
    }), v = c({
      height: e.value.style.chart.height,
      width: e.value.style.chart.width,
      plotSize: e.value.style.chart.plots.radius,
      // ratio 100
      ticksFontSize: e.value.style.chart.yAxis.labels.ticks.fontSize,
      // ratio 42.85
      datapointFontSize: e.value.style.chart.yAxis.labels.datapoints.fontSize,
      axisNameFontSize: e.value.style.chart.yAxis.labels.axisNamesFontSize
    }), d = g(() => {
      const { top: t, right: l, bottom: a, left: o } = e.value.style.chart.padding, n = v.value.height, s = v.value.width;
      return {
        chartHeight: n,
        chartWidth: s,
        height: n - t - a,
        width: s - o - l,
        top: t,
        left: o,
        right: s - l,
        bottom: n - a
      };
    }), Ne = g(() => Qe(e.value.customPalette)), f = c({
      dataLabels: {
        show: e.value.style.chart.yAxis.labels.datapoints.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), $ = c([]);
    function pe(t) {
      $.value.includes(t) ? $.value = $.value.filter((l) => l !== t) : $.value.push(t);
    }
    const _ = g(() => A.dataset.map((t, l) => {
      const a = Je(t.color) || Ne.value[l] || V[l] || V[l % V.length];
      return {
        ...t,
        series: t.series.map((o) => ({
          ...o,
          id: Z(),
          color: a
        })),
        seriesIndex: l,
        color: a,
        id: Z(),
        shape: t.shape || "circle"
      };
    })), Se = g(() => _.value.map((t) => ({
      ...t,
      opacity: $.value.includes(t.id) ? 0.5 : 1,
      segregate: () => pe(t.id),
      isSegregated: $.value.includes(t.id)
    }))), Le = g(() => ({
      cy: "pcp-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), me = g(() => Math.max(
      ..._.value.filter((t) => !$.value.includes(t.id)).map((t) => Math.max(...t.series.flatMap((l) => l.values.length)))
    )), k = g(() => d.value.width / me.value), X = g(() => _.value.filter((t) => !$.value.includes(t.id))), m = g(() => {
      let t = [];
      for (let l = 0; l < me.value; l += 1) {
        const a = Math.min(...X.value.flatMap((h) => h.series.map((j) => j.values[l] || 0) || 0)), o = Math.max(...X.value.flatMap((h) => h.series.map((j) => j.values[l] || 0) || 0)), n = o === a ? a / 4 : a, s = o === a ? o * 2 : o, i = Ke(n, s, e.value.style.chart.yAxis.scaleTicks), w = i.ticks.map((h, j) => {
          const We = i.min < 0 ? h + Math.abs(i.min) : h - Math.abs(i.min), Ee = i.min < 0 ? i.max + Math.abs(i.min) : i.max - Math.abs(i.min);
          return {
            y: d.value.bottom - d.value.height * (We / Ee),
            x: d.value.left + k.value * l + k.value / 2,
            value: h
          };
        });
        t.push({
          scale: i,
          ticks: w,
          name: e.value.style.chart.yAxis.labels.axisNames[l] || `Y-${l + 1}`
        });
      }
      return t;
    }), Y = g(() => X.value.map((t, l) => ({
      ...t,
      series: t.series.map((a, o) => ({
        ...a,
        datapoints: a.values.map((n, s) => {
          const i = m.value[s].scale.min < 0 ? (n || 0) + Math.abs(m.value[s].scale.min) : (n || 0) - Math.abs(m.value[s].scale.min), w = m.value[s].scale.min < 0 ? m.value[s].scale.max + Math.abs(m.value[s].scale.min) : m.value[s].scale.max - Math.abs(m.value[s].scale.min);
          return {
            name: a.name,
            seriesName: t.name,
            axisIndex: s,
            datapointIndex: o,
            seriesIndex: l,
            value: n || 0,
            x: d.value.left + k.value * s + k.value / 2,
            y: d.value.bottom - d.value.height * (i / w),
            comment: a.comments && a.comments[s] || ""
          };
        })
      }))
    })).map((t) => ({
      ...t,
      series: t.series.map((l) => {
        const a = Ze(l.datapoints), o = et(l.datapoints), n = tt(e.value.style.chart.lines.smooth ? `M ${o}` : `M ${a}`);
        return {
          ...l,
          smoothPath: o,
          straightPath: a,
          pathLength: n
        };
      })
    })));
    function ye({ value: t, index: l, datapoint: a }) {
      return _e(
        e.value.style.chart.yAxis.labels.formatters[l] || null,
        t,
        Te({
          p: e.value.style.chart.yAxis.labels.prefixes[l] || "",
          v: t,
          s: e.value.style.chart.yAxis.labels.suffixes[l] || "",
          r: e.value.style.chart.yAxis.labels.roundings[l] || 0
        }),
        { datapoint: a, seriesIndex: l }
      );
    }
    const p = c(null), q = c(null), D = c(!1), Q = c("");
    function J({ shape: t, serieName: l, serie: a, relativeIndex: o, seriesIndex: n }) {
      q.value = { serie: a, relativeIndex: o, seriesIndex: n, series: _.value, scales: m.value }, D.value = !0, p.value = a.id;
      let s = "";
      const i = e.value.style.chart.tooltip.customFormat;
      Ae(i) && lt(() => i({
        serie: a,
        seriesIndex: a.seriesIndex,
        series: _.value,
        config: e.value,
        scales: m.value
      })) ? Q.value = i({
        serie: a,
        seriesIndex: a.seriesIndex,
        series: _.value,
        config: e.value,
        scales: m.value
      }) : (s += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l ? l + " - " : ""}${a.name}</div>`, m.value.map((w) => w.name).forEach((w, h) => {
        s += `
                <div class="vue-ui-tooltip-item" style="text-align:left">
                    <span>${w}: </span>
                    <span>
                        ${_e(
          e.value.style.chart.yAxis.labels.formatters[h] || null,
          a.datapoints[h].value,
          Te({
            p: e.value.style.chart.yAxis.labels.prefixes[h] || "",
            v: a.datapoints[h].value,
            s: e.value.style.chart.yAxis.labels.suffixes[h] || "",
            r: e.value.style.chart.yAxis.labels.roundings[h] || ""
          }),
          { datapoint: a.datapoints[h], seriesIndex: h }
        )}    
                    </span>
                </div>
            `, e.value.style.chart.comments.showInTooltip && a.datapoints[h].comment && (s += `<div class="vue-data-ui-tooltip-comment" style="background:${a.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${a.color}">${a.datapoints[h].comment}</div>`);
      }), Q.value = `<div>${s}</div>`);
    }
    function Oe() {
      return _.value;
    }
    const S = g(() => {
      const t = [e.value.table.columnNames.series].concat([e.value.table.columnNames.item]).concat(m.value.map((n) => n.name)), l = Y.value.flatMap((n, s) => n.series.map((i) => [n.name].concat([i.name]).concat(i.values))), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, o = [e.value.table.columnNames.series].concat([e.value.table.columnNames.item]).concat(m.value.map((n) => n.name));
      return {
        body: l,
        head: t,
        config: a,
        colNames: o
      };
    }), fe = g(() => Y.value.length === 0 ? { head: [], body: [], config: {}, columnNames: [] } : {
      head: S.value.head,
      body: S.value.body
    });
    function ge() {
      const t = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], l = fe.value.head, a = fe.value.body, o = t.concat([l]).concat(a), n = ot(o);
      st({ csvContent: n, title: e.value.style.chart.title.text || "vue-ui-parallel-coordinate-plot" });
    }
    function De(t) {
      ee("selectDatapoint", t);
    }
    function be(t) {
      ee("selectLegend", {
        ...t,
        isSegregated: !t.isSegregated,
        opacity: t.isSegregated ? 1 : 0.5
      });
    }
    function xe() {
      f.value.showTable = !f.value.showTable;
    }
    function ke() {
      f.value.dataLabels.show = !f.value.dataLabels.show;
    }
    function Ce() {
      f.value.showTooltip = !f.value.showTooltip;
    }
    const R = c(!1);
    function K() {
      R.value = !R.value;
    }
    return Ie({
      getData: Oe,
      generateCsv: ge,
      generatePdf: de,
      generateImage: he,
      toggleTable: xe,
      toggleLabels: ke,
      toggleTooltip: Ce,
      toggleAnnotator: K
    }), (t, l) => (u(), r("div", {
      ref_key: "pcpChart",
      ref: N,
      class: U(`vue-ui-pcp ${O.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: T(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `pcp_${H.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (u(), z(gt, {
        key: 0,
        parent: N.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: R.value,
        onClose: K
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      e.value.style.chart.title.text ? (u(), r("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (u(), z(rt, {
          key: `title_${se.value}`,
          config: {
            title: {
              cy: "pcp-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "pcp-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && F.value ? (u(), z(ht, {
        ref: "details",
        key: `user_options_${te.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: M(ce),
        isImaging: M(ve),
        uid: H.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: O.value,
        isTooltip: f.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: N.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: R.value,
        onToggleFullscreen: Fe,
        onGeneratePdf: M(de),
        onGenerateCsv: ge,
        onGenerateImage: M(he),
        onToggleTable: xe,
        onToggleLabels: ke,
        onToggleTooltip: Ce,
        onToggleAnnotator: K
      }, Ue({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: x(() => [
            b(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: x(() => [
            b(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: x(() => [
            b(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: x(() => [
            b(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: x(() => [
            b(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: x(({ toggleFullscreen: a, isFullscreen: o }) => [
            b(t.$slots, "optionFullscreen", W(E({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: x(({ toggleAnnotator: a, isAnnotator: o }) => [
            b(t.$slots, "optionAnnotator", W(E({ toggleAnnotator: a, isAnnotator: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      F.value ? (u(), r("svg", {
        key: 3,
        xmlns: M(at),
        class: U({ "vue-data-ui-fullscreen--on": O.value, "vue-data-ui-fulscreen--off": !O.value }),
        viewBox: `0 0 ${d.value.chartWidth <= 0 ? 10 : d.value.chartWidth} ${d.value.chartHeight <= 0 ? 10 : d.value.chartHeight}`,
        style: T(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        $e(ft),
        (u(!0), r(C, null, I(m.value, (a, o) => (u(), r("g", Ct, [
          P("line", {
            x1: d.value.left + k.value * o + k.value / 2,
            x2: d.value.left + k.value * o + k.value / 2,
            y1: d.value.top,
            y2: d.value.bottom,
            stroke: e.value.style.chart.yAxis.stroke,
            "stroke-width": e.value.style.chart.yAxis.strokeWidth
          }, null, 8, $t),
          P("text", {
            x: d.value.left + k.value * o + k.value / 2,
            y: d.value.top - 24,
            fill: e.value.style.chart.yAxis.labels.axisNamesColor,
            "font-size": v.value.axisNameFontSize,
            "font-weight": e.value.style.chart.yAxis.labels.axisNamesBold ? "bold" : "",
            "text-anchor": "middle"
          }, L(a.name), 9, wt),
          e.value.style.chart.yAxis.labels.ticks.show ? (u(), r(C, { key: 0 }, [
            (u(!0), r(C, null, I(a.ticks, (n) => (u(), r("line", {
              x1: n.x,
              x2: n.x - 10,
              y1: n.y,
              y2: n.y,
              stroke: e.value.style.chart.yAxis.stroke,
              "stroke-width": e.value.style.chart.yAxis.strokeWidth,
              style: T(`opacity:${p.value && !f.value.showTooltip ? 0.2 : 1}`)
            }, null, 12, At))), 256)),
            (u(!0), r(C, null, I(a.ticks, (n) => (u(), r("text", {
              x: n.x - 12 + e.value.style.chart.yAxis.labels.ticks.offsetX,
              y: n.y + e.value.style.chart.yAxis.labels.ticks.offsetY + v.value.ticksFontSize / 3,
              fill: e.value.style.chart.yAxis.labels.ticks.color,
              "text-anchor": "end",
              "font-size": v.value.ticksFontSize,
              "font-weight": e.value.style.chart.yAxis.labels.ticks.bold ? "bold" : "normal",
              style: T(`opacity:${p.value && !f.value.showTooltip ? 0.2 : 1}`)
            }, L(ye({ value: n.value, index: o, datapoint: n })), 13, _t))), 256))
          ], 64)) : y("", !0)
        ]))), 256)),
        (u(!0), r(C, null, I(Y.value, (a) => (u(), r("g", null, [
          (u(!0), r(C, null, I(a.series, (o, n) => (u(), r("g", null, [
            e.value.style.chart.plots.show ? (u(), r("g", Tt, [
              (u(!0), r(C, null, I(o.datapoints, (s) => (u(), z(vt, {
                plot: { x: s.x, y: s.y },
                color: a.color,
                shape: a.shape,
                radius: a.shape === "triangle" ? v.value.plotSize * 1.2 : v.value.plotSize,
                stroke: e.value.style.chart.backgroundColor,
                strokeWidth: 0.5,
                onMouseenter: (i) => J({
                  shape: a.shape,
                  serieName: a.name,
                  serie: o,
                  relativeIndex: n,
                  seriesIndex: o.seriesIndex
                }),
                onMouseleave: l[0] || (l[0] = (i) => {
                  p.value = null, D.value = !1;
                }),
                style: T(`opacity:${p.value ? p.value === o.id ? e.value.style.chart.plots.opacity : 0.2 : e.value.style.chart.plots.opacity}`),
                onClick: () => De(s)
              }, null, 8, ["plot", "color", "shape", "radius", "stroke", "onMouseenter", "style", "onClick"]))), 256)),
              f.value.showTooltip ? y("", !0) : (u(), r(C, { key: 0 }, [
                p.value && p.value === o.id && o.datapoints.length ? (u(), r("text", {
                  key: 0,
                  x: o.datapoints[0].x - v.value.ticksFontSize,
                  y: o.datapoints[0].y + v.value.ticksFontSize / 3,
                  "text-anchor": "end",
                  "font-size": v.value.ticksFontSize,
                  fill: a.color,
                  "font-weight": "bold"
                }, L(o.name), 9, zt)) : y("", !0)
              ], 64)),
              e.value.style.chart.comments.show ? (u(!0), r(C, { key: 1 }, I(o.datapoints, (s) => (u(), r("g", null, [
                s.comment ? (u(), r("foreignObject", {
                  key: 0,
                  style: { overflow: "visible" },
                  height: "12",
                  width: e.value.style.chart.comments.width,
                  x: s.x - e.value.style.chart.comments.width / 2 + e.value.style.chart.comments.offsetX,
                  y: s.y + e.value.style.chart.comments.offsetY + 6
                }, [
                  P("div", It, [
                    b(t.$slots, "plot-comment", {
                      plot: { ...s, color: a.color }
                    }, void 0, !0)
                  ])
                ], 8, Mt)) : y("", !0)
              ]))), 256)) : y("", !0)
            ])) : y("", !0),
            f.value.dataLabels.show || p.value && p.value === o.id ? (u(!0), r(C, { key: 1 }, I(o.datapoints, (s, i) => (u(), r("text", {
              x: s.x + 12 + e.value.style.chart.yAxis.labels.datapoints.offsetX,
              y: s.y + e.value.style.chart.yAxis.labels.datapoints.offsetY + v.value.datapointFontSize / 3,
              fill: e.value.style.chart.yAxis.labels.datapoints.useSerieColor ? a.color : e.value.style.chart.yAxis.labels.datapoints.color,
              "text-anchor": "start",
              "font-weight": e.value.style.chart.yAxis.labels.datapoints.bold ? "bold" : "normal",
              class: U({ "vue-ui-pcp-animated": !1, "vue-ui-pcp-transition": !0 }),
              "font-size": v.value.datapointFontSize,
              onMouseenter: (w) => J({
                shape: a.shape,
                serieName: a.name,
                serie: o,
                relativeIndex: n,
                seriesIndex: o.seriesIndex
              }),
              onMouseleave: l[1] || (l[1] = (w) => {
                p.value = null, D.value = !1;
              }),
              style: T(`opacity:${p.value ? p.value === o.id ? 1 : 0.2 : 1}`)
            }, L(ye({ value: s.value, index: i, datapoint: s })), 45, Pt))), 256)) : y("", !0),
            P("path", {
              d: `M${e.value.style.chart.lines.smooth ? o.smoothPath : o.straightPath}`,
              stroke: a.color,
              "stroke-width": e.value.style.chart.lines.strokeWidth,
              fill: "none",
              class: U({ "vue-ui-pcp-animated vue-data-ui-line-animated": e.value.useCssAnimation, "vue-ui-pcp-transition": !0 }),
              onMouseenter: (s) => J({
                shape: a.shape,
                serieName: a.name,
                serie: o,
                relativeIndex: n,
                seriesIndex: o.seriesIndex
              }),
              onMouseleave: l[2] || (l[2] = (s) => {
                p.value = null, D.value = !1;
              }),
              style: T(`opacity:${p.value ? p.value === o.id ? e.value.style.chart.lines.opacity : 0.2 : e.value.style.chart.lines.opacity}; stroke-dasharray:${o.pathLength}; stroke-dashoffset: ${e.value.useCssAnimation ? o.pathLength : 0}`)
            }, null, 46, Ft)
          ]))), 256))
        ]))), 256)),
        b(t.$slots, "svg", { svg: d.value }, void 0, !0)
      ], 14, kt)) : y("", !0),
      t.$slots.watermark ? (u(), r("div", Nt, [
        b(t.$slots, "watermark", W(E({ isPrinting: M(ce) || M(ve) })), void 0, !0)
      ])) : y("", !0),
      F.value ? y("", !0) : (u(), z(yt, {
        key: 5,
        config: {
          type: "parallelCoordinatePlot",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      P("div", {
        ref_key: "chartLegend",
        ref: le
      }, [
        e.value.style.chart.legend.show && F.value ? (u(), z(it, {
          key: `legend_${ne.value}`,
          legendSet: Se.value,
          config: Le.value,
          onClickMarker: l[3] || (l[3] = ({ legend: a }) => {
            pe(a.id), be(a);
          })
        }, {
          item: x(({ legend: a, index: o }) => [
            P("div", {
              onClick: (n) => {
                a.segregate(), be(a);
              },
              style: T(`opacity:${$.value.includes(a.id) ? 0.5 : 1}`)
            }, L(a.name), 13, St)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : b(t.$slots, "legend", {
          key: 1,
          legend: _.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (u(), r("div", {
        key: 6,
        ref_key: "source",
        ref: oe,
        dir: "auto"
      }, [
        b(t.$slots, "source", {}, void 0, !0)
      ], 512)) : y("", !0),
      $e(ct, {
        show: f.value.showTooltip && D.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: N.value,
        content: Q.value,
        isCustom: M(Ae)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": x(() => [
          b(t.$slots, "tooltip-before", W(E({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": x(() => [
          b(t.$slots, "tooltip-after", W(E({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      F.value ? (u(), z(mt, {
        key: 7,
        hideDetails: "",
        config: {
          open: f.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: x(() => [
          (u(), z(pt, {
            key: `table_${ue.value}`,
            colNames: S.value.colNames,
            head: S.value.head,
            body: S.value.body,
            config: S.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[4] || (l[4] = (a) => f.value.showTable = !1)
          }, {
            th: x(({ th: a }) => [
              P("div", { innerHTML: a }, null, 8, Lt)
            ]),
            td: x(({ td: a }) => [
              Ve(L(a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, xt));
  }
}, Kt = /* @__PURE__ */ bt(Ot, [["__scopeId", "data-v-1fae112e"]]);
export {
  Kt as default
};
