import { computed as d, ref as c, watch as Le, onMounted as Xe, onBeforeUnmount as Ye, openBlock as r, createElementBlock as i, normalizeClass as Ae, normalizeStyle as Z, createBlock as N, createCommentVNode as f, unref as h, createSlots as Ke, withCtx as m, renderSlot as g, normalizeProps as D, guardReactiveProps as G, createVNode as ze, createElementVNode as k, Fragment as T, renderList as R, toDisplayString as S, createTextVNode as Fe, nextTick as Je, pushScopeId as Qe, popScopeId as Ze } from "vue";
import { u as et, c as tt, t as at, a as lt, p as O, o as ot, e as re, g as ut, b as rt, i as U, f as x, X as st, s as nt, w as it, F as ct, K as vt, d as dt, x as ht, y as pt, q as yt, r as ft } from "./index-Bya_q1J-.js";
import { t as gt, u as mt } from "./useResponsive-BY8tgM1n.js";
import { _ as bt } from "./Title-C5pIfQAz.js";
import { u as wt, U as kt } from "./usePrinter-CiHd1FwD.js";
import { _ as xt } from "./Tooltip-Cz24YLfw.js";
import { D as Ct } from "./DataTable-DYqC2pqu.js";
import { L as _t } from "./Legend-DNgTCgEK.js";
import $t from "./vue-ui-skeleton-BYssP0K4.js";
import It from "./vue-ui-accordion-DfUfL2dI.js";
import { u as Ne } from "./useNestedProp-B33hazbH.js";
import { _ as Tt } from "./PackageVersion-VkaUzgmt.js";
import { P as St } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Pt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Oe = (j) => (Qe("data-v-89a6ba4c"), j = j(), Ze(), j), Lt = ["id"], At = ["xmlns", "viewBox"], zt = ["id"], Ft = ["stop-color"], Nt = ["stop-color"], Ot = ["id"], Bt = /* @__PURE__ */ Oe(() => /* @__PURE__ */ k("feGaussianBlur", {
  in: "SourceGraphic",
  stdDeviation: 2
}, null, -1)), Vt = /* @__PURE__ */ Oe(() => /* @__PURE__ */ k("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Mt = [
  Bt,
  Vt
], Dt = ["x", "y", "height", "width"], Gt = ["height", "width"], Rt = ["rx", "x", "y", "height", "width", "stroke", "stroke-width", "filter"], Ut = ["rx", "x", "y", "height", "width", "fill", "stroke", "stroke-width", "filter"], jt = ["x", "y", "height", "width", "filter"], Et = { key: 0 }, Wt = { key: 1 }, qt = { key: 2 }, Ht = { key: 3 }, Xt = ["onMouseover", "x", "y", "height", "width"], Yt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Kt = ["onClick"], Jt = { key: 0 }, Qt = { key: 1 }, Zt = ["innerHTML"], ea = {
  __name: "vue-ui-waffle",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(j, { expose: Be, emit: Ve }) {
    const b = j, { vue_ui_waffle: Me } = et(), X = d(() => !!b.dataset && b.dataset.length), P = c(tt()), De = c(null), ee = c(!1), te = c(""), B = c(null), se = c(0), V = c(null), ne = c(null), ie = c(null), ce = c(null), ve = c(0), de = c(0), he = c(0), e = d({
      get: () => pe(),
      set: (t) => t
    });
    function pe() {
      const t = Ne({
        userConfig: b.config,
        defaultConfig: Me
      });
      return t.theme ? {
        ...Ne({
          userConfig: at.vue_ui_waffle[t.theme] || b.config,
          defaultConfig: t
        }),
        customPalette: lt[t.theme] || O
      } : t;
    }
    Le(() => b.config, (t) => {
      e.value = pe(), ye(), ve.value += 1, de.value += 1, he.value += 1;
    }, { deep: !0 });
    const Y = c(null);
    function ye() {
      if (ot(b.dataset) ? re({
        componentName: "VueUiWaffle",
        type: "dataset"
      }) : b.dataset.forEach((t, o) => {
        ut({
          datasetObject: t,
          requiredAttributes: ["name", "values"]
        }).forEach((a) => {
          re({
            componentName: "VueUiWaffle",
            type: "datasetSerieAttribute",
            property: a,
            index: o
          });
        });
      }), e.value.responsive) {
        const t = gt(() => {
          const { width: o, height: a } = mt({
            chart: V.value,
            title: e.value.style.chart.title.text ? ne.value : null,
            legend: e.value.style.chart.legend.show ? ie.value : null,
            source: ce.value
          });
          L.value.width = o, L.value.height = a, C.value.width = o, C.value.height = a;
        });
        Y.value = new ResizeObserver(t), Y.value.observe(V.value.parentNode);
      }
    }
    Xe(() => {
      ye();
    }), Ye(() => {
      Y.value && Y.value.disconnect();
    });
    const { isPrinting: fe, isImaging: ge, generatePdf: me, generateImage: be } = wt({
      elementId: `vue-ui-waffle_${P.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-waffle"
    }), we = d(() => rt(e.value.customPalette)), I = c({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), L = c({
      height: 512,
      width: 512
    }), C = c({
      top: 0,
      left: 0,
      height: 512,
      width: 512
    }), A = d(() => (C.value.width - e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.spaceBetween) / e.value.style.chart.layout.grid.size), z = d(() => (C.value.height - e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.spaceBetween) / e.value.style.chart.layout.grid.size), E = d(() => C.value.width / e.value.style.chart.layout.grid.size), K = d(() => C.value.height / e.value.style.chart.layout.grid.size);
    function ke(t) {
      const o = e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.size, a = t.reduce((w, ue) => w + ue, 0), l = t.map((w) => w / a * o), u = l.map(Math.floor), n = l.map((w) => w % 1);
      let y = o - u.reduce((w, ue) => w + ue, 0);
      for (; y > 0; ) {
        let w = n.indexOf(Math.max(...n));
        u[w] += 1, n[w] = 0, y -= 1;
      }
      return u;
    }
    function xe() {
      return b.dataset.map((t, o) => ({
        ...t,
        color: dt(t.color) || we.value[o] || O[o] || O[o % O.length],
        uid: `serie_${o}`,
        absoluteIndex: o
      }));
    }
    const Ce = d(() => xe()), v = c(Ce.value);
    Le(() => b.dataset, (t) => {
      v.value = xe();
    }, { deep: !0 });
    const Ge = d(() => {
      const t = v.value.filter((o, a) => !p.value.includes(o.uid)).map((o, a) => (o.values || []).reduce((l, u) => l + u, 0));
      return ke(t);
    }), Re = d(() => {
      const t = v.value.map((o, a) => (o.values || []).reduce((l, u) => l + u));
      return ke(t);
    }), W = d(() => (b.dataset.forEach((t, o) => {
      [null, void 0].includes(t.values) && re({
        componentName: "VueUiWaffle",
        type: "datasetSerieAttribute",
        property: "values (number[])",
        index: o
      });
    }), v.value.filter((t, o) => !p.value.includes(t.uid)).map((t, o) => ({
      absoluteIndex: t.absoluteIndex,
      uid: t.uid,
      name: t.name,
      color: t.color,
      value: (t.values || []).reduce((a, l) => a + l, 0),
      absoluteValues: t.values || [],
      proportion: Ge.value[o]
    })))), Ue = d(() => v.value.map((t, o) => ({
      absoluteIndex: t.absoluteIndex,
      uid: t.uid,
      name: t.name,
      color: t.color,
      value: (t.values || []).reduce((a, l) => a + l, 0),
      absoluteValues: t.values || [],
      proportion: Re.value[o]
    })));
    function je() {
      return Ue.value.map((t) => ({
        name: t.name,
        color: t.color,
        value: t.value,
        proportion: t.proportion
      }));
    }
    const Ee = d(() => {
      let t = 0;
      return W.value.map((o, a) => {
        const l = t, u = l + o.proportion, n = [];
        for (let y = Math.floor(l); y < Math.floor(u); y += 1)
          n.push(y);
        return t = u, {
          ...o,
          start: l,
          rects: n
        };
      });
    }), s = d(() => Ee.value.flatMap((t, o) => t.rects.map((a, l) => ({
      isFirst: l === 0,
      isLongEnough: a.length > 2,
      name: t.name,
      color: t.color,
      value: t.value,
      serieIndex: o,
      absoluteStartIndex: l < 3,
      serieId: t.uid,
      ...t
    }))).map((t, o) => ({
      ...t,
      isAbsoluteFirst: o % e.value.style.chart.layout.grid.size === 0
    }))), q = d(() => {
      const t = [];
      for (let o = 0; o < e.value.style.chart.layout.grid.size; o += 1)
        for (let a = 0; a < e.value.style.chart.layout.grid.size; a += 1)
          t.push({
            isStartOfLine: a === 0,
            position: e.value.style.chart.layout.grid.vertical ? o : a,
            x: (e.value.style.chart.layout.grid.vertical ? o : a) * (A.value + e.value.style.chart.layout.grid.spaceBetween),
            y: (e.value.style.chart.layout.grid.vertical ? a : o) * (z.value + e.value.style.chart.layout.grid.spaceBetween) + C.value.top
          });
      return t;
    }), p = c([]), F = c(!1), _e = c(null), $e = c(null);
    function Ie(t) {
      if (!e.value.useAnimation) {
        p.value.includes(t) ? p.value = p.value.filter((u) => u !== t) : p.value.length < M.value.length - 1 && M.value.length > 1 && p.value.push(t);
        return;
      }
      const o = Ce.value.find((u) => u.uid === t).values.reduce((u, n) => u + n, 0);
      let l = v.value.find((u) => u.uid === t).values.reduce((u, n) => u + n, 0);
      if (p.value.includes(t)) {
        let n = function() {
          l > u ? (cancelAnimationFrame(_e.value), v.value = v.value.map((y, w) => y.uid === t ? {
            ...y,
            values: [u]
          } : y), F.value = !1) : (F.value = !0, l += u * 0.025, v.value = v.value.map((y, w) => y.uid === t ? {
            ...y,
            values: [l]
          } : y), _e.value = requestAnimationFrame(n));
        };
        p.value = p.value.filter((y) => y !== t);
        const u = o;
        n();
      } else if (p.value.length < M.value.length - 1 && M.value.length > 1) {
        let u = function() {
          l < 0.1 ? (cancelAnimationFrame($e.value), p.value.push(t), v.value = v.value.map((n, y) => n.uid === t ? {
            ...n,
            values: [0]
          } : n), F.value = !1) : (F.value = !0, l /= 1.5, v.value = v.value.map((n, y) => n.uid === t ? {
            ...n,
            values: [l]
          } : n), $e.value = requestAnimationFrame(u));
        };
        u();
      }
      Ve("selectLegend", W.value.map((u) => ({
        name: u.name,
        color: u.color,
        value: u.value,
        proportion: u.proportion / Math.pow(e.value.style.chart.layout.grid.size, 2)
      })));
    }
    const M = d(() => v.value.map((t, o) => ({
      name: t.name,
      color: t.color || we[o] || O[o] || O[o % O.length],
      value: (t.values || []).reduce((a, l) => a + l, 0),
      uid: t.uid,
      shape: "square"
    })).map((t, o) => ({
      ...t,
      proportion: t.value / v.value.map((a) => (a.values || []).reduce((l, u) => l + u, 0)).reduce((a, l) => a + l, 0),
      opacity: p.value.includes(t.uid) ? 0.5 : 1,
      segregate: () => Ie(t.uid),
      isSegregated: p.value.includes(t.uid)
    }))), We = d(() => ({
      cy: "waffle-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), _ = d(() => W.value.map((t) => t.value).reduce((t, o) => t + o, 0)), ae = c(null);
    function qe(t) {
      if (p.value.length === b.dataset.length) return;
      const o = s.value[t];
      ae.value = {
        datapoint: o,
        seriesIndex: o.absoluteIndex,
        series: v.value,
        config: e.value
      }, ee.value = !0, B.value = s.value[t].serieIndex;
      const a = e.value.style.chart.tooltip.customFormat;
      if (ht(a) && pt(() => a({
        seriesIndex: s.value[t].absoluteIndex,
        datapoint: o,
        series: v.value,
        config: e.value
      })))
        te.value = a({
          seriesIndex: s.value[t].absoluteIndex,
          datapoint: o,
          series: v.value,
          config: e.value
        });
      else {
        let l = "";
        if (l += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${o.name}</div>`, l += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" height="12" width="12" stroke="none" rx="1" fill="${o.color}" /></svg>`, e.value.style.chart.tooltip.showValue && (l += `<b>${U(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          o.value,
          x({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: o.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: o,
            seriesIndex: s.value[t].absoluteIndex,
            series: v.value
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const u = x({
            v: o.value / _.value * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          });
          e.value.style.chart.tooltip.showValue ? l += `<span>(${u})</span></div>` : l += `<b>${u}%</b></div>`;
        }
        te.value = l;
      }
    }
    const $ = d(() => {
      const t = W.value.map((a) => ({
        name: a.name,
        color: a.color
      })), o = W.value.map((a) => a.value);
      return { head: t, body: o };
    });
    function le(t) {
      return e.value.useBlurOnHover && ![null, void 0].includes(B.value) && B.value !== t ? `url(#blur_${P.value})` : "";
    }
    function Te() {
      Je(() => {
        const t = $.value.head.map((l, u) => [[
          l.name
        ], [$.value.body[u]], [isNaN($.value.body[u] / _.value) ? "-" : $.value.body[u] / _.value * 100]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), a = yt(o);
        ft({ csvContent: a, title: e.value.style.chart.title.text || "vue-ui-waffle" });
      });
    }
    const J = d(() => {
      const t = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        U(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          _.value,
          x({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: _.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        "100%"
      ], o = $.value.head.map((u, n) => [
        {
          color: u.color,
          name: u.name
        },
        U(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          $.value.body[n],
          x({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: $.value.body[n],
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        isNaN($.value.body[n] / _.value) ? "-" : x({
          v: $.value.body[n] / _.value * 100,
          s: "%",
          r: e.value.table.td.roundingPercentage
        })
      ]), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        shape: "square",
        breakpoint: e.value.table.responsiveBreakpoint
      }, l = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ];
      return {
        head: t,
        body: o,
        config: a,
        colNames: l
      };
    }), H = c(!1);
    function He(t) {
      H.value = t, se.value += 1;
    }
    function Se() {
      I.value.showTable = !I.value.showTable;
    }
    function Pe() {
      I.value.showTooltip = !I.value.showTooltip;
    }
    const Q = c(!1);
    function oe() {
      Q.value = !Q.value;
    }
    return Be({
      getData: je,
      generatePdf: me,
      generateCsv: Te,
      generateImage: be,
      toggleTable: Se,
      toggleTooltip: Pe,
      toggleAnnotator: oe
    }), (t, o) => (r(), i("div", {
      class: Ae(`vue-ui-waffle ${H.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      ref_key: "waffleChart",
      ref: V,
      id: `vue-ui-waffle_${P.value}`,
      style: Z(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (r(), N(St, {
        key: 0,
        parent: V.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: Q.value,
        onClose: oe
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : f("", !0),
      e.value.style.chart.title.text ? (r(), i("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: ne,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (r(), N(bt, {
          key: `title_${ve.value}`,
          config: {
            title: {
              cy: "waffle-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "waffle-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : f("", !0),
      e.value.userOptions.show && X.value ? (r(), N(kt, {
        ref_key: "details",
        ref: De,
        key: `user_options_${se.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(fe),
        isImaging: h(ge),
        uid: P.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: H.value,
        isTooltip: I.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: V.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: Q.value,
        onToggleFullscreen: He,
        onGeneratePdf: h(me),
        onGenerateCsv: Te,
        onGenerateImage: h(be),
        onToggleTable: Se,
        onToggleTooltip: Pe,
        onToggleAnnotator: oe
      }, Ke({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: m(() => [
            g(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            g(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            g(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            g(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            g(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: a, isFullscreen: l }) => [
            g(t.$slots, "optionFullscreen", D(G({ toggleFullscreen: a, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: m(({ toggleAnnotator: a, isAnnotator: l }) => [
            g(t.$slots, "optionAnnotator", D(G({ toggleAnnotator: a, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : f("", !0),
      X.value ? (r(), i("svg", {
        key: 3,
        xmlns: h(st),
        class: Ae({ "vue-data-ui-fullscreen--on": H.value, "vue-data-ui-fulscreen--off": !H.value }),
        viewBox: `0 0 ${L.value.width <= 0 ? 10 : L.value.width} ${L.value.height <= 0 ? 10 : L.value.height}`,
        style: Z(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ze(Tt),
        k("defs", null, [
          (r(!0), i(T, null, R(s.value, (a, l) => (r(), i("radialGradient", {
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `gradient_${P.value}_${l}`
          }, [
            k("stop", {
              offset: "0%",
              "stop-color": h(nt)(h(it)(a.color, 0.05), 100 - e.value.style.chart.layout.rect.gradientIntensity)
            }, null, 8, Ft),
            k("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, Nt)
          ], 8, zt))), 256))
        ]),
        k("defs", null, [
          k("filter", {
            id: `blur_${P.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, Mt, 8, Ot)
        ]),
        e.value.useCustomCells && s.value.length ? (r(!0), i(T, { key: 0 }, R(q.value, (a, l) => (r(), i("foreignObject", {
          x: a.x,
          y: a.y,
          height: z.value <= 0 ? 1e-4 : z.value,
          width: A.value <= 0 ? 1e-4 : A.value,
          class: "vue-ui-waffle-custom-cell-foreignObject"
        }, [
          g(t.$slots, "cell", D(G({ cell: { ...a, color: s.value[l].color, ...s.value[l] }, isSelected: [null, void 0].includes(B.value) ? !0 : s.value[l].serieIndex === B.value })), void 0, !0)
        ], 8, Dt))), 256)) : f("", !0),
        !s.value.length && !e.value.useCustomCells ? (r(), i("rect", {
          key: 1,
          x: 12,
          y: 12,
          height: C.value.height - 24,
          width: C.value.width - 24,
          rx: 3,
          fill: "none",
          stroke: "black"
        }, null, 8, Gt)) : s.value.length && !e.value.useCustomCells ? (r(), i(T, { key: 2 }, [
          (r(!0), i(T, null, R(q.value, (a, l) => (r(), i("rect", {
            rx: e.value.style.chart.layout.rect.rounded ? e.value.style.chart.layout.rect.rounding : 0,
            x: a.x + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: a.y + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: z.value <= 0 ? 1e-4 : z.value,
            width: A.value <= 0 ? 1e-4 : A.value,
            fill: "white",
            stroke: e.value.style.chart.layout.rect.stroke,
            "stroke-width": e.value.style.chart.layout.rect.strokeWidth,
            filter: le(s.value[l].serieIndex)
          }, null, 8, Rt))), 256)),
          (r(!0), i(T, null, R(q.value, (a, l) => (r(), i("rect", {
            rx: e.value.style.chart.layout.rect.rounded ? e.value.style.chart.layout.rect.rounding : 0,
            x: a.x + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: a.y + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: z.value <= 0 ? 1e-4 : z.value,
            width: A.value <= 0 ? 1e-4 : A.value,
            fill: e.value.style.chart.layout.rect.useGradient && e.value.style.chart.layout.rect.gradientIntensity > 0 ? `url(#gradient_${P.value}_${l})` : s.value[l].color,
            stroke: e.value.style.chart.layout.rect.stroke,
            "stroke-width": e.value.style.chart.layout.rect.strokeWidth,
            filter: le(s.value[l].serieIndex)
          }, null, 8, Ut))), 256))
        ], 64)) : f("", !0),
        (r(!0), i(T, null, R(q.value, (a, l) => (r(), i(T, null, [
          s.value.length && !F.value && !e.value.style.chart.layout.grid.vertical && e.value.style.chart.layout.labels.captions.show && (s.value[l].isFirst && a.position < e.value.style.chart.layout.grid.size - 2 || s.value[l].isAbsoluteFirst && l % e.value.style.chart.layout.grid.size === 0 && s.value[l].absoluteStartIndex) ? (r(), i("foreignObject", {
            key: 0,
            x: a.x + e.value.style.chart.layout.labels.captions.offsetX + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: a.y + e.value.style.chart.layout.labels.captions.offsetY + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: K.value <= 0 ? 1e-4 : K.value,
            width: E.value * e.value.style.chart.layout.grid.size <= 0 ? 1e-4 : E.value * e.value.style.chart.layout.grid.size,
            filter: le(s.value[l].serieIndex)
          }, [
            k("div", {
              class: "vue-ui-waffle-caption",
              style: Z(`height: 100%; width: 100%; font-size:${e.value.style.chart.layout.labels.captions.fontSize}px;display:flex;align-items:center;justify-content:flex-start;padding: 0 ${E.value / 12}px;color:${h(ct)(s.value[l].color)};gap:2px`)
            }, [
              e.value.style.chart.layout.labels.captions.showSerieName ? (r(), i("span", Et, S(e.value.style.chart.layout.labels.captions.serieNameAbbreviation ? h(vt)({ source: s.value[l].name, length: e.value.style.chart.layout.labels.captions.serieNameMaxAbbreviationSize }) : s.value[l].name) + ": ", 1)) : f("", !0),
              e.value.style.chart.layout.labels.captions.showPercentage ? (r(), i("span", Wt, S(h(x)({ v: s.value[l].proportion, s: "%", r: e.value.style.chart.layout.labels.captions.roundingPercentage })), 1)) : f("", !0),
              e.value.style.chart.layout.labels.captions.showPercentage && e.value.style.chart.layout.labels.captions.showValue ? (r(), i("span", qt, " (" + S(h(U)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                s.value[l].value,
                h(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: s.value[l].value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.captions.roundingValue
                }),
                { datapoint: s.value[l], position: a }
              )) + ") ", 1)) : f("", !0),
              !e.value.style.chart.layout.labels.captions.showPercentage && e.value.style.chart.layout.labels.captions.showValue ? (r(), i("span", Ht, S(h(U)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                s.value[l].value,
                h(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: s.value[l].value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.captions.roundingValue
                }),
                { datapoint: s.value[l], position: a }
              )), 1)) : f("", !0)
            ], 4)
          ], 8, jt)) : f("", !0)
        ], 64))), 256)),
        (r(!0), i(T, null, R(q.value, (a, l) => (r(), i("rect", {
          onMouseover: (u) => qe(l),
          onMouseleave: o[0] || (o[0] = (u) => {
            ee.value = !1, B.value = null;
          }),
          x: a.x + e.value.style.chart.layout.grid.spaceBetween / 2,
          y: a.y + e.value.style.chart.layout.grid.spaceBetween / 2,
          height: K.value <= 0 ? 1e-4 : K.value,
          width: E.value <= 0 ? 1e-4 : E.value,
          fill: "transparent",
          stroke: "none"
        }, null, 40, Xt))), 256)),
        g(t.$slots, "svg", { svg: L.value }, void 0, !0)
      ], 14, At)) : f("", !0),
      t.$slots.watermark ? (r(), i("div", Yt, [
        g(t.$slots, "watermark", D(G({ isPrinting: h(fe) || h(ge) })), void 0, !0)
      ])) : f("", !0),
      X.value ? f("", !0) : (r(), N($t, {
        key: 5,
        config: {
          type: "waffle",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            waffle: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      k("div", {
        ref_key: "chartLegend",
        ref: ie
      }, [
        e.value.style.chart.legend.show ? (r(), N(_t, {
          key: `legend_${he.value}`,
          legendSet: M.value,
          config: We.value,
          onClickMarker: o[1] || (o[1] = ({ legend: a }) => Ie(a.uid))
        }, {
          item: m(({ legend: a }) => [
            k("div", {
              onClick: (l) => a.segregate(),
              style: Z(`opacity:${p.value.includes(a.uid) ? 0.5 : 1}`)
            }, [
              Fe(S(a.name) + ": " + S(h(U)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                a.value,
                h(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: a.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue,
                  isAnimating: F.value
                }),
                { datapoint: a }
              )) + " ", 1),
              p.value.includes(a.uid) ? (r(), i("span", Qt, " ( - % ) ")) : (r(), i("span", Jt, " (" + S(isNaN(a.value / _.value) ? "-" : h(x)({ v: a.value / _.value * 100, s: "%", r: e.value.style.chart.legend.roundingPercentage, isAnimating: F.value })) + ") ", 1))
            ], 12, Kt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : g(t.$slots, "legend", {
          key: 1,
          legend: M.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (r(), i("div", {
        key: 6,
        ref_key: "source",
        ref: ce,
        dir: "auto"
      }, [
        g(t.$slots, "source", {}, void 0, !0)
      ], 512)) : f("", !0),
      ze(xt, {
        show: I.value.showTooltip && ee.value && p.value.length < b.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: V.value,
        content: te.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function",
        fontSize: e.value.style.chart.tooltip.fontSize
      }, {
        "tooltip-before": m(() => [
          g(t.$slots, "tooltip-before", D(G({ ...ae.value })), void 0, !0)
        ]),
        "tooltip-after": m(() => [
          g(t.$slots, "tooltip-after", D(G({ ...ae.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "fontSize"]),
      X.value ? (r(), N(It, {
        key: 7,
        hideDetails: "",
        config: {
          open: I.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (r(), N(Ct, {
            key: `table_${de.value}`,
            colNames: J.value.colNames,
            head: J.value.head,
            body: J.value.body,
            config: J.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[2] || (o[2] = (a) => I.value.showTable = !1)
          }, {
            th: m(({ th: a }) => [
              k("div", {
                innerHTML: a,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Zt)
            ]),
            td: m(({ td: a }) => [
              Fe(S(a.name || a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : f("", !0)
    ], 14, Lt));
  }
}, ya = /* @__PURE__ */ Pt(ea, [["__scopeId", "data-v-89a6ba4c"]]);
export {
  ya as default
};
