import { computed as k, ref as n, watch as G, onMounted as ae, onBeforeUnmount as le, openBlock as s, createElementBlock as h, normalizeStyle as E, createBlock as w, createCommentVNode as d, unref as r, createSlots as oe, withCtx as b, renderSlot as f, normalizeProps as I, guardReactiveProps as P, normalizeClass as R, createVNode as ne, Fragment as se, renderList as re, toDisplayString as ue } from "vue";
import { u as ie, c as ce, t as ve, o as he, e as de, w as j, X as fe, i as ye, v as D, f as me } from "./index-Bya_q1J-.js";
import { _ as pe } from "./Title-C5pIfQAz.js";
import { u as ge, U as ke } from "./usePrinter-CiHd1FwD.js";
import { t as we, u as be } from "./useResponsive-BY8tgM1n.js";
import Ce from "./vue-ui-skeleton-BYssP0K4.js";
import { u as Y } from "./useNestedProp-B33hazbH.js";
import { _ as _e } from "./PackageVersion-VkaUzgmt.js";
import { P as $e } from "./PenAndPaper-DAZYA8Ew.js";
import { _ as Ae } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ie = ["id"], Pe = ["xmlns", "viewBox"], xe = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-linecap"], Fe = ["cx", "cy", "r", "stroke", "stroke-width"], Oe = ["x", "y", "font-size", "fill", "font-weight"], ze = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Se = {
  __name: "vue-ui-wheel",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(H, { expose: W }) {
    const c = H, { vue_ui_wheel: q } = ie(), C = k(() => !!c.dataset && Object.keys(c.dataset).length), _ = n(ce()), J = n(null), x = n(0), y = n(null), F = n(null), O = n(null), z = n(0), e = k({
      get: () => S(),
      set: (t) => t
    });
    function S() {
      const t = Y({
        userConfig: c.config,
        defaultConfig: q
      });
      return t.theme ? {
        ...Y({
          userConfig: ve.vue_ui_wheel[t.theme] || c.config,
          defaultConfig: t
        })
      } : t;
    }
    G(() => c.config, (t) => {
      e.value = S(), X(), z.value += 1;
    }, { deep: !0 });
    const { isPrinting: M, isImaging: N, generatePdf: L, generateImage: T } = ge({
      elementId: _.value,
      fileName: e.value.style.chart.title.text || "vue-ui-wheel"
    }), l = n({
      size: 360,
      height: 360,
      width: 360
    }), $ = n(e.value.style.chart.layout.percentage.fontSize), i = k(() => ({
      radius: Math.min(l.value.width, l.value.height) * 0.9 / 2,
      centerX: l.value.width / 2,
      centerY: l.value.height / 2
    }));
    function U(t, v = 1) {
      return {
        x: i.value.centerX + i.value.radius * Math.cos(29.85 + t * Math.PI / 180) * v,
        y: i.value.centerY + i.value.radius * Math.sin(29.85 + t * Math.PI / 180) * v
      };
    }
    const o = n(e.value.style.chart.animation.use ? 0 : c.dataset.percentage || 0);
    G(() => c.dataset, (t) => {
      e.value.style.chart.animation.use ? B(t.percentage) : o.value = t.percentage || 0;
    }, { deep: !0 });
    const m = n(null);
    ae(() => {
      X();
    });
    function X() {
      if (he(c.dataset) && de({
        componentName: "VueUiWheel",
        type: "dataset"
      }), B(c.dataset.percentage || 0), e.value.responsive) {
        const t = we(() => {
          const { width: v, height: a } = be({
            chart: y.value,
            title: e.value.style.chart.title.text ? F.value : null,
            source: O.value
          });
          l.value.width = v, l.value.height = a, $.value = e.value.style.chart.layout.percentage.fontSize / 360 * Math.min(v, a);
        });
        m.value = new ResizeObserver(t), m.value.observe(y.value.parentNode);
      }
    }
    le(() => {
      m.value && m.value.disconnect();
    });
    function B(t) {
      let v = e.value.style.chart.animation.speed;
      const a = Math.abs(t - o.value) / (v * 120);
      function u() {
        o.value < t ? o.value = Math.min(o.value + a, t) : o.value > t && (o.value = Math.max(o.value - a, t)), o.value !== t && requestAnimationFrame(u);
      }
      u();
    }
    const K = k(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const u = o.value > a ? e.value.style.chart.layout.wheel.ticks.activeColor : e.value.style.chart.layout.wheel.ticks.inactiveColor, { x: Z, y: V } = U(l.value.size / 100 * a), { x: ee, y: te } = U(l.value.size / 100 * a, e.value.style.chart.layout.wheel.ticks.sizeRatio);
        t.push({
          x1: Z,
          y1: V,
          x2: ee,
          y2: te,
          color: e.value.style.chart.layout.wheel.ticks.gradient.show ? j(u, a / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : u
        });
      }
      return t;
    }), p = n(!1);
    function Q(t) {
      p.value = t, x.value += 1;
    }
    const g = n(!1);
    function A() {
      g.value = !g.value;
    }
    return W({
      generatePdf: L,
      generateImage: T,
      toggleAnnotator: A
    }), (t, v) => (s(), h("div", {
      class: "vue-ui-wheel",
      ref_key: "wheelChart",
      ref: y,
      id: _.value,
      style: E(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.userOptions.buttons.annotator ? (s(), w($e, {
        key: 0,
        parent: y.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: g.value,
        onClose: A
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : d("", !0),
      e.value.style.chart.title.text ? (s(), h("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: F,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (s(), w(pe, {
          key: `title_${z.value}`,
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : d("", !0),
      e.value.userOptions.show && C.value ? (s(), w(ke, {
        ref_key: "details",
        ref: J,
        key: `user_options_${x.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(M),
        isImaging: r(N),
        uid: _.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: p.value,
        position: e.value.userOptions.position,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: g.value,
        chartElement: y.value,
        onToggleFullscreen: Q,
        onGeneratePdf: r(L),
        onGenerateImage: r(T),
        onToggleAnnotator: A
      }, oe({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: b(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: b(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: b(({ toggleFullscreen: a, isFullscreen: u }) => [
            f(t.$slots, "optionFullscreen", I(P({ toggleFullscreen: a, isFullscreen: u })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: b(({ toggleAnnotator: a, isAnnotator: u }) => [
            f(t.$slots, "optionAnnotator", I(P({ toggleAnnotator: a, isAnnotator: u })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "position", "titles", "hasAnnotator", "isAnnotation", "chartElement", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      C.value ? (s(), h("svg", {
        key: 3,
        xmlns: r(fe),
        class: R({ "vue-data-ui-fullscreen--on": p.value, "vue-data-ui-fulscreen--off": !p.value }),
        viewBox: `0 0 ${l.value.width <= 0 ? 10 : l.value.width} ${l.value.height <= 0 ? 10 : l.value.height}`,
        style: E(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ne(_e),
        (s(!0), h(se, null, re(K.value, (a, u) => (s(), h("line", {
          x1: a.x1,
          x2: a.x2,
          y1: a.y1,
          y2: a.y2,
          stroke: a.color,
          "stroke-width": 5 / 360 * Math.min(l.value.width, l.value.height),
          "stroke-linecap": e.value.style.chart.layout.wheel.ticks.rounded ? "round" : "butt",
          class: R({ "vue-ui-tick-animated": e.value.style.chart.animation.use && u <= o.value })
        }, null, 10, xe))), 256)),
        e.value.style.chart.layout.innerCircle.show ? (s(), h("circle", {
          key: 0,
          cx: i.value.centerX,
          cy: i.value.centerY,
          r: i.value.radius * 0.8 <= 0 ? 1e-4 : i.value.radius * 0.8,
          stroke: e.value.style.chart.layout.innerCircle.stroke,
          "stroke-width": e.value.style.chart.layout.innerCircle.strokeWidth,
          fill: "none"
        }, null, 8, Fe)) : d("", !0),
        e.value.style.chart.layout.percentage.show ? (s(), h("text", {
          key: 1,
          x: i.value.centerX,
          y: i.value.centerY + $.value / 3,
          "font-size": $.value,
          fill: e.value.style.chart.layout.wheel.ticks.gradient.show ? r(j)(e.value.style.chart.layout.wheel.ticks.activeColor, o.value / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.wheel.ticks.activeColor,
          "text-anchor": "middle",
          "font-weight": e.value.style.chart.layout.percentage.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabluar-nums" }
        }, ue(r(ye)(
          e.value.style.chart.layout.percentage.formatter,
          r(D)(o.value),
          r(me)({
            v: r(D)(o.value),
            s: "%",
            r: e.value.style.chart.layout.percentage.rounding
          })
        )), 9, Oe)) : d("", !0),
        f(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, Pe)) : d("", !0),
      t.$slots.watermark ? (s(), h("div", ze, [
        f(t.$slots, "watermark", I(P({ isPrinting: r(M) || r(N) })), void 0, !0)
      ])) : d("", !0),
      t.$slots.source ? (s(), h("div", {
        key: 5,
        ref_key: "source",
        ref: O,
        dir: "auto"
      }, [
        f(t.$slots, "source", {}, void 0, !0)
      ], 512)) : d("", !0),
      C.value ? d("", !0) : (s(), w(Ce, {
        key: 6,
        config: {
          type: "wheel",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            wheel: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Ie));
  }
}, je = /* @__PURE__ */ Ae(Se, [["__scopeId", "data-v-d5ffc7dc"]]);
export {
  je as default
};
